#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 629
#define LARGE_STATE_COUNT 2
#define SYMBOL_COUNT 337
#define ALIAS_COUNT 0
#define TOKEN_COUNT 175
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 50
#define MAX_ALIAS_SEQUENCE_LENGTH 7
#define PRODUCTION_ID_COUNT 130

enum ts_symbol_identifiers {
  sym_identifier = 1,
  anon_sym_module = 2,
  anon_sym_version = 3,
  anon_sym_is = 4,
  anon_sym_end = 5,
  anon_sym_import = 6,
  anon_sym_LBRACK = 7,
  anon_sym_RBRACK = 8,
  anon_sym_from = 9,
  anon_sym_COLON_COLON = 10,
  anon_sym_COLON_COLON2 = 11,
  anon_sym_as = 12,
  anon_sym_COLON = 13,
  anon_sym_AT = 14,
  anon_sym_EQ = 15,
  anon_sym_assert = 16,
  sym_controlled_language_tag = 17,
  anon_sym_LPAREN = 18,
  anon_sym_RPAREN = 19,
  anon_sym_COMMA = 20,
  sym_reserved_self = 21,
  anon_sym_with = 22,
  anon_sym_def = 23,
  anon_sym_LBRACE = 24,
  anon_sym_RBRACE = 25,
  anon_sym_Thing = 26,
  anon_sym_Nothing = 27,
  anon_sym_real = 28,
  anon_sym_rational = 29,
  anon_sym_anyURI = 30,
  anon_sym_iri = 31,
  anon_sym_base64Binary = 32,
  anon_sym_boolean = 33,
  anon_sym_date = 34,
  anon_sym_dateTime = 35,
  anon_sym_decimal = 36,
  anon_sym_double = 37,
  anon_sym_duration = 38,
  anon_sym_float = 39,
  anon_sym_gDay = 40,
  anon_sym_gMonth = 41,
  anon_sym_gMonthDay = 42,
  anon_sym_gYearMonth = 43,
  anon_sym_gYear = 44,
  anon_sym_hexBinary = 45,
  anon_sym_binary = 46,
  anon_sym_string = 47,
  anon_sym_time = 48,
  anon_sym_dateTimeStamp = 49,
  anon_sym_dayTimeDuration = 50,
  anon_sym_yearMonthDuration = 51,
  anon_sym_integer = 52,
  anon_sym_long = 53,
  anon_sym_int = 54,
  anon_sym_short = 55,
  anon_sym_byte = 56,
  anon_sym_nonNegativeInteger = 57,
  anon_sym_positiveInteger = 58,
  anon_sym_unsignedLong = 59,
  anon_sym_unsignedInt = 60,
  anon_sym_unsigned = 61,
  anon_sym_unsignedShort = 62,
  anon_sym_unsignedByte = 63,
  anon_sym_nonPositiveInteger = 64,
  anon_sym_negativeInteger = 65,
  anon_sym_normalizedString = 66,
  anon_sym_token = 67,
  anon_sym_language = 68,
  sym_quoted_string = 69,
  sym_language_tag = 70,
  anon_sym_LT = 71,
  aux_sym_iri_token1 = 72,
  anon_sym_GT = 73,
  anon_sym_POUND_LBRACK = 74,
  sym_hex_byte = 75,
  sym_double = 76,
  sym_decimal = 77,
  sym_integer = 78,
  sym_rational = 79,
  sym_unsigned = 80,
  anon_sym_true = 81,
  anon_sym_u22a4 = 82,
  anon_sym_false = 83,
  anon_sym_u22a5 = 84,
  anon_sym_datatype = 85,
  sym_opaque = 86,
  anon_sym_length = 87,
  anon_sym_maxLength = 88,
  anon_sym_minLength = 89,
  anon_sym_fractionDigits = 90,
  anon_sym_totalDigits = 91,
  anon_sym_maxExclusive = 92,
  anon_sym_maxInclusive = 93,
  anon_sym_minExclusive = 94,
  anon_sym_minInclusive = 95,
  anon_sym_explicitTimezone = 96,
  anon_sym_required = 97,
  anon_sym_prohibited = 98,
  anon_sym_optional = 99,
  anon_sym_pattern = 100,
  sym_kw_is_fixed = 101,
  anon_sym_dimension = 102,
  anon_sym_source = 103,
  anon_sym_parent = 104,
  anon_sym_entity = 105,
  anon_sym_enum = 106,
  anon_sym_of = 107,
  anon_sym_event = 108,
  anon_sym_property = 109,
  anon_sym_structure = 110,
  anon_sym_union = 111,
  anon_sym_rdf = 112,
  anon_sym_a = 113,
  anon_sym_type = 114,
  anon_sym_class = 115,
  sym_wildcard = 116,
  anon_sym_identity = 117,
  anon_sym_ref = 118,
  sym_unknown_type = 119,
  anon_sym_ordered = 120,
  anon_sym_unordered = 121,
  anon_sym_unique = 122,
  anon_sym_nonunique = 123,
  anon_sym_DOT_DOT = 124,
  anon_sym_SLASH_EQ = 125,
  anon_sym_u2260 = 126,
  sym_op_less_than = 127,
  sym_op_greater_than = 128,
  anon_sym_LT_EQ = 129,
  anon_sym_u2264 = 130,
  anon_sym_GT_EQ = 131,
  anon_sym_u2265 = 132,
  anon_sym_not = 133,
  anon_sym_u00ac = 134,
  anon_sym_and = 135,
  anon_sym_u2227 = 136,
  anon_sym_or = 137,
  anon_sym_u2228 = 138,
  anon_sym_xor = 139,
  anon_sym_u22bb = 140,
  anon_sym_implies = 141,
  anon_sym_EQ_EQ_GT = 142,
  anon_sym_u21d2 = 143,
  anon_sym_iff = 144,
  anon_sym_LT_EQ_EQ_GT = 145,
  anon_sym_u21d4 = 146,
  anon_sym_forall = 147,
  anon_sym_u2200 = 148,
  anon_sym_exists = 149,
  anon_sym_u2203 = 150,
  anon_sym_u222a = 151,
  anon_sym_intersection = 152,
  anon_sym_u2229 = 153,
  anon_sym_subset = 154,
  anon_sym_u2282 = 155,
  anon_sym_subseteq = 156,
  anon_sym_u2286 = 157,
  anon_sym_complement = 158,
  anon_sym_u2216 = 159,
  anon_sym_in = 160,
  anon_sym_u2208 = 161,
  sym_set_op_builder = 162,
  anon_sym_u00b7 = 163,
  anon_sym_DOT = 164,
  anon_sym_COLON_EQ = 165,
  anon_sym_u2254 = 166,
  anon_sym_u2192 = 167,
  anon_sym_DASH_GT = 168,
  anon_sym_u2190 = 169,
  anon_sym_LT_DASH = 170,
  anon_sym_PLUS = 171,
  anon_sym_u2295 = 172,
  sym__value_empty_sequence = 173,
  sym_line_comment = 174,
  sym_module = 175,
  sym__module_locations = 176,
  sym_module_body = 177,
  sym_import_statement = 178,
  sym_from_clause = 179,
  sym_module_path_root_only = 180,
  sym_module_path_absolute = 181,
  sym_module_path_relative = 182,
  sym__import = 183,
  sym__rename_import = 184,
  sym_member_import = 185,
  sym_module_import = 186,
  sym_qualified_identifier = 187,
  sym_identifier_reference = 188,
  sym_annotation = 189,
  sym_annotation_property = 190,
  sym_constraint = 191,
  sym_informal_constraint = 192,
  sym_formal_constraint = 193,
  sym_constraint_sentence = 194,
  sym_simple_sentence = 195,
  sym_atomic_sentence = 196,
  sym__actual_arguments = 197,
  sym_equation = 198,
  sym_inequation = 199,
  sym_boolean_sentence = 200,
  sym_unary_boolean_sentence = 201,
  sym_binary_boolean_sentence = 202,
  sym__logical_connective = 203,
  sym_quantified_sentence = 204,
  sym_quantified_variable_binding = 205,
  sym_quantified_variable = 206,
  sym_variable = 207,
  sym_term = 208,
  sym_functional_term = 209,
  sym_function_composition = 210,
  sym_predicate_value = 211,
  sym_sequence_of_predicate_values = 212,
  sym_constraint_environment = 213,
  sym_function_def = 214,
  sym_function_signature = 215,
  sym_function_parameter = 216,
  sym__function_type = 217,
  sym_function_cardinality_expression = 218,
  sym_function_type_reference = 219,
  sym_function_body = 220,
  sym_sequence_builder = 221,
  sym_sequence_builder_body = 222,
  sym_value = 223,
  sym_sequence_of_values = 224,
  sym__sequence_value_constraints = 225,
  sym_value_constructor = 226,
  sym_mapping_value = 227,
  sym_builtin_simple_type = 228,
  sym__owl_builtin_types = 229,
  sym__builtin_primitive_datatypes = 230,
  sym__derived_date_datetypes = 231,
  sym__derived_numeric_datatypes = 232,
  sym__derived_string_datatypes = 233,
  sym_simple_value = 234,
  sym_string = 235,
  sym_iri = 236,
  sym_binary = 237,
  sym_boolean = 238,
  sym_boolean_truth = 239,
  sym_boolean_falsity = 240,
  sym_definition = 241,
  sym_data_type_def = 242,
  sym__datatype_base = 243,
  sym_datatype_def_restriction = 244,
  sym__restriction_facet = 245,
  sym_length_restriction_facet = 246,
  sym_digit_restriction_facet = 247,
  sym_value_restriction_facet = 248,
  sym_restriction_value = 249,
  sym_tz_restriction_facet = 250,
  sym_tz_restriction_value = 251,
  sym_pattern_restriction_facet = 252,
  sym_annotation_only_body = 253,
  sym_dimension_def = 254,
  sym_dimension_body = 255,
  sym_source_entity = 256,
  sym__identifier_or_sequence = 257,
  sym_from_definition_clause = 258,
  sym__wildcard_or_identifier_or_sequence = 259,
  sym_dimension_parent = 260,
  sym_entity_def = 261,
  sym_entity_body = 262,
  sym_enum_def = 263,
  sym_enum_body = 264,
  sym_event_def = 265,
  sym_event_body = 266,
  sym_property_def = 267,
  sym_structure_def = 268,
  sym_structure_body = 269,
  sym_union_def = 270,
  sym_union_body = 271,
  sym_rdf_def = 272,
  sym_rdf_types = 273,
  sym_type_class_def = 274,
  sym_type_variable = 275,
  sym_type_variable_restriction = 276,
  sym_type_class_reference = 277,
  sym_type_class_arguments = 278,
  sym_type_class_body = 279,
  sym_method_def = 280,
  sym_entity_identity = 281,
  sym_member = 282,
  sym_member_def = 283,
  sym_property_ref = 284,
  sym__type_expression_to = 285,
  sym_type_reference = 286,
  sym_mapping_type = 287,
  sym_cardinality_expression = 288,
  sym__cardinality_inner = 289,
  sym_sequence_ordering = 290,
  sym_sequence_uniqueness = 291,
  sym_cardinality_range = 292,
  sym_value_variant = 293,
  sym_type_variant = 294,
  sym_op_inequality = 295,
  sym_op_less_than_or_equal = 296,
  sym_op_greater_than_or_equal = 297,
  sym_logical_op_negation = 298,
  sym_logical_op_conjunction = 299,
  sym_logical_op_disjunction = 300,
  sym_logical_op_exclusive_disjunction = 301,
  sym_logical_op_implication = 302,
  sym_logical_op_biconditional = 303,
  sym_logical_quantifier_universal = 304,
  sym_logical_quantifier_existential = 305,
  sym_set_op_membership = 306,
  sym__function_op_composition = 307,
  sym__function_op_by_definition = 308,
  sym__type_op_has_type = 309,
  sym__type_op_type_restriction = 310,
  sym_type_op_combiner = 311,
  aux_sym_module_body_repeat1 = 312,
  aux_sym_module_body_repeat2 = 313,
  aux_sym_module_body_repeat3 = 314,
  aux_sym_import_statement_repeat1 = 315,
  aux_sym_module_path_absolute_repeat1 = 316,
  aux_sym__actual_arguments_repeat1 = 317,
  aux_sym_function_composition_repeat1 = 318,
  aux_sym_sequence_of_predicate_values_repeat1 = 319,
  aux_sym_constraint_environment_repeat1 = 320,
  aux_sym_function_signature_repeat1 = 321,
  aux_sym_sequence_builder_repeat1 = 322,
  aux_sym_sequence_of_values_repeat1 = 323,
  aux_sym_binary_repeat1 = 324,
  aux_sym_datatype_def_restriction_repeat1 = 325,
  aux_sym_pattern_restriction_facet_repeat1 = 326,
  aux_sym_dimension_body_repeat1 = 327,
  aux_sym_dimension_body_repeat2 = 328,
  aux_sym__identifier_or_sequence_repeat1 = 329,
  aux_sym_enum_body_repeat1 = 330,
  aux_sym_union_body_repeat1 = 331,
  aux_sym_rdf_types_repeat1 = 332,
  aux_sym_type_class_def_repeat1 = 333,
  aux_sym_type_variable_restriction_repeat1 = 334,
  aux_sym_type_class_arguments_repeat1 = 335,
  aux_sym_type_class_body_repeat1 = 336,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_module] = "module",
  [anon_sym_version] = "version",
  [anon_sym_is] = "is",
  [anon_sym_end] = "end",
  [anon_sym_import] = "import",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_from] = "from",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_COLON_COLON2] = "::",
  [anon_sym_as] = "as",
  [anon_sym_COLON] = ":",
  [anon_sym_AT] = "@",
  [anon_sym_EQ] = "=",
  [anon_sym_assert] = "assert",
  [sym_controlled_language_tag] = "controlled_language_tag",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_COMMA] = ",",
  [sym_reserved_self] = "reserved_self",
  [anon_sym_with] = "with",
  [anon_sym_def] = "def",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_Thing] = "Thing",
  [anon_sym_Nothing] = "Nothing",
  [anon_sym_real] = "real",
  [anon_sym_rational] = "rational",
  [anon_sym_anyURI] = "anyURI",
  [anon_sym_iri] = "iri",
  [anon_sym_base64Binary] = "base64Binary",
  [anon_sym_boolean] = "boolean",
  [anon_sym_date] = "date",
  [anon_sym_dateTime] = "dateTime",
  [anon_sym_decimal] = "decimal",
  [anon_sym_double] = "double",
  [anon_sym_duration] = "duration",
  [anon_sym_float] = "float",
  [anon_sym_gDay] = "gDay",
  [anon_sym_gMonth] = "gMonth",
  [anon_sym_gMonthDay] = "gMonthDay",
  [anon_sym_gYearMonth] = "gYearMonth",
  [anon_sym_gYear] = "gYear",
  [anon_sym_hexBinary] = "hexBinary",
  [anon_sym_binary] = "binary",
  [anon_sym_string] = "string",
  [anon_sym_time] = "time",
  [anon_sym_dateTimeStamp] = "dateTimeStamp",
  [anon_sym_dayTimeDuration] = "dayTimeDuration",
  [anon_sym_yearMonthDuration] = "yearMonthDuration",
  [anon_sym_integer] = "integer",
  [anon_sym_long] = "long",
  [anon_sym_int] = "int",
  [anon_sym_short] = "short",
  [anon_sym_byte] = "byte",
  [anon_sym_nonNegativeInteger] = "nonNegativeInteger",
  [anon_sym_positiveInteger] = "positiveInteger",
  [anon_sym_unsignedLong] = "unsignedLong",
  [anon_sym_unsignedInt] = "unsignedInt",
  [anon_sym_unsigned] = "unsigned",
  [anon_sym_unsignedShort] = "unsignedShort",
  [anon_sym_unsignedByte] = "unsignedByte",
  [anon_sym_nonPositiveInteger] = "nonPositiveInteger",
  [anon_sym_negativeInteger] = "negativeInteger",
  [anon_sym_normalizedString] = "normalizedString",
  [anon_sym_token] = "token",
  [anon_sym_language] = "language",
  [sym_quoted_string] = "quoted_string",
  [sym_language_tag] = "language_tag",
  [anon_sym_LT] = "<",
  [aux_sym_iri_token1] = "iri_token1",
  [anon_sym_GT] = ">",
  [anon_sym_POUND_LBRACK] = "#[",
  [sym_hex_byte] = "hex_byte",
  [sym_double] = "double",
  [sym_decimal] = "decimal",
  [sym_integer] = "integer",
  [sym_rational] = "rational",
  [sym_unsigned] = "unsigned",
  [anon_sym_true] = "true",
  [anon_sym_u22a4] = "\u22a4",
  [anon_sym_false] = "false",
  [anon_sym_u22a5] = "\u22a5",
  [anon_sym_datatype] = "datatype",
  [sym_opaque] = "opaque",
  [anon_sym_length] = "length",
  [anon_sym_maxLength] = "maxLength",
  [anon_sym_minLength] = "minLength",
  [anon_sym_fractionDigits] = "fractionDigits",
  [anon_sym_totalDigits] = "totalDigits",
  [anon_sym_maxExclusive] = "maxExclusive",
  [anon_sym_maxInclusive] = "maxInclusive",
  [anon_sym_minExclusive] = "minExclusive",
  [anon_sym_minInclusive] = "minInclusive",
  [anon_sym_explicitTimezone] = "explicitTimezone",
  [anon_sym_required] = "required",
  [anon_sym_prohibited] = "prohibited",
  [anon_sym_optional] = "optional",
  [anon_sym_pattern] = "pattern",
  [sym_kw_is_fixed] = "kw_is_fixed",
  [anon_sym_dimension] = "dimension",
  [anon_sym_source] = "source",
  [anon_sym_parent] = "parent",
  [anon_sym_entity] = "entity",
  [anon_sym_enum] = "enum",
  [anon_sym_of] = "of",
  [anon_sym_event] = "event",
  [anon_sym_property] = "property",
  [anon_sym_structure] = "structure",
  [anon_sym_union] = "union",
  [anon_sym_rdf] = "rdf",
  [anon_sym_a] = "a",
  [anon_sym_type] = "type",
  [anon_sym_class] = "class",
  [sym_wildcard] = "wildcard",
  [anon_sym_identity] = "identity",
  [anon_sym_ref] = "ref",
  [sym_unknown_type] = "unknown_type",
  [anon_sym_ordered] = "ordered",
  [anon_sym_unordered] = "unordered",
  [anon_sym_unique] = "unique",
  [anon_sym_nonunique] = "nonunique",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_u2260] = "\u2260",
  [sym_op_less_than] = "op_less_than",
  [sym_op_greater_than] = "op_greater_than",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_u2264] = "\u2264",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_u2265] = "\u2265",
  [anon_sym_not] = "not",
  [anon_sym_u00ac] = "\u00ac",
  [anon_sym_and] = "and",
  [anon_sym_u2227] = "\u2227",
  [anon_sym_or] = "or",
  [anon_sym_u2228] = "\u2228",
  [anon_sym_xor] = "xor",
  [anon_sym_u22bb] = "\u22bb",
  [anon_sym_implies] = "implies",
  [anon_sym_EQ_EQ_GT] = "==>",
  [anon_sym_u21d2] = "\u21d2",
  [anon_sym_iff] = "iff",
  [anon_sym_LT_EQ_EQ_GT] = "<==>",
  [anon_sym_u21d4] = "\u21d4",
  [anon_sym_forall] = "forall",
  [anon_sym_u2200] = "\u2200",
  [anon_sym_exists] = "exists",
  [anon_sym_u2203] = "\u2203",
  [anon_sym_u222a] = "\u222a",
  [anon_sym_intersection] = "intersection",
  [anon_sym_u2229] = "\u2229",
  [anon_sym_subset] = "subset",
  [anon_sym_u2282] = "\u2282",
  [anon_sym_subseteq] = "subseteq",
  [anon_sym_u2286] = "\u2286",
  [anon_sym_complement] = "complement",
  [anon_sym_u2216] = "\u2216",
  [anon_sym_in] = "in",
  [anon_sym_u2208] = "\u2208",
  [sym_set_op_builder] = "set_op_builder",
  [anon_sym_u00b7] = "\u00b7",
  [anon_sym_DOT] = ".",
  [anon_sym_COLON_EQ] = ":=",
  [anon_sym_u2254] = "\u2254",
  [anon_sym_u2192] = "\u2192",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_u2190] = "\u2190",
  [anon_sym_LT_DASH] = "<-",
  [anon_sym_PLUS] = "+",
  [anon_sym_u2295] = "\u2295",
  [sym__value_empty_sequence] = "_value_empty_sequence",
  [sym_line_comment] = "line_comment",
  [sym_module] = "module",
  [sym__module_locations] = "_module_locations",
  [sym_module_body] = "module_body",
  [sym_import_statement] = "import_statement",
  [sym_from_clause] = "from_clause",
  [sym_module_path_root_only] = "module_path_root_only",
  [sym_module_path_absolute] = "module_path_absolute",
  [sym_module_path_relative] = "module_path_relative",
  [sym__import] = "_import",
  [sym__rename_import] = "_rename_import",
  [sym_member_import] = "member_import",
  [sym_module_import] = "module_import",
  [sym_qualified_identifier] = "qualified_identifier",
  [sym_identifier_reference] = "identifier_reference",
  [sym_annotation] = "annotation",
  [sym_annotation_property] = "annotation_property",
  [sym_constraint] = "constraint",
  [sym_informal_constraint] = "informal_constraint",
  [sym_formal_constraint] = "formal_constraint",
  [sym_constraint_sentence] = "constraint_sentence",
  [sym_simple_sentence] = "simple_sentence",
  [sym_atomic_sentence] = "atomic_sentence",
  [sym__actual_arguments] = "_actual_arguments",
  [sym_equation] = "equation",
  [sym_inequation] = "inequation",
  [sym_boolean_sentence] = "boolean_sentence",
  [sym_unary_boolean_sentence] = "unary_boolean_sentence",
  [sym_binary_boolean_sentence] = "binary_boolean_sentence",
  [sym__logical_connective] = "_logical_connective",
  [sym_quantified_sentence] = "quantified_sentence",
  [sym_quantified_variable_binding] = "quantified_variable_binding",
  [sym_quantified_variable] = "quantified_variable",
  [sym_variable] = "variable",
  [sym_term] = "term",
  [sym_functional_term] = "functional_term",
  [sym_function_composition] = "function_composition",
  [sym_predicate_value] = "predicate_value",
  [sym_sequence_of_predicate_values] = "sequence_of_predicate_values",
  [sym_constraint_environment] = "constraint_environment",
  [sym_function_def] = "function_def",
  [sym_function_signature] = "function_signature",
  [sym_function_parameter] = "function_parameter",
  [sym__function_type] = "_function_type",
  [sym_function_cardinality_expression] = "function_cardinality_expression",
  [sym_function_type_reference] = "function_type_reference",
  [sym_function_body] = "function_body",
  [sym_sequence_builder] = "sequence_builder",
  [sym_sequence_builder_body] = "sequence_builder_body",
  [sym_value] = "value",
  [sym_sequence_of_values] = "sequence_of_values",
  [sym__sequence_value_constraints] = "_sequence_value_constraints",
  [sym_value_constructor] = "value_constructor",
  [sym_mapping_value] = "mapping_value",
  [sym_builtin_simple_type] = "builtin_simple_type",
  [sym__owl_builtin_types] = "_owl_builtin_types",
  [sym__builtin_primitive_datatypes] = "_builtin_primitive_datatypes",
  [sym__derived_date_datetypes] = "_derived_date_datetypes",
  [sym__derived_numeric_datatypes] = "_derived_numeric_datatypes",
  [sym__derived_string_datatypes] = "_derived_string_datatypes",
  [sym_simple_value] = "simple_value",
  [sym_string] = "string",
  [sym_iri] = "iri",
  [sym_binary] = "binary",
  [sym_boolean] = "boolean",
  [sym_boolean_truth] = "boolean_truth",
  [sym_boolean_falsity] = "boolean_falsity",
  [sym_definition] = "definition",
  [sym_data_type_def] = "data_type_def",
  [sym__datatype_base] = "_datatype_base",
  [sym_datatype_def_restriction] = "datatype_def_restriction",
  [sym__restriction_facet] = "_restriction_facet",
  [sym_length_restriction_facet] = "length_restriction_facet",
  [sym_digit_restriction_facet] = "digit_restriction_facet",
  [sym_value_restriction_facet] = "value_restriction_facet",
  [sym_restriction_value] = "restriction_value",
  [sym_tz_restriction_facet] = "tz_restriction_facet",
  [sym_tz_restriction_value] = "tz_restriction_value",
  [sym_pattern_restriction_facet] = "pattern_restriction_facet",
  [sym_annotation_only_body] = "annotation_only_body",
  [sym_dimension_def] = "dimension_def",
  [sym_dimension_body] = "dimension_body",
  [sym_source_entity] = "source_entity",
  [sym__identifier_or_sequence] = "_identifier_or_sequence",
  [sym_from_definition_clause] = "from_definition_clause",
  [sym__wildcard_or_identifier_or_sequence] = "_wildcard_or_identifier_or_sequence",
  [sym_dimension_parent] = "dimension_parent",
  [sym_entity_def] = "entity_def",
  [sym_entity_body] = "entity_body",
  [sym_enum_def] = "enum_def",
  [sym_enum_body] = "enum_body",
  [sym_event_def] = "event_def",
  [sym_event_body] = "event_body",
  [sym_property_def] = "property_def",
  [sym_structure_def] = "structure_def",
  [sym_structure_body] = "structure_body",
  [sym_union_def] = "union_def",
  [sym_union_body] = "union_body",
  [sym_rdf_def] = "rdf_def",
  [sym_rdf_types] = "rdf_types",
  [sym_type_class_def] = "type_class_def",
  [sym_type_variable] = "type_variable",
  [sym_type_variable_restriction] = "type_variable_restriction",
  [sym_type_class_reference] = "type_class_reference",
  [sym_type_class_arguments] = "type_class_arguments",
  [sym_type_class_body] = "type_class_body",
  [sym_method_def] = "method_def",
  [sym_entity_identity] = "entity_identity",
  [sym_member] = "member",
  [sym_member_def] = "member_def",
  [sym_property_ref] = "property_ref",
  [sym__type_expression_to] = "_type_expression_to",
  [sym_type_reference] = "type_reference",
  [sym_mapping_type] = "mapping_type",
  [sym_cardinality_expression] = "cardinality_expression",
  [sym__cardinality_inner] = "_cardinality_inner",
  [sym_sequence_ordering] = "sequence_ordering",
  [sym_sequence_uniqueness] = "sequence_uniqueness",
  [sym_cardinality_range] = "cardinality_range",
  [sym_value_variant] = "value_variant",
  [sym_type_variant] = "type_variant",
  [sym_op_inequality] = "op_inequality",
  [sym_op_less_than_or_equal] = "op_less_than_or_equal",
  [sym_op_greater_than_or_equal] = "op_greater_than_or_equal",
  [sym_logical_op_negation] = "logical_op_negation",
  [sym_logical_op_conjunction] = "logical_op_conjunction",
  [sym_logical_op_disjunction] = "logical_op_disjunction",
  [sym_logical_op_exclusive_disjunction] = "logical_op_exclusive_disjunction",
  [sym_logical_op_implication] = "logical_op_implication",
  [sym_logical_op_biconditional] = "logical_op_biconditional",
  [sym_logical_quantifier_universal] = "logical_quantifier_universal",
  [sym_logical_quantifier_existential] = "logical_quantifier_existential",
  [sym_set_op_membership] = "set_op_membership",
  [sym__function_op_composition] = "_function_op_composition",
  [sym__function_op_by_definition] = "_function_op_by_definition",
  [sym__type_op_has_type] = "_type_op_has_type",
  [sym__type_op_type_restriction] = "_type_op_type_restriction",
  [sym_type_op_combiner] = "type_op_combiner",
  [aux_sym_module_body_repeat1] = "module_body_repeat1",
  [aux_sym_module_body_repeat2] = "module_body_repeat2",
  [aux_sym_module_body_repeat3] = "module_body_repeat3",
  [aux_sym_import_statement_repeat1] = "import_statement_repeat1",
  [aux_sym_module_path_absolute_repeat1] = "module_path_absolute_repeat1",
  [aux_sym__actual_arguments_repeat1] = "_actual_arguments_repeat1",
  [aux_sym_function_composition_repeat1] = "function_composition_repeat1",
  [aux_sym_sequence_of_predicate_values_repeat1] = "sequence_of_predicate_values_repeat1",
  [aux_sym_constraint_environment_repeat1] = "constraint_environment_repeat1",
  [aux_sym_function_signature_repeat1] = "function_signature_repeat1",
  [aux_sym_sequence_builder_repeat1] = "sequence_builder_repeat1",
  [aux_sym_sequence_of_values_repeat1] = "sequence_of_values_repeat1",
  [aux_sym_binary_repeat1] = "binary_repeat1",
  [aux_sym_datatype_def_restriction_repeat1] = "datatype_def_restriction_repeat1",
  [aux_sym_pattern_restriction_facet_repeat1] = "pattern_restriction_facet_repeat1",
  [aux_sym_dimension_body_repeat1] = "dimension_body_repeat1",
  [aux_sym_dimension_body_repeat2] = "dimension_body_repeat2",
  [aux_sym__identifier_or_sequence_repeat1] = "_identifier_or_sequence_repeat1",
  [aux_sym_enum_body_repeat1] = "enum_body_repeat1",
  [aux_sym_union_body_repeat1] = "union_body_repeat1",
  [aux_sym_rdf_types_repeat1] = "rdf_types_repeat1",
  [aux_sym_type_class_def_repeat1] = "type_class_def_repeat1",
  [aux_sym_type_variable_restriction_repeat1] = "type_variable_restriction_repeat1",
  [aux_sym_type_class_arguments_repeat1] = "type_class_arguments_repeat1",
  [aux_sym_type_class_body_repeat1] = "type_class_body_repeat1",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_version] = anon_sym_version,
  [anon_sym_is] = anon_sym_is,
  [anon_sym_end] = anon_sym_end,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_from] = anon_sym_from,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_COLON_COLON2] = anon_sym_COLON_COLON,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_assert] = anon_sym_assert,
  [sym_controlled_language_tag] = sym_controlled_language_tag,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [sym_reserved_self] = sym_reserved_self,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_def] = anon_sym_def,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_Thing] = anon_sym_Thing,
  [anon_sym_Nothing] = anon_sym_Nothing,
  [anon_sym_real] = anon_sym_real,
  [anon_sym_rational] = anon_sym_rational,
  [anon_sym_anyURI] = anon_sym_anyURI,
  [anon_sym_iri] = anon_sym_iri,
  [anon_sym_base64Binary] = anon_sym_base64Binary,
  [anon_sym_boolean] = anon_sym_boolean,
  [anon_sym_date] = anon_sym_date,
  [anon_sym_dateTime] = anon_sym_dateTime,
  [anon_sym_decimal] = anon_sym_decimal,
  [anon_sym_double] = anon_sym_double,
  [anon_sym_duration] = anon_sym_duration,
  [anon_sym_float] = anon_sym_float,
  [anon_sym_gDay] = anon_sym_gDay,
  [anon_sym_gMonth] = anon_sym_gMonth,
  [anon_sym_gMonthDay] = anon_sym_gMonthDay,
  [anon_sym_gYearMonth] = anon_sym_gYearMonth,
  [anon_sym_gYear] = anon_sym_gYear,
  [anon_sym_hexBinary] = anon_sym_hexBinary,
  [anon_sym_binary] = anon_sym_binary,
  [anon_sym_string] = anon_sym_string,
  [anon_sym_time] = anon_sym_time,
  [anon_sym_dateTimeStamp] = anon_sym_dateTimeStamp,
  [anon_sym_dayTimeDuration] = anon_sym_dayTimeDuration,
  [anon_sym_yearMonthDuration] = anon_sym_yearMonthDuration,
  [anon_sym_integer] = anon_sym_integer,
  [anon_sym_long] = anon_sym_long,
  [anon_sym_int] = anon_sym_int,
  [anon_sym_short] = anon_sym_short,
  [anon_sym_byte] = anon_sym_byte,
  [anon_sym_nonNegativeInteger] = anon_sym_nonNegativeInteger,
  [anon_sym_positiveInteger] = anon_sym_positiveInteger,
  [anon_sym_unsignedLong] = anon_sym_unsignedLong,
  [anon_sym_unsignedInt] = anon_sym_unsignedInt,
  [anon_sym_unsigned] = anon_sym_unsigned,
  [anon_sym_unsignedShort] = anon_sym_unsignedShort,
  [anon_sym_unsignedByte] = anon_sym_unsignedByte,
  [anon_sym_nonPositiveInteger] = anon_sym_nonPositiveInteger,
  [anon_sym_negativeInteger] = anon_sym_negativeInteger,
  [anon_sym_normalizedString] = anon_sym_normalizedString,
  [anon_sym_token] = anon_sym_token,
  [anon_sym_language] = anon_sym_language,
  [sym_quoted_string] = sym_quoted_string,
  [sym_language_tag] = sym_language_tag,
  [anon_sym_LT] = anon_sym_LT,
  [aux_sym_iri_token1] = aux_sym_iri_token1,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_POUND_LBRACK] = anon_sym_POUND_LBRACK,
  [sym_hex_byte] = sym_hex_byte,
  [sym_double] = sym_double,
  [sym_decimal] = sym_decimal,
  [sym_integer] = sym_integer,
  [sym_rational] = sym_rational,
  [sym_unsigned] = sym_unsigned,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_u22a4] = anon_sym_u22a4,
  [anon_sym_false] = anon_sym_false,
  [anon_sym_u22a5] = anon_sym_u22a5,
  [anon_sym_datatype] = anon_sym_datatype,
  [sym_opaque] = sym_opaque,
  [anon_sym_length] = anon_sym_length,
  [anon_sym_maxLength] = anon_sym_maxLength,
  [anon_sym_minLength] = anon_sym_minLength,
  [anon_sym_fractionDigits] = anon_sym_fractionDigits,
  [anon_sym_totalDigits] = anon_sym_totalDigits,
  [anon_sym_maxExclusive] = anon_sym_maxExclusive,
  [anon_sym_maxInclusive] = anon_sym_maxInclusive,
  [anon_sym_minExclusive] = anon_sym_minExclusive,
  [anon_sym_minInclusive] = anon_sym_minInclusive,
  [anon_sym_explicitTimezone] = anon_sym_explicitTimezone,
  [anon_sym_required] = anon_sym_required,
  [anon_sym_prohibited] = anon_sym_prohibited,
  [anon_sym_optional] = anon_sym_optional,
  [anon_sym_pattern] = anon_sym_pattern,
  [sym_kw_is_fixed] = sym_kw_is_fixed,
  [anon_sym_dimension] = anon_sym_dimension,
  [anon_sym_source] = anon_sym_source,
  [anon_sym_parent] = anon_sym_parent,
  [anon_sym_entity] = anon_sym_entity,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_of] = anon_sym_of,
  [anon_sym_event] = anon_sym_event,
  [anon_sym_property] = anon_sym_property,
  [anon_sym_structure] = anon_sym_structure,
  [anon_sym_union] = anon_sym_union,
  [anon_sym_rdf] = anon_sym_rdf,
  [anon_sym_a] = anon_sym_a,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_class] = anon_sym_class,
  [sym_wildcard] = sym_wildcard,
  [anon_sym_identity] = anon_sym_identity,
  [anon_sym_ref] = anon_sym_ref,
  [sym_unknown_type] = sym_unknown_type,
  [anon_sym_ordered] = anon_sym_ordered,
  [anon_sym_unordered] = anon_sym_unordered,
  [anon_sym_unique] = anon_sym_unique,
  [anon_sym_nonunique] = anon_sym_nonunique,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_u2260] = anon_sym_u2260,
  [sym_op_less_than] = sym_op_less_than,
  [sym_op_greater_than] = sym_op_greater_than,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_u2264] = anon_sym_u2264,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_u2265] = anon_sym_u2265,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_u00ac] = anon_sym_u00ac,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_u2227] = anon_sym_u2227,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_u2228] = anon_sym_u2228,
  [anon_sym_xor] = anon_sym_xor,
  [anon_sym_u22bb] = anon_sym_u22bb,
  [anon_sym_implies] = anon_sym_implies,
  [anon_sym_EQ_EQ_GT] = anon_sym_EQ_EQ_GT,
  [anon_sym_u21d2] = anon_sym_u21d2,
  [anon_sym_iff] = anon_sym_iff,
  [anon_sym_LT_EQ_EQ_GT] = anon_sym_LT_EQ_EQ_GT,
  [anon_sym_u21d4] = anon_sym_u21d4,
  [anon_sym_forall] = anon_sym_forall,
  [anon_sym_u2200] = anon_sym_u2200,
  [anon_sym_exists] = anon_sym_exists,
  [anon_sym_u2203] = anon_sym_u2203,
  [anon_sym_u222a] = anon_sym_u222a,
  [anon_sym_intersection] = anon_sym_intersection,
  [anon_sym_u2229] = anon_sym_u2229,
  [anon_sym_subset] = anon_sym_subset,
  [anon_sym_u2282] = anon_sym_u2282,
  [anon_sym_subseteq] = anon_sym_subseteq,
  [anon_sym_u2286] = anon_sym_u2286,
  [anon_sym_complement] = anon_sym_complement,
  [anon_sym_u2216] = anon_sym_u2216,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_u2208] = anon_sym_u2208,
  [sym_set_op_builder] = sym_set_op_builder,
  [anon_sym_u00b7] = anon_sym_u00b7,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_COLON_EQ] = anon_sym_COLON_EQ,
  [anon_sym_u2254] = anon_sym_u2254,
  [anon_sym_u2192] = anon_sym_u2192,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_u2190] = anon_sym_u2190,
  [anon_sym_LT_DASH] = anon_sym_LT_DASH,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_u2295] = anon_sym_u2295,
  [sym__value_empty_sequence] = sym__value_empty_sequence,
  [sym_line_comment] = sym_line_comment,
  [sym_module] = sym_module,
  [sym__module_locations] = sym__module_locations,
  [sym_module_body] = sym_module_body,
  [sym_import_statement] = sym_import_statement,
  [sym_from_clause] = sym_from_clause,
  [sym_module_path_root_only] = sym_module_path_root_only,
  [sym_module_path_absolute] = sym_module_path_absolute,
  [sym_module_path_relative] = sym_module_path_relative,
  [sym__import] = sym__import,
  [sym__rename_import] = sym__rename_import,
  [sym_member_import] = sym_member_import,
  [sym_module_import] = sym_module_import,
  [sym_qualified_identifier] = sym_qualified_identifier,
  [sym_identifier_reference] = sym_identifier_reference,
  [sym_annotation] = sym_annotation,
  [sym_annotation_property] = sym_annotation_property,
  [sym_constraint] = sym_constraint,
  [sym_informal_constraint] = sym_informal_constraint,
  [sym_formal_constraint] = sym_formal_constraint,
  [sym_constraint_sentence] = sym_constraint_sentence,
  [sym_simple_sentence] = sym_simple_sentence,
  [sym_atomic_sentence] = sym_atomic_sentence,
  [sym__actual_arguments] = sym__actual_arguments,
  [sym_equation] = sym_equation,
  [sym_inequation] = sym_inequation,
  [sym_boolean_sentence] = sym_boolean_sentence,
  [sym_unary_boolean_sentence] = sym_unary_boolean_sentence,
  [sym_binary_boolean_sentence] = sym_binary_boolean_sentence,
  [sym__logical_connective] = sym__logical_connective,
  [sym_quantified_sentence] = sym_quantified_sentence,
  [sym_quantified_variable_binding] = sym_quantified_variable_binding,
  [sym_quantified_variable] = sym_quantified_variable,
  [sym_variable] = sym_variable,
  [sym_term] = sym_term,
  [sym_functional_term] = sym_functional_term,
  [sym_function_composition] = sym_function_composition,
  [sym_predicate_value] = sym_predicate_value,
  [sym_sequence_of_predicate_values] = sym_sequence_of_predicate_values,
  [sym_constraint_environment] = sym_constraint_environment,
  [sym_function_def] = sym_function_def,
  [sym_function_signature] = sym_function_signature,
  [sym_function_parameter] = sym_function_parameter,
  [sym__function_type] = sym__function_type,
  [sym_function_cardinality_expression] = sym_function_cardinality_expression,
  [sym_function_type_reference] = sym_function_type_reference,
  [sym_function_body] = sym_function_body,
  [sym_sequence_builder] = sym_sequence_builder,
  [sym_sequence_builder_body] = sym_sequence_builder_body,
  [sym_value] = sym_value,
  [sym_sequence_of_values] = sym_sequence_of_values,
  [sym__sequence_value_constraints] = sym__sequence_value_constraints,
  [sym_value_constructor] = sym_value_constructor,
  [sym_mapping_value] = sym_mapping_value,
  [sym_builtin_simple_type] = sym_builtin_simple_type,
  [sym__owl_builtin_types] = sym__owl_builtin_types,
  [sym__builtin_primitive_datatypes] = sym__builtin_primitive_datatypes,
  [sym__derived_date_datetypes] = sym__derived_date_datetypes,
  [sym__derived_numeric_datatypes] = sym__derived_numeric_datatypes,
  [sym__derived_string_datatypes] = sym__derived_string_datatypes,
  [sym_simple_value] = sym_simple_value,
  [sym_string] = sym_string,
  [sym_iri] = sym_iri,
  [sym_binary] = sym_binary,
  [sym_boolean] = sym_boolean,
  [sym_boolean_truth] = sym_boolean_truth,
  [sym_boolean_falsity] = sym_boolean_falsity,
  [sym_definition] = sym_definition,
  [sym_data_type_def] = sym_data_type_def,
  [sym__datatype_base] = sym__datatype_base,
  [sym_datatype_def_restriction] = sym_datatype_def_restriction,
  [sym__restriction_facet] = sym__restriction_facet,
  [sym_length_restriction_facet] = sym_length_restriction_facet,
  [sym_digit_restriction_facet] = sym_digit_restriction_facet,
  [sym_value_restriction_facet] = sym_value_restriction_facet,
  [sym_restriction_value] = sym_restriction_value,
  [sym_tz_restriction_facet] = sym_tz_restriction_facet,
  [sym_tz_restriction_value] = sym_tz_restriction_value,
  [sym_pattern_restriction_facet] = sym_pattern_restriction_facet,
  [sym_annotation_only_body] = sym_annotation_only_body,
  [sym_dimension_def] = sym_dimension_def,
  [sym_dimension_body] = sym_dimension_body,
  [sym_source_entity] = sym_source_entity,
  [sym__identifier_or_sequence] = sym__identifier_or_sequence,
  [sym_from_definition_clause] = sym_from_definition_clause,
  [sym__wildcard_or_identifier_or_sequence] = sym__wildcard_or_identifier_or_sequence,
  [sym_dimension_parent] = sym_dimension_parent,
  [sym_entity_def] = sym_entity_def,
  [sym_entity_body] = sym_entity_body,
  [sym_enum_def] = sym_enum_def,
  [sym_enum_body] = sym_enum_body,
  [sym_event_def] = sym_event_def,
  [sym_event_body] = sym_event_body,
  [sym_property_def] = sym_property_def,
  [sym_structure_def] = sym_structure_def,
  [sym_structure_body] = sym_structure_body,
  [sym_union_def] = sym_union_def,
  [sym_union_body] = sym_union_body,
  [sym_rdf_def] = sym_rdf_def,
  [sym_rdf_types] = sym_rdf_types,
  [sym_type_class_def] = sym_type_class_def,
  [sym_type_variable] = sym_type_variable,
  [sym_type_variable_restriction] = sym_type_variable_restriction,
  [sym_type_class_reference] = sym_type_class_reference,
  [sym_type_class_arguments] = sym_type_class_arguments,
  [sym_type_class_body] = sym_type_class_body,
  [sym_method_def] = sym_method_def,
  [sym_entity_identity] = sym_entity_identity,
  [sym_member] = sym_member,
  [sym_member_def] = sym_member_def,
  [sym_property_ref] = sym_property_ref,
  [sym__type_expression_to] = sym__type_expression_to,
  [sym_type_reference] = sym_type_reference,
  [sym_mapping_type] = sym_mapping_type,
  [sym_cardinality_expression] = sym_cardinality_expression,
  [sym__cardinality_inner] = sym__cardinality_inner,
  [sym_sequence_ordering] = sym_sequence_ordering,
  [sym_sequence_uniqueness] = sym_sequence_uniqueness,
  [sym_cardinality_range] = sym_cardinality_range,
  [sym_value_variant] = sym_value_variant,
  [sym_type_variant] = sym_type_variant,
  [sym_op_inequality] = sym_op_inequality,
  [sym_op_less_than_or_equal] = sym_op_less_than_or_equal,
  [sym_op_greater_than_or_equal] = sym_op_greater_than_or_equal,
  [sym_logical_op_negation] = sym_logical_op_negation,
  [sym_logical_op_conjunction] = sym_logical_op_conjunction,
  [sym_logical_op_disjunction] = sym_logical_op_disjunction,
  [sym_logical_op_exclusive_disjunction] = sym_logical_op_exclusive_disjunction,
  [sym_logical_op_implication] = sym_logical_op_implication,
  [sym_logical_op_biconditional] = sym_logical_op_biconditional,
  [sym_logical_quantifier_universal] = sym_logical_quantifier_universal,
  [sym_logical_quantifier_existential] = sym_logical_quantifier_existential,
  [sym_set_op_membership] = sym_set_op_membership,
  [sym__function_op_composition] = sym__function_op_composition,
  [sym__function_op_by_definition] = sym__function_op_by_definition,
  [sym__type_op_has_type] = sym__type_op_has_type,
  [sym__type_op_type_restriction] = sym__type_op_type_restriction,
  [sym_type_op_combiner] = sym_type_op_combiner,
  [aux_sym_module_body_repeat1] = aux_sym_module_body_repeat1,
  [aux_sym_module_body_repeat2] = aux_sym_module_body_repeat2,
  [aux_sym_module_body_repeat3] = aux_sym_module_body_repeat3,
  [aux_sym_import_statement_repeat1] = aux_sym_import_statement_repeat1,
  [aux_sym_module_path_absolute_repeat1] = aux_sym_module_path_absolute_repeat1,
  [aux_sym__actual_arguments_repeat1] = aux_sym__actual_arguments_repeat1,
  [aux_sym_function_composition_repeat1] = aux_sym_function_composition_repeat1,
  [aux_sym_sequence_of_predicate_values_repeat1] = aux_sym_sequence_of_predicate_values_repeat1,
  [aux_sym_constraint_environment_repeat1] = aux_sym_constraint_environment_repeat1,
  [aux_sym_function_signature_repeat1] = aux_sym_function_signature_repeat1,
  [aux_sym_sequence_builder_repeat1] = aux_sym_sequence_builder_repeat1,
  [aux_sym_sequence_of_values_repeat1] = aux_sym_sequence_of_values_repeat1,
  [aux_sym_binary_repeat1] = aux_sym_binary_repeat1,
  [aux_sym_datatype_def_restriction_repeat1] = aux_sym_datatype_def_restriction_repeat1,
  [aux_sym_pattern_restriction_facet_repeat1] = aux_sym_pattern_restriction_facet_repeat1,
  [aux_sym_dimension_body_repeat1] = aux_sym_dimension_body_repeat1,
  [aux_sym_dimension_body_repeat2] = aux_sym_dimension_body_repeat2,
  [aux_sym__identifier_or_sequence_repeat1] = aux_sym__identifier_or_sequence_repeat1,
  [aux_sym_enum_body_repeat1] = aux_sym_enum_body_repeat1,
  [aux_sym_union_body_repeat1] = aux_sym_union_body_repeat1,
  [aux_sym_rdf_types_repeat1] = aux_sym_rdf_types_repeat1,
  [aux_sym_type_class_def_repeat1] = aux_sym_type_class_def_repeat1,
  [aux_sym_type_variable_restriction_repeat1] = aux_sym_type_variable_restriction_repeat1,
  [aux_sym_type_class_arguments_repeat1] = aux_sym_type_class_arguments_repeat1,
  [aux_sym_type_class_body_repeat1] = aux_sym_type_class_body_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_version] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_end] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assert] = {
    .visible = true,
    .named = false,
  },
  [sym_controlled_language_tag] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [sym_reserved_self] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_def] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Thing] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Nothing] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_real] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rational] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_anyURI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_iri] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_base64Binary] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_boolean] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_date] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dateTime] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_decimal] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_double] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_duration] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_float] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_gDay] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_gMonth] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_gMonthDay] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_gYearMonth] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_gYear] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_hexBinary] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_binary] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_time] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dateTimeStamp] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dayTimeDuration] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yearMonthDuration] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_integer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_long] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_short] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_byte] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nonNegativeInteger] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_positiveInteger] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsignedLong] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsignedInt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsigned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsignedShort] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsignedByte] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nonPositiveInteger] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_negativeInteger] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_normalizedString] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_token] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_language] = {
    .visible = true,
    .named = false,
  },
  [sym_quoted_string] = {
    .visible = true,
    .named = true,
  },
  [sym_language_tag] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_iri_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [sym_hex_byte] = {
    .visible = true,
    .named = true,
  },
  [sym_double] = {
    .visible = true,
    .named = true,
  },
  [sym_decimal] = {
    .visible = true,
    .named = true,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [sym_rational] = {
    .visible = true,
    .named = true,
  },
  [sym_unsigned] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u22a4] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u22a5] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_datatype] = {
    .visible = true,
    .named = false,
  },
  [sym_opaque] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_length] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_maxLength] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_minLength] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fractionDigits] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_totalDigits] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_maxExclusive] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_maxInclusive] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_minExclusive] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_minInclusive] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_explicitTimezone] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_required] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_prohibited] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_optional] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pattern] = {
    .visible = true,
    .named = false,
  },
  [sym_kw_is_fixed] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_dimension] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_source] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_parent] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_entity] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_of] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_event] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_property] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_structure] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_union] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rdf] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_a] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [sym_wildcard] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_identity] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ref] = {
    .visible = true,
    .named = false,
  },
  [sym_unknown_type] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_ordered] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unordered] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unique] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nonunique] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2260] = {
    .visible = true,
    .named = false,
  },
  [sym_op_less_than] = {
    .visible = true,
    .named = true,
  },
  [sym_op_greater_than] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2264] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2265] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u00ac] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2227] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2228] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_xor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u22bb] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implies] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u21d2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_iff] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u21d4] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_forall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2200] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_exists] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2203] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u222a] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_intersection] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2229] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_subset] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2282] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_subseteq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2286] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_complement] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2216] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2208] = {
    .visible = true,
    .named = false,
  },
  [sym_set_op_builder] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_u00b7] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2254] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2192] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2190] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2295] = {
    .visible = true,
    .named = false,
  },
  [sym__value_empty_sequence] = {
    .visible = false,
    .named = true,
  },
  [sym_line_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym__module_locations] = {
    .visible = false,
    .named = true,
  },
  [sym_module_body] = {
    .visible = true,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_from_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_module_path_root_only] = {
    .visible = true,
    .named = true,
  },
  [sym_module_path_absolute] = {
    .visible = true,
    .named = true,
  },
  [sym_module_path_relative] = {
    .visible = true,
    .named = true,
  },
  [sym__import] = {
    .visible = false,
    .named = true,
  },
  [sym__rename_import] = {
    .visible = false,
    .named = true,
  },
  [sym_member_import] = {
    .visible = true,
    .named = true,
  },
  [sym_module_import] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier_reference] = {
    .visible = true,
    .named = true,
  },
  [sym_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_annotation_property] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_informal_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_formal_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint_sentence] = {
    .visible = true,
    .named = true,
  },
  [sym_simple_sentence] = {
    .visible = true,
    .named = true,
  },
  [sym_atomic_sentence] = {
    .visible = true,
    .named = true,
  },
  [sym__actual_arguments] = {
    .visible = false,
    .named = true,
  },
  [sym_equation] = {
    .visible = true,
    .named = true,
  },
  [sym_inequation] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean_sentence] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_boolean_sentence] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_boolean_sentence] = {
    .visible = true,
    .named = true,
  },
  [sym__logical_connective] = {
    .visible = false,
    .named = true,
  },
  [sym_quantified_sentence] = {
    .visible = true,
    .named = true,
  },
  [sym_quantified_variable_binding] = {
    .visible = true,
    .named = true,
  },
  [sym_quantified_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_term] = {
    .visible = true,
    .named = true,
  },
  [sym_functional_term] = {
    .visible = true,
    .named = true,
  },
  [sym_function_composition] = {
    .visible = true,
    .named = true,
  },
  [sym_predicate_value] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_of_predicate_values] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint_environment] = {
    .visible = true,
    .named = true,
  },
  [sym_function_def] = {
    .visible = true,
    .named = true,
  },
  [sym_function_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_function_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__function_type] = {
    .visible = false,
    .named = true,
  },
  [sym_function_cardinality_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type_reference] = {
    .visible = true,
    .named = true,
  },
  [sym_function_body] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_builder] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_builder_body] = {
    .visible = true,
    .named = true,
  },
  [sym_value] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_of_values] = {
    .visible = true,
    .named = true,
  },
  [sym__sequence_value_constraints] = {
    .visible = false,
    .named = true,
  },
  [sym_value_constructor] = {
    .visible = true,
    .named = true,
  },
  [sym_mapping_value] = {
    .visible = true,
    .named = true,
  },
  [sym_builtin_simple_type] = {
    .visible = true,
    .named = true,
  },
  [sym__owl_builtin_types] = {
    .visible = false,
    .named = true,
  },
  [sym__builtin_primitive_datatypes] = {
    .visible = false,
    .named = true,
  },
  [sym__derived_date_datetypes] = {
    .visible = false,
    .named = true,
  },
  [sym__derived_numeric_datatypes] = {
    .visible = false,
    .named = true,
  },
  [sym__derived_string_datatypes] = {
    .visible = false,
    .named = true,
  },
  [sym_simple_value] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_iri] = {
    .visible = true,
    .named = true,
  },
  [sym_binary] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean_truth] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean_falsity] = {
    .visible = true,
    .named = true,
  },
  [sym_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_data_type_def] = {
    .visible = true,
    .named = true,
  },
  [sym__datatype_base] = {
    .visible = false,
    .named = true,
  },
  [sym_datatype_def_restriction] = {
    .visible = true,
    .named = true,
  },
  [sym__restriction_facet] = {
    .visible = false,
    .named = true,
  },
  [sym_length_restriction_facet] = {
    .visible = true,
    .named = true,
  },
  [sym_digit_restriction_facet] = {
    .visible = true,
    .named = true,
  },
  [sym_value_restriction_facet] = {
    .visible = true,
    .named = true,
  },
  [sym_restriction_value] = {
    .visible = true,
    .named = true,
  },
  [sym_tz_restriction_facet] = {
    .visible = true,
    .named = true,
  },
  [sym_tz_restriction_value] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern_restriction_facet] = {
    .visible = true,
    .named = true,
  },
  [sym_annotation_only_body] = {
    .visible = true,
    .named = true,
  },
  [sym_dimension_def] = {
    .visible = true,
    .named = true,
  },
  [sym_dimension_body] = {
    .visible = true,
    .named = true,
  },
  [sym_source_entity] = {
    .visible = true,
    .named = true,
  },
  [sym__identifier_or_sequence] = {
    .visible = false,
    .named = true,
  },
  [sym_from_definition_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__wildcard_or_identifier_or_sequence] = {
    .visible = false,
    .named = true,
  },
  [sym_dimension_parent] = {
    .visible = true,
    .named = true,
  },
  [sym_entity_def] = {
    .visible = true,
    .named = true,
  },
  [sym_entity_body] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_def] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_body] = {
    .visible = true,
    .named = true,
  },
  [sym_event_def] = {
    .visible = true,
    .named = true,
  },
  [sym_event_body] = {
    .visible = true,
    .named = true,
  },
  [sym_property_def] = {
    .visible = true,
    .named = true,
  },
  [sym_structure_def] = {
    .visible = true,
    .named = true,
  },
  [sym_structure_body] = {
    .visible = true,
    .named = true,
  },
  [sym_union_def] = {
    .visible = true,
    .named = true,
  },
  [sym_union_body] = {
    .visible = true,
    .named = true,
  },
  [sym_rdf_def] = {
    .visible = true,
    .named = true,
  },
  [sym_rdf_types] = {
    .visible = true,
    .named = true,
  },
  [sym_type_class_def] = {
    .visible = true,
    .named = true,
  },
  [sym_type_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_type_variable_restriction] = {
    .visible = true,
    .named = true,
  },
  [sym_type_class_reference] = {
    .visible = true,
    .named = true,
  },
  [sym_type_class_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_type_class_body] = {
    .visible = true,
    .named = true,
  },
  [sym_method_def] = {
    .visible = true,
    .named = true,
  },
  [sym_entity_identity] = {
    .visible = true,
    .named = true,
  },
  [sym_member] = {
    .visible = true,
    .named = true,
  },
  [sym_member_def] = {
    .visible = true,
    .named = true,
  },
  [sym_property_ref] = {
    .visible = true,
    .named = true,
  },
  [sym__type_expression_to] = {
    .visible = false,
    .named = true,
  },
  [sym_type_reference] = {
    .visible = true,
    .named = true,
  },
  [sym_mapping_type] = {
    .visible = true,
    .named = true,
  },
  [sym_cardinality_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__cardinality_inner] = {
    .visible = false,
    .named = true,
  },
  [sym_sequence_ordering] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_uniqueness] = {
    .visible = true,
    .named = true,
  },
  [sym_cardinality_range] = {
    .visible = true,
    .named = true,
  },
  [sym_value_variant] = {
    .visible = true,
    .named = true,
  },
  [sym_type_variant] = {
    .visible = true,
    .named = true,
  },
  [sym_op_inequality] = {
    .visible = true,
    .named = true,
  },
  [sym_op_less_than_or_equal] = {
    .visible = true,
    .named = true,
  },
  [sym_op_greater_than_or_equal] = {
    .visible = true,
    .named = true,
  },
  [sym_logical_op_negation] = {
    .visible = true,
    .named = true,
  },
  [sym_logical_op_conjunction] = {
    .visible = true,
    .named = true,
  },
  [sym_logical_op_disjunction] = {
    .visible = true,
    .named = true,
  },
  [sym_logical_op_exclusive_disjunction] = {
    .visible = true,
    .named = true,
  },
  [sym_logical_op_implication] = {
    .visible = true,
    .named = true,
  },
  [sym_logical_op_biconditional] = {
    .visible = true,
    .named = true,
  },
  [sym_logical_quantifier_universal] = {
    .visible = true,
    .named = true,
  },
  [sym_logical_quantifier_existential] = {
    .visible = true,
    .named = true,
  },
  [sym_set_op_membership] = {
    .visible = true,
    .named = true,
  },
  [sym__function_op_composition] = {
    .visible = false,
    .named = true,
  },
  [sym__function_op_by_definition] = {
    .visible = false,
    .named = true,
  },
  [sym__type_op_has_type] = {
    .visible = false,
    .named = true,
  },
  [sym__type_op_type_restriction] = {
    .visible = false,
    .named = true,
  },
  [sym_type_op_combiner] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_module_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_module_body_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_module_body_repeat3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_import_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_module_path_absolute_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__actual_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_composition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_sequence_of_predicate_values_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_constraint_environment_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_signature_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_sequence_builder_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_sequence_of_values_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_binary_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_datatype_def_restriction_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pattern_restriction_facet_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dimension_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dimension_body_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__identifier_or_sequence_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_union_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_rdf_types_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_class_def_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_variable_restriction_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_class_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_class_body_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum ts_field_identifiers {
  field_argument = 1,
  field_arguments = 2,
  field_base = 3,
  field_binding = 4,
  field_body = 5,
  field_byte = 6,
  field_cardinality = 7,
  field_domain = 8,
  field_element = 9,
  field_empty = 10,
  field_entity = 11,
  field_environment = 12,
  field_facet = 13,
  field_from = 14,
  field_function = 15,
  field_identity = 16,
  field_is_fixed = 17,
  field_language = 18,
  field_lhs = 19,
  field_max = 20,
  field_member = 21,
  field_method = 22,
  field_min = 23,
  field_module = 24,
  field_name = 25,
  field_opaque = 26,
  field_operator = 27,
  field_ordering = 28,
  field_parameter = 29,
  field_predicate = 30,
  field_property = 31,
  field_quantifier = 32,
  field_range = 33,
  field_relation = 34,
  field_rename = 35,
  field_restriction = 36,
  field_rhs = 37,
  field_segment = 38,
  field_signature = 39,
  field_source = 40,
  field_subject = 41,
  field_target = 42,
  field_type = 43,
  field_types = 44,
  field_uniqueness = 45,
  field_value = 46,
  field_variable = 47,
  field_version_info = 48,
  field_version_uri = 49,
  field_wildcard = 50,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_base] = "base",
  [field_binding] = "binding",
  [field_body] = "body",
  [field_byte] = "byte",
  [field_cardinality] = "cardinality",
  [field_domain] = "domain",
  [field_element] = "element",
  [field_empty] = "empty",
  [field_entity] = "entity",
  [field_environment] = "environment",
  [field_facet] = "facet",
  [field_from] = "from",
  [field_function] = "function",
  [field_identity] = "identity",
  [field_is_fixed] = "is_fixed",
  [field_language] = "language",
  [field_lhs] = "lhs",
  [field_max] = "max",
  [field_member] = "member",
  [field_method] = "method",
  [field_min] = "min",
  [field_module] = "module",
  [field_name] = "name",
  [field_opaque] = "opaque",
  [field_operator] = "operator",
  [field_ordering] = "ordering",
  [field_parameter] = "parameter",
  [field_predicate] = "predicate",
  [field_property] = "property",
  [field_quantifier] = "quantifier",
  [field_range] = "range",
  [field_relation] = "relation",
  [field_rename] = "rename",
  [field_restriction] = "restriction",
  [field_rhs] = "rhs",
  [field_segment] = "segment",
  [field_signature] = "signature",
  [field_source] = "source",
  [field_subject] = "subject",
  [field_target] = "target",
  [field_type] = "type",
  [field_types] = "types",
  [field_uniqueness] = "uniqueness",
  [field_value] = "value",
  [field_variable] = "variable",
  [field_version_info] = "version_info",
  [field_version_uri] = "version_uri",
  [field_wildcard] = "wildcard",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 2},
  [2] = {.index = 2, .length = 1},
  [3] = {.index = 3, .length = 5},
  [4] = {.index = 8, .length = 1},
  [5] = {.index = 9, .length = 1},
  [6] = {.index = 10, .length = 1},
  [7] = {.index = 11, .length = 1},
  [8] = {.index = 12, .length = 2},
  [9] = {.index = 14, .length = 2},
  [10] = {.index = 16, .length = 2},
  [11] = {.index = 18, .length = 1},
  [12] = {.index = 19, .length = 2},
  [13] = {.index = 21, .length = 3},
  [14] = {.index = 24, .length = 2},
  [15] = {.index = 26, .length = 3},
  [16] = {.index = 29, .length = 1},
  [17] = {.index = 30, .length = 2},
  [18] = {.index = 32, .length = 3},
  [19] = {.index = 35, .length = 2},
  [20] = {.index = 37, .length = 2},
  [21] = {.index = 39, .length = 1},
  [22] = {.index = 40, .length = 2},
  [23] = {.index = 42, .length = 1},
  [24] = {.index = 43, .length = 2},
  [25] = {.index = 45, .length = 4},
  [26] = {.index = 49, .length = 1},
  [27] = {.index = 50, .length = 1},
  [28] = {.index = 51, .length = 3},
  [29] = {.index = 54, .length = 1},
  [30] = {.index = 55, .length = 1},
  [31] = {.index = 56, .length = 1},
  [32] = {.index = 57, .length = 1},
  [33] = {.index = 58, .length = 1},
  [34] = {.index = 59, .length = 1},
  [35] = {.index = 60, .length = 3},
  [36] = {.index = 63, .length = 2},
  [37] = {.index = 65, .length = 1},
  [38] = {.index = 66, .length = 2},
  [39] = {.index = 68, .length = 2},
  [40] = {.index = 70, .length = 2},
  [41] = {.index = 72, .length = 2},
  [42] = {.index = 74, .length = 2},
  [43] = {.index = 76, .length = 2},
  [44] = {.index = 78, .length = 3},
  [45] = {.index = 81, .length = 3},
  [46] = {.index = 84, .length = 3},
  [47] = {.index = 87, .length = 1},
  [48] = {.index = 88, .length = 1},
  [49] = {.index = 89, .length = 2},
  [50] = {.index = 91, .length = 1},
  [51] = {.index = 92, .length = 1},
  [52] = {.index = 93, .length = 2},
  [53] = {.index = 95, .length = 1},
  [54] = {.index = 96, .length = 1},
  [55] = {.index = 97, .length = 1},
  [56] = {.index = 98, .length = 2},
  [57] = {.index = 100, .length = 2},
  [58] = {.index = 102, .length = 2},
  [59] = {.index = 104, .length = 2},
  [60] = {.index = 106, .length = 2},
  [61] = {.index = 108, .length = 1},
  [62] = {.index = 109, .length = 2},
  [63] = {.index = 111, .length = 1},
  [64] = {.index = 112, .length = 1},
  [65] = {.index = 113, .length = 1},
  [66] = {.index = 114, .length = 2},
  [67] = {.index = 116, .length = 2},
  [68] = {.index = 118, .length = 2},
  [69] = {.index = 120, .length = 2},
  [70] = {.index = 122, .length = 3},
  [71] = {.index = 125, .length = 2},
  [72] = {.index = 127, .length = 2},
  [73] = {.index = 129, .length = 1},
  [74] = {.index = 130, .length = 3},
  [75] = {.index = 133, .length = 3},
  [76] = {.index = 136, .length = 2},
  [77] = {.index = 138, .length = 4},
  [78] = {.index = 142, .length = 4},
  [79] = {.index = 146, .length = 4},
  [80] = {.index = 150, .length = 2},
  [81] = {.index = 152, .length = 1},
  [82] = {.index = 153, .length = 1},
  [83] = {.index = 154, .length = 2},
  [84] = {.index = 156, .length = 2},
  [85] = {.index = 158, .length = 2},
  [86] = {.index = 160, .length = 1},
  [87] = {.index = 161, .length = 2},
  [88] = {.index = 163, .length = 2},
  [89] = {.index = 165, .length = 1},
  [90] = {.index = 166, .length = 3},
  [91] = {.index = 169, .length = 3},
  [92] = {.index = 172, .length = 2},
  [93] = {.index = 174, .length = 2},
  [94] = {.index = 176, .length = 3},
  [95] = {.index = 179, .length = 2},
  [96] = {.index = 181, .length = 1},
  [97] = {.index = 182, .length = 2},
  [98] = {.index = 184, .length = 2},
  [99] = {.index = 186, .length = 1},
  [100] = {.index = 187, .length = 5},
  [101] = {.index = 192, .length = 1},
  [102] = {.index = 193, .length = 2},
  [103] = {.index = 195, .length = 2},
  [104] = {.index = 197, .length = 2},
  [105] = {.index = 199, .length = 1},
  [106] = {.index = 200, .length = 3},
  [107] = {.index = 203, .length = 1},
  [108] = {.index = 204, .length = 3},
  [109] = {.index = 207, .length = 3},
  [110] = {.index = 210, .length = 3},
  [111] = {.index = 213, .length = 2},
  [112] = {.index = 215, .length = 2},
  [113] = {.index = 217, .length = 2},
  [114] = {.index = 219, .length = 2},
  [115] = {.index = 221, .length = 2},
  [116] = {.index = 223, .length = 1},
  [117] = {.index = 224, .length = 2},
  [118] = {.index = 226, .length = 2},
  [119] = {.index = 228, .length = 2},
  [120] = {.index = 230, .length = 4},
  [121] = {.index = 234, .length = 4},
  [122] = {.index = 238, .length = 3},
  [123] = {.index = 241, .length = 2},
  [124] = {.index = 243, .length = 1},
  [125] = {.index = 244, .length = 2},
  [126] = {.index = 246, .length = 3},
  [127] = {.index = 249, .length = 1},
  [128] = {.index = 250, .length = 1},
  [129] = {.index = 251, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_body, 2},
    {field_name, 1},
  [2] =
    {field_base, 0},
  [3] =
    {field_base, 2, .inherited = true},
    {field_body, 3},
    {field_name, 1},
    {field_version_info, 2, .inherited = true},
    {field_version_uri, 2, .inherited = true},
  [8] =
    {field_name, 0},
  [9] =
    {field_segment, 0},
  [10] =
    {field_name, 1},
  [11] =
    {field_member, 1},
  [12] =
    {field_base, 0},
    {field_version_uri, 2},
  [14] =
    {field_name, 0},
    {field_rename, 1, .inherited = true},
  [16] =
    {field_name, 0},
    {field_version_uri, 1},
  [18] =
    {field_segment, 1},
  [19] =
    {field_segment, 0},
    {field_segment, 1, .inherited = true},
  [21] =
    {field_cardinality, 1, .inherited = true},
    {field_name, 0},
    {field_target, 1, .inherited = true},
  [24] =
    {field_name, 1},
    {field_types, 2},
  [26] =
    {field_base, 0},
    {field_version_info, 2},
    {field_version_uri, 3},
  [29] =
    {field_rename, 1},
  [30] =
    {field_member, 2},
    {field_module, 0},
  [32] =
    {field_name, 0},
    {field_rename, 2, .inherited = true},
    {field_version_uri, 1},
  [35] =
    {field_segment, 1},
    {field_segment, 2, .inherited = true},
  [37] =
    {field_segment, 0, .inherited = true},
    {field_segment, 1, .inherited = true},
  [39] =
    {field_empty, 0},
  [40] =
    {field_name, 1},
    {field_value, 3},
  [42] =
    {field_value, 1},
  [43] =
    {field_base, 3},
    {field_name, 1},
  [45] =
    {field_body, 2},
    {field_cardinality, 1, .inherited = true},
    {field_name, 0},
    {field_target, 1, .inherited = true},
  [49] =
    {field_target, 1},
  [50] =
    {field_type, 1},
  [51] =
    {field_body, 3},
    {field_name, 1},
    {field_types, 2},
  [54] =
    {field_signature, 0},
  [55] =
    {field_method, 0},
  [56] =
    {field_variable, 0},
  [57] =
    {field_element, 0},
  [58] =
    {field_language, 1},
  [59] =
    {field_byte, 0},
  [60] =
    {field_empty, 1},
    {field_ordering, 0, .inherited = true},
    {field_uniqueness, 0, .inherited = true},
  [63] =
    {field_name, 1, .inherited = true},
    {field_subject, 0},
  [65] =
    {field_body, 1},
  [66] =
    {field_argument, 1, .inherited = true},
    {field_predicate, 0},
  [68] =
    {field_argument, 1, .inherited = true},
    {field_function, 0},
  [70] =
    {field_operator, 0},
    {field_rhs, 1},
  [72] =
    {field_binding, 1},
    {field_quantifier, 0},
  [74] =
    {field_language, 2},
    {field_value, 1},
  [76] =
    {field_body, 1},
    {field_signature, 0},
  [78] =
    {field_base, 4},
    {field_name, 1},
    {field_opaque, 3},
  [81] =
    {field_base, 3},
    {field_name, 1},
    {field_restriction, 4},
  [84] =
    {field_base, 3},
    {field_body, 4},
    {field_name, 1},
  [87] =
    {field_entity, 1},
  [88] =
    {field_identity, 1},
  [89] =
    {field_body, 1},
    {field_name, 0},
  [91] =
    {field_from, 1},
  [92] =
    {field_min, 0},
  [93] =
    {field_cardinality, 1},
    {field_target, 2},
  [95] =
    {field_property, 1},
  [96] =
    {field_type, 0},
  [97] =
    {field_method, 1, .inherited = true},
  [98] =
    {field_method, 0, .inherited = true},
    {field_method, 1, .inherited = true},
  [100] =
    {field_name, 0},
    {field_restriction, 1},
  [102] =
    {field_cardinality, 0},
    {field_name, 1},
  [104] =
    {field_name, 1},
    {field_variable, 3, .inherited = true},
  [106] =
    {field_variable, 0, .inherited = true},
    {field_variable, 1, .inherited = true},
  [108] =
    {field_element, 1, .inherited = true},
  [109] =
    {field_element, 0, .inherited = true},
    {field_element, 1, .inherited = true},
  [111] =
    {field_ordering, 1},
  [112] =
    {field_uniqueness, 1},
  [113] =
    {field_byte, 1, .inherited = true},
  [114] =
    {field_byte, 0, .inherited = true},
    {field_byte, 1, .inherited = true},
  [116] =
    {field_ordering, 0, .inherited = true},
    {field_uniqueness, 0, .inherited = true},
  [118] =
    {field_domain, 0},
    {field_range, 2},
  [120] =
    {field_name, 0, .inherited = true},
    {field_name, 1, .inherited = true},
  [122] =
    {field_lhs, 0},
    {field_operator, 1},
    {field_rhs, 2},
  [125] =
    {field_binding, 0},
    {field_body, 2},
  [127] =
    {field_lhs, 0},
    {field_rhs, 2},
  [129] =
    {field_argument, 0},
  [130] =
    {field_lhs, 0},
    {field_relation, 1},
    {field_rhs, 2},
  [133] =
    {field_cardinality, 2, .inherited = true},
    {field_name, 1},
    {field_target, 2, .inherited = true},
  [136] =
    {field_body, 2},
    {field_environment, 0},
  [138] =
    {field_base, 4},
    {field_name, 1},
    {field_opaque, 3},
    {field_restriction, 5},
  [142] =
    {field_base, 4},
    {field_body, 5},
    {field_name, 1},
    {field_opaque, 3},
  [146] =
    {field_base, 3},
    {field_body, 5},
    {field_name, 1},
    {field_restriction, 4},
  [150] =
    {field_from, 2},
    {field_identity, 1},
  [152] =
    {field_identity, 2},
  [153] =
    {field_from, 2},
  [154] =
    {field_min, 0},
    {field_range, 1},
  [156] =
    {field_min, 1, .inherited = true},
    {field_range, 1, .inherited = true},
  [158] =
    {field_name, 0},
    {field_rename, 2},
  [160] =
    {field_type, 2, .inherited = true},
  [161] =
    {field_type, 0, .inherited = true},
    {field_type, 1, .inherited = true},
  [163] =
    {field_from, 1},
    {field_method, 2, .inherited = true},
  [165] =
    {field_method, 2, .inherited = true},
  [166] =
    {field_cardinality, 0},
    {field_name, 1},
    {field_restriction, 2},
  [169] =
    {field_body, 5},
    {field_name, 1},
    {field_variable, 3, .inherited = true},
  [172] =
    {field_ordering, 1},
    {field_uniqueness, 2},
  [174] =
    {field_name, 0},
    {field_value, 2},
  [176] =
    {field_element, 2, .inherited = true},
    {field_ordering, 0, .inherited = true},
    {field_uniqueness, 0, .inherited = true},
  [179] =
    {field_name, 0},
    {field_range, 2},
  [181] =
    {field_argument, 1, .inherited = true},
  [182] =
    {field_argument, 0, .inherited = true},
    {field_argument, 1, .inherited = true},
  [184] =
    {field_source, 2},
    {field_variable, 0},
  [186] =
    {field_parameter, 0},
  [187] =
    {field_base, 4},
    {field_body, 6},
    {field_name, 1},
    {field_opaque, 3},
    {field_restriction, 5},
  [192] =
    {field_member, 0},
  [193] =
    {field_entity, 1},
    {field_member, 3, .inherited = true},
  [195] =
    {field_from, 3},
    {field_identity, 1},
  [197] =
    {field_from, 3},
    {field_identity, 2},
  [199] =
    {field_wildcard, 0},
  [200] =
    {field_from, 1},
    {field_member, 3, .inherited = true},
    {field_wildcard, 3, .inherited = true},
  [203] =
    {field_max, 1},
  [204] =
    {field_min, 2, .inherited = true},
    {field_ordering, 1},
    {field_range, 2, .inherited = true},
  [207] =
    {field_min, 2, .inherited = true},
    {field_range, 2, .inherited = true},
    {field_uniqueness, 1},
  [210] =
    {field_body, 3},
    {field_name, 0},
    {field_rename, 2},
  [213] =
    {field_from, 2},
    {field_method, 3, .inherited = true},
  [215] =
    {field_arguments, 1},
    {field_name, 0},
  [217] =
    {field_body, 3},
    {field_variable, 1, .inherited = true},
  [219] =
    {field_parameter, 0, .inherited = true},
    {field_parameter, 1, .inherited = true},
  [221] =
    {field_facet, 0},
    {field_value, 2},
  [223] =
    {field_value, 2},
  [224] =
    {field_entity, 3},
    {field_name, 1},
  [226] =
    {field_from, 4},
    {field_identity, 2},
  [228] =
    {field_domain, 1},
    {field_range, 3},
  [230] =
    {field_min, 3, .inherited = true},
    {field_ordering, 1},
    {field_range, 3, .inherited = true},
    {field_uniqueness, 2},
  [234] =
    {field_cardinality, 5, .inherited = true},
    {field_name, 1},
    {field_parameter, 3, .inherited = true},
    {field_target, 5, .inherited = true},
  [238] =
    {field_facet, 0},
    {field_is_fixed, 2},
    {field_value, 3},
  [241] =
    {field_is_fixed, 2},
    {field_value, 3},
  [243] =
    {field_member, 1, .inherited = true},
  [244] =
    {field_member, 0, .inherited = true},
    {field_member, 1, .inherited = true},
  [246] =
    {field_body, 4},
    {field_entity, 3},
    {field_name, 1},
  [249] =
    {field_wildcard, 1},
  [250] =
    {field_variable, 1, .inherited = true},
  [251] =
    {field_value, 2},
    {field_value, 3},
    {field_value, 4},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 17,
  [18] = 18,
  [19] = 19,
  [20] = 20,
  [21] = 21,
  [22] = 22,
  [23] = 22,
  [24] = 24,
  [25] = 25,
  [26] = 26,
  [27] = 27,
  [28] = 20,
  [29] = 29,
  [30] = 21,
  [31] = 24,
  [32] = 32,
  [33] = 33,
  [34] = 34,
  [35] = 35,
  [36] = 36,
  [37] = 37,
  [38] = 38,
  [39] = 39,
  [40] = 40,
  [41] = 41,
  [42] = 42,
  [43] = 43,
  [44] = 44,
  [45] = 45,
  [46] = 46,
  [47] = 47,
  [48] = 48,
  [49] = 49,
  [50] = 50,
  [51] = 51,
  [52] = 52,
  [53] = 53,
  [54] = 48,
  [55] = 55,
  [56] = 52,
  [57] = 57,
  [58] = 58,
  [59] = 59,
  [60] = 60,
  [61] = 61,
  [62] = 62,
  [63] = 63,
  [64] = 64,
  [65] = 65,
  [66] = 66,
  [67] = 67,
  [68] = 68,
  [69] = 69,
  [70] = 70,
  [71] = 71,
  [72] = 68,
  [73] = 73,
  [74] = 74,
  [75] = 75,
  [76] = 70,
  [77] = 69,
  [78] = 75,
  [79] = 79,
  [80] = 79,
  [81] = 81,
  [82] = 82,
  [83] = 83,
  [84] = 84,
  [85] = 85,
  [86] = 86,
  [87] = 87,
  [88] = 88,
  [89] = 89,
  [90] = 90,
  [91] = 91,
  [92] = 92,
  [93] = 93,
  [94] = 94,
  [95] = 95,
  [96] = 96,
  [97] = 97,
  [98] = 98,
  [99] = 99,
  [100] = 100,
  [101] = 101,
  [102] = 96,
  [103] = 103,
  [104] = 96,
  [105] = 63,
  [106] = 106,
  [107] = 107,
  [108] = 108,
  [109] = 109,
  [110] = 110,
  [111] = 111,
  [112] = 112,
  [113] = 113,
  [114] = 114,
  [115] = 115,
  [116] = 8,
  [117] = 66,
  [118] = 2,
  [119] = 3,
  [120] = 4,
  [121] = 71,
  [122] = 122,
  [123] = 123,
  [124] = 124,
  [125] = 73,
  [126] = 74,
  [127] = 127,
  [128] = 11,
  [129] = 12,
  [130] = 9,
  [131] = 7,
  [132] = 5,
  [133] = 10,
  [134] = 134,
  [135] = 13,
  [136] = 82,
  [137] = 137,
  [138] = 138,
  [139] = 137,
  [140] = 140,
  [141] = 138,
  [142] = 142,
  [143] = 140,
  [144] = 92,
  [145] = 89,
  [146] = 95,
  [147] = 127,
  [148] = 148,
  [149] = 87,
  [150] = 91,
  [151] = 90,
  [152] = 152,
  [153] = 88,
  [154] = 154,
  [155] = 155,
  [156] = 156,
  [157] = 157,
  [158] = 158,
  [159] = 45,
  [160] = 160,
  [161] = 161,
  [162] = 162,
  [163] = 163,
  [164] = 164,
  [165] = 85,
  [166] = 166,
  [167] = 167,
  [168] = 168,
  [169] = 94,
  [170] = 170,
  [171] = 171,
  [172] = 160,
  [173] = 93,
  [174] = 174,
  [175] = 86,
  [176] = 176,
  [177] = 177,
  [178] = 178,
  [179] = 179,
  [180] = 180,
  [181] = 181,
  [182] = 182,
  [183] = 183,
  [184] = 184,
  [185] = 185,
  [186] = 186,
  [187] = 187,
  [188] = 188,
  [189] = 189,
  [190] = 190,
  [191] = 191,
  [192] = 192,
  [193] = 193,
  [194] = 194,
  [195] = 195,
  [196] = 196,
  [197] = 197,
  [198] = 198,
  [199] = 199,
  [200] = 200,
  [201] = 201,
  [202] = 185,
  [203] = 203,
  [204] = 204,
  [205] = 205,
  [206] = 206,
  [207] = 207,
  [208] = 208,
  [209] = 209,
  [210] = 210,
  [211] = 211,
  [212] = 212,
  [213] = 213,
  [214] = 214,
  [215] = 215,
  [216] = 216,
  [217] = 217,
  [218] = 218,
  [219] = 219,
  [220] = 217,
  [221] = 221,
  [222] = 222,
  [223] = 223,
  [224] = 224,
  [225] = 225,
  [226] = 226,
  [227] = 227,
  [228] = 228,
  [229] = 229,
  [230] = 230,
  [231] = 231,
  [232] = 232,
  [233] = 233,
  [234] = 234,
  [235] = 235,
  [236] = 236,
  [237] = 237,
  [238] = 238,
  [239] = 239,
  [240] = 240,
  [241] = 241,
  [242] = 242,
  [243] = 243,
  [244] = 244,
  [245] = 245,
  [246] = 246,
  [247] = 247,
  [248] = 248,
  [249] = 249,
  [250] = 250,
  [251] = 251,
  [252] = 252,
  [253] = 253,
  [254] = 254,
  [255] = 255,
  [256] = 256,
  [257] = 257,
  [258] = 258,
  [259] = 259,
  [260] = 260,
  [261] = 261,
  [262] = 262,
  [263] = 263,
  [264] = 264,
  [265] = 265,
  [266] = 266,
  [267] = 267,
  [268] = 268,
  [269] = 269,
  [270] = 270,
  [271] = 271,
  [272] = 272,
  [273] = 273,
  [274] = 274,
  [275] = 275,
  [276] = 276,
  [277] = 277,
  [278] = 278,
  [279] = 279,
  [280] = 280,
  [281] = 281,
  [282] = 282,
  [283] = 283,
  [284] = 284,
  [285] = 285,
  [286] = 286,
  [287] = 287,
  [288] = 288,
  [289] = 289,
  [290] = 290,
  [291] = 291,
  [292] = 292,
  [293] = 293,
  [294] = 294,
  [295] = 295,
  [296] = 296,
  [297] = 297,
  [298] = 298,
  [299] = 299,
  [300] = 300,
  [301] = 301,
  [302] = 302,
  [303] = 303,
  [304] = 304,
  [305] = 305,
  [306] = 306,
  [307] = 307,
  [308] = 308,
  [309] = 309,
  [310] = 310,
  [311] = 311,
  [312] = 312,
  [313] = 313,
  [314] = 314,
  [315] = 315,
  [316] = 316,
  [317] = 317,
  [318] = 318,
  [319] = 319,
  [320] = 320,
  [321] = 321,
  [322] = 322,
  [323] = 323,
  [324] = 324,
  [325] = 325,
  [326] = 326,
  [327] = 327,
  [328] = 328,
  [329] = 329,
  [330] = 330,
  [331] = 331,
  [332] = 332,
  [333] = 333,
  [334] = 334,
  [335] = 335,
  [336] = 336,
  [337] = 337,
  [338] = 338,
  [339] = 339,
  [340] = 337,
  [341] = 339,
  [342] = 342,
  [343] = 343,
  [344] = 344,
  [345] = 345,
  [346] = 346,
  [347] = 347,
  [348] = 348,
  [349] = 349,
  [350] = 350,
  [351] = 351,
  [352] = 352,
  [353] = 353,
  [354] = 354,
  [355] = 355,
  [356] = 356,
  [357] = 357,
  [358] = 358,
  [359] = 359,
  [360] = 360,
  [361] = 361,
  [362] = 362,
  [363] = 154,
  [364] = 364,
  [365] = 365,
  [366] = 366,
  [367] = 367,
  [368] = 368,
  [369] = 369,
  [370] = 370,
  [371] = 371,
  [372] = 372,
  [373] = 373,
  [374] = 374,
  [375] = 375,
  [376] = 376,
  [377] = 377,
  [378] = 378,
  [379] = 379,
  [380] = 380,
  [381] = 381,
  [382] = 382,
  [383] = 383,
  [384] = 384,
  [385] = 385,
  [386] = 386,
  [387] = 387,
  [388] = 388,
  [389] = 389,
  [390] = 390,
  [391] = 391,
  [392] = 392,
  [393] = 393,
  [394] = 394,
  [395] = 395,
  [396] = 396,
  [397] = 397,
  [398] = 398,
  [399] = 399,
  [400] = 400,
  [401] = 401,
  [402] = 402,
  [403] = 403,
  [404] = 404,
  [405] = 405,
  [406] = 406,
  [407] = 407,
  [408] = 408,
  [409] = 409,
  [410] = 410,
  [411] = 411,
  [412] = 412,
  [413] = 413,
  [414] = 414,
  [415] = 415,
  [416] = 416,
  [417] = 417,
  [418] = 418,
  [419] = 419,
  [420] = 420,
  [421] = 421,
  [422] = 422,
  [423] = 423,
  [424] = 424,
  [425] = 425,
  [426] = 426,
  [427] = 427,
  [428] = 428,
  [429] = 429,
  [430] = 430,
  [431] = 431,
  [432] = 432,
  [433] = 433,
  [434] = 434,
  [435] = 435,
  [436] = 436,
  [437] = 437,
  [438] = 438,
  [439] = 439,
  [440] = 45,
  [441] = 441,
  [442] = 442,
  [443] = 443,
  [444] = 444,
  [445] = 445,
  [446] = 446,
  [447] = 447,
  [448] = 448,
  [449] = 449,
  [450] = 450,
  [451] = 451,
  [452] = 452,
  [453] = 453,
  [454] = 454,
  [455] = 455,
  [456] = 453,
  [457] = 457,
  [458] = 189,
  [459] = 459,
  [460] = 181,
  [461] = 461,
  [462] = 462,
  [463] = 463,
  [464] = 464,
  [465] = 465,
  [466] = 466,
  [467] = 467,
  [468] = 468,
  [469] = 469,
  [470] = 470,
  [471] = 471,
  [472] = 472,
  [473] = 473,
  [474] = 474,
  [475] = 475,
  [476] = 476,
  [477] = 477,
  [478] = 478,
  [479] = 479,
  [480] = 480,
  [481] = 481,
  [482] = 482,
  [483] = 483,
  [484] = 484,
  [485] = 485,
  [486] = 486,
  [487] = 487,
  [488] = 488,
  [489] = 489,
  [490] = 490,
  [491] = 491,
  [492] = 492,
  [493] = 493,
  [494] = 494,
  [495] = 495,
  [496] = 496,
  [497] = 497,
  [498] = 498,
  [499] = 499,
  [500] = 500,
  [501] = 501,
  [502] = 502,
  [503] = 503,
  [504] = 504,
  [505] = 505,
  [506] = 506,
  [507] = 507,
  [508] = 508,
  [509] = 509,
  [510] = 510,
  [511] = 485,
  [512] = 512,
  [513] = 513,
  [514] = 514,
  [515] = 515,
  [516] = 507,
  [517] = 517,
  [518] = 518,
  [519] = 519,
  [520] = 520,
  [521] = 521,
  [522] = 522,
  [523] = 523,
  [524] = 524,
  [525] = 525,
  [526] = 526,
  [527] = 527,
  [528] = 526,
  [529] = 529,
  [530] = 530,
  [531] = 531,
  [532] = 532,
  [533] = 533,
  [534] = 534,
  [535] = 535,
  [536] = 536,
  [537] = 537,
  [538] = 538,
  [539] = 539,
  [540] = 540,
  [541] = 541,
  [542] = 542,
  [543] = 543,
  [544] = 544,
  [545] = 545,
  [546] = 546,
  [547] = 547,
  [548] = 548,
  [549] = 549,
  [550] = 550,
  [551] = 551,
  [552] = 552,
  [553] = 553,
  [554] = 554,
  [555] = 555,
  [556] = 556,
  [557] = 557,
  [558] = 558,
  [559] = 559,
  [560] = 560,
  [561] = 561,
  [562] = 562,
  [563] = 563,
  [564] = 564,
  [565] = 565,
  [566] = 566,
  [567] = 567,
  [568] = 568,
  [569] = 569,
  [570] = 570,
  [571] = 571,
  [572] = 572,
  [573] = 573,
  [574] = 574,
  [575] = 575,
  [576] = 576,
  [577] = 577,
  [578] = 578,
  [579] = 579,
  [580] = 580,
  [581] = 581,
  [582] = 582,
  [583] = 583,
  [584] = 584,
  [585] = 585,
  [586] = 586,
  [587] = 587,
  [588] = 588,
  [589] = 589,
  [590] = 590,
  [591] = 591,
  [592] = 592,
  [593] = 593,
  [594] = 594,
  [595] = 595,
  [596] = 596,
  [597] = 597,
  [598] = 598,
  [599] = 599,
  [600] = 593,
  [601] = 575,
  [602] = 602,
  [603] = 603,
  [604] = 604,
  [605] = 605,
  [606] = 606,
  [607] = 607,
  [608] = 608,
  [609] = 609,
  [610] = 572,
  [611] = 611,
  [612] = 612,
  [613] = 613,
  [614] = 614,
  [615] = 615,
  [616] = 616,
  [617] = 617,
  [618] = 618,
  [619] = 619,
  [620] = 620,
  [621] = 574,
  [622] = 620,
  [623] = 623,
  [624] = 565,
  [625] = 625,
  [626] = 626,
  [627] = 627,
  [628] = 628,
};

static TSCharacterRange sym_identifier_character_set_1[] = {
  {'A', 'Z'}, {'a', 'z'}, {0xb5, 0xb5}, {0xc0, 0xd6}, {0xd8, 0xf6}, {0xf8, 0x1ba}, {0x1bc, 0x1bf}, {0x1c4, 0x1c4},
  {0x1c6, 0x1c7}, {0x1c9, 0x1ca}, {0x1cc, 0x1f1}, {0x1f3, 0x293}, {0x295, 0x2af}, {0x370, 0x373}, {0x376, 0x377}, {0x37b, 0x37d},
  {0x37f, 0x37f}, {0x386, 0x386}, {0x388, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5}, {0x3f7, 0x481}, {0x48a, 0x52f},
  {0x531, 0x556}, {0x560, 0x588}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fd, 0x10ff}, {0x13a0, 0x13f5},
  {0x13f8, 0x13fd}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf}, {0x1d00, 0x1d2b}, {0x1d6b, 0x1d77}, {0x1d79, 0x1d9a}, {0x1e00, 0x1f15},
  {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57}, {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b}, {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d},
  {0x1f80, 0x1f87}, {0x1f90, 0x1f97}, {0x1fa0, 0x1fa7}, {0x1fb0, 0x1fb4}, {0x1fb6, 0x1fbb}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4}, {0x1fc6, 0x1fcb},
  {0x1fd0, 0x1fd3}, {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffb}, {0x2102, 0x2102}, {0x2107, 0x2107}, {0x210a, 0x2113},
  {0x2115, 0x2115}, {0x2119, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x212d}, {0x212f, 0x2134}, {0x2139, 0x2139},
  {0x213c, 0x213f}, {0x2145, 0x2149}, {0x214e, 0x214e}, {0x2183, 0x2184}, {0x2c00, 0x2c7b}, {0x2c7e, 0x2ce4}, {0x2ceb, 0x2cee}, {0x2cf2, 0x2cf3},
  {0x2d00, 0x2d25}, {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d}, {0xa640, 0xa66d}, {0xa680, 0xa69b}, {0xa722, 0xa76f}, {0xa771, 0xa787}, {0xa78b, 0xa78e},
  {0xa790, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f5, 0xa7f6}, {0xa7fa, 0xa7fa}, {0xab30, 0xab5a}, {0xab60, 0xab68},
  {0xab70, 0xabbf}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xff21, 0xff3a}, {0xff41, 0xff5a}, {0x10400, 0x1044f}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb},
  {0x10570, 0x1057a}, {0x1057c, 0x1058a}, {0x1058c, 0x10592}, {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc},
};

static TSCharacterRange sym_identifier_character_set_2[] = {
  {'0', '9'}, {'A', 'Z'}, {'_', '_'}, {'a', 'z'}, {0xb5, 0xb5}, {0xc0, 0xd6}, {0xd8, 0xf6}, {0xf8, 0x1ba},
  {0x1bc, 0x1bf}, {0x1c4, 0x1c4}, {0x1c6, 0x1c7}, {0x1c9, 0x1ca}, {0x1cc, 0x1f1}, {0x1f3, 0x293}, {0x295, 0x2af}, {0x370, 0x373},
  {0x376, 0x377}, {0x37b, 0x37d}, {0x37f, 0x37f}, {0x386, 0x386}, {0x388, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5},
  {0x3f7, 0x481}, {0x48a, 0x52f}, {0x531, 0x556}, {0x560, 0x588}, {0x660, 0x669}, {0x6f0, 0x6f9}, {0x7c0, 0x7c9}, {0x966, 0x96f},
  {0x9e6, 0x9ef}, {0xa66, 0xa6f}, {0xae6, 0xaef}, {0xb66, 0xb6f}, {0xbe6, 0xbef}, {0xc66, 0xc6f}, {0xce6, 0xcef}, {0xd66, 0xd6f},
  {0xde6, 0xdef}, {0xe50, 0xe59}, {0xed0, 0xed9}, {0xf20, 0xf29}, {0x1040, 0x1049}, {0x1090, 0x1099}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7},
  {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fd, 0x10ff}, {0x13a0, 0x13f5}, {0x13f8, 0x13fd}, {0x17e0, 0x17e9}, {0x1810, 0x1819}, {0x1946, 0x194f},
  {0x19d0, 0x19d9}, {0x1a80, 0x1a89}, {0x1a90, 0x1a99}, {0x1b50, 0x1b59}, {0x1bb0, 0x1bb9}, {0x1c40, 0x1c49}, {0x1c50, 0x1c59}, {0x1c80, 0x1c88},
  {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf}, {0x1d00, 0x1d2b}, {0x1d6b, 0x1d77}, {0x1d79, 0x1d9a}, {0x1e00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45},
  {0x1f48, 0x1f4d}, {0x1f50, 0x1f57}, {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b}, {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1f87}, {0x1f90, 0x1f97},
  {0x1fa0, 0x1fa7}, {0x1fb0, 0x1fb4}, {0x1fb6, 0x1fbb}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4}, {0x1fc6, 0x1fcb}, {0x1fd0, 0x1fd3}, {0x1fd6, 0x1fdb},
  {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffb}, {0x2102, 0x2102}, {0x2107, 0x2107}, {0x210a, 0x2113}, {0x2115, 0x2115}, {0x2119, 0x211d},
  {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x212d}, {0x212f, 0x2134}, {0x2139, 0x2139}, {0x213c, 0x213f}, {0x2145, 0x2149},
  {0x214e, 0x214e}, {0x2183, 0x2184}, {0x2c00, 0x2c7b}, {0x2c7e, 0x2ce4}, {0x2ceb, 0x2cee}, {0x2cf2, 0x2cf3}, {0x2d00, 0x2d25}, {0x2d27, 0x2d27},
  {0x2d2d, 0x2d2d}, {0xa620, 0xa629}, {0xa640, 0xa66d}, {0xa680, 0xa69b}, {0xa722, 0xa76f}, {0xa771, 0xa787}, {0xa78b, 0xa78e}, {0xa790, 0xa7ca},
  {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f5, 0xa7f6}, {0xa7fa, 0xa7fa}, {0xa8d0, 0xa8d9}, {0xa900, 0xa909}, {0xa9d0, 0xa9d9},
  {0xa9f0, 0xa9f9}, {0xaa50, 0xaa59}, {0xab30, 0xab5a}, {0xab60, 0xab68}, {0xab70, 0xabbf}, {0xabf0, 0xabf9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17},
  {0xff10, 0xff19}, {0xff21, 0xff3a}, {0xff41, 0xff5a}, {0x10400, 0x1044f}, {0x104a0, 0x104a9}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb}, {0x10570, 0x1057a},
  {0x1057c, 0x1058a}, {0x1058c, 0x10592}, {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc},
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(71);
      ADVANCE_MAP(
        '"', 5,
        '#', 29,
        '(', 96,
        ')', 97,
        '+', 176,
        ',', 98,
        '-', 12,
        '.', 169,
        '/', 23,
        '0', 132,
        ':', 79,
        ';', 188,
        '<', 143,
        '=', 84,
        '>', 145,
        '@', 82,
        '[', 72,
        '\\', 14,
        ']', 73,
        '_', 139,
        '{', 99,
        '|', 166,
        '}', 100,
        0xac, 150,
        0xb7, 167,
        0x2190, 174,
        0x2192, 172,
        0x21d2, 155,
        0x21d4, 157,
        0x2200, 158,
        0x2203, 159,
        0x2205, 178,
        0x2208, 165,
        0x2216, 164,
        0x2227, 151,
        0x2228, 152,
        0x2229, 161,
        0x222a, 160,
        0x2254, 171,
        0x2260, 142,
        0x2264, 147,
        0x2265, 149,
        0x2282, 162,
        0x2286, 163,
        0x2295, 177,
        0x22a4, 137,
        0x22a5, 138,
        0x22bb, 153,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(70);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(131);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(76);
      if (set_contains(sym_identifier_character_set_1, 112, lookahead)) ADVANCE(77);
      END_STATE();
    case 1:
      ADVANCE_MAP(
        '"', 5,
        '#', 29,
        '(', 96,
        ')', 97,
        '+', 13,
        '-', 12,
        '.', 168,
        '0', 129,
        ':', 78,
        ';', 188,
        '<', 117,
        '>', 121,
        '@', 81,
        '[', 72,
        '\\', 14,
        ']', 73,
        '{', 99,
        '}', 100,
        0xac, 150,
        0xb7, 167,
        0x2192, 172,
        0x2200, 158,
        0x2203, 159,
        0x2205, 178,
        0x22a4, 137,
        0x22a5, 138,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(3);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(130);
      if (set_contains(sym_identifier_character_set_1, 112, lookahead)) ADVANCE(77);
      END_STATE();
    case 2:
      ADVANCE_MAP(
        '"', 5,
        '#', 29,
        '(', 96,
        ')', 97,
        '+', 13,
        '-', 12,
        '0', 129,
        ':', 17,
        ';', 188,
        '<', 117,
        '@', 66,
        '[', 72,
        '\\', 14,
        ']', 73,
        '{', 99,
        0x2192, 172,
        0x2205, 178,
        0x22a4, 137,
        0x22a5, 138,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(4);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(130);
      if (set_contains(sym_identifier_character_set_1, 112, lookahead)) ADVANCE(77);
      END_STATE();
    case 3:
      ADVANCE_MAP(
        '"', 5,
        '#', 29,
        '(', 96,
        ')', 97,
        '+', 13,
        '-', 12,
        '0', 129,
        ';', 188,
        '<', 117,
        '@', 81,
        '[', 72,
        '\\', 14,
        ']', 73,
        '{', 99,
        '}', 100,
        0xac, 150,
        0x2192, 172,
        0x2200, 158,
        0x2203, 159,
        0x2205, 178,
        0x22a4, 137,
        0x22a5, 138,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(3);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(130);
      if (set_contains(sym_identifier_character_set_1, 112, lookahead)) ADVANCE(77);
      END_STATE();
    case 4:
      ADVANCE_MAP(
        '"', 5,
        '#', 29,
        '(', 96,
        ')', 97,
        '+', 13,
        '-', 12,
        '0', 129,
        ';', 188,
        '<', 117,
        '[', 72,
        '\\', 14,
        ']', 73,
        '{', 99,
        0x2192, 172,
        0x2205, 178,
        0x22a4, 137,
        0x22a5, 138,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(4);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(130);
      if (set_contains(sym_identifier_character_set_1, 112, lookahead)) ADVANCE(77);
      END_STATE();
    case 5:
      if (lookahead == '"') ADVANCE(101);
      if (lookahead == '\\') ADVANCE(31);
      if (lookahead > 0x08 &&
          (lookahead < 0x0b || 0x1f < lookahead) &&
          lookahead != 0x7f) ADVANCE(5);
      END_STATE();
    case 6:
      ADVANCE_MAP(
        '(', 96,
        ')', 97,
        '+', 176,
        ',', 98,
        '-', 25,
        '.', 168,
        '/', 23,
        '0', 135,
        ':', 80,
        ';', 188,
        '<', 144,
        '=', 84,
        '>', 145,
        '@', 81,
        '[', 72,
        ']', 73,
        '_', 139,
        '{', 99,
        '|', 166,
        '}', 100,
        0xb7, 167,
        0x2192, 172,
        0x21d2, 155,
        0x21d4, 157,
        0x2200, 158,
        0x2203, 159,
        0x2208, 165,
        0x2227, 151,
        0x2228, 152,
        0x2254, 171,
        0x2260, 142,
        0x2264, 147,
        0x2265, 149,
        0x2295, 177,
        0x22bb, 153,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(7);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(136);
      if (set_contains(sym_identifier_character_set_1, 112, lookahead)) ADVANCE(77);
      END_STATE();
    case 7:
      ADVANCE_MAP(
        '(', 96,
        ')', 97,
        '+', 176,
        ',', 98,
        '-', 25,
        '/', 23,
        '0', 135,
        ':', 24,
        ';', 188,
        '<', 144,
        '=', 84,
        '>', 145,
        '@', 81,
        '[', 72,
        ']', 73,
        '_', 139,
        '{', 99,
        '|', 166,
        '}', 100,
        0x2192, 172,
        0x21d2, 155,
        0x21d4, 157,
        0x2200, 158,
        0x2203, 159,
        0x2208, 165,
        0x2227, 151,
        0x2228, 152,
        0x2254, 171,
        0x2260, 142,
        0x2264, 147,
        0x2265, 149,
        0x2295, 177,
        0x22bb, 153,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(7);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(136);
      if (set_contains(sym_identifier_character_set_1, 112, lookahead)) ADVANCE(77);
      END_STATE();
    case 8:
      ADVANCE_MAP(
        '(', 96,
        ')', 97,
        ',', 98,
        '-', 25,
        '.', 11,
        '/', 23,
        ':', 18,
        ';', 188,
        '<', 144,
        '=', 84,
        '>', 145,
        '@', 81,
        '}', 100,
        0x2192, 172,
        0x21d2, 155,
        0x21d4, 157,
        0x2227, 151,
        0x2228, 152,
        0x2260, 142,
        0x2264, 147,
        0x2265, 149,
        0x22bb, 153,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(8);
      if (set_contains(sym_identifier_character_set_1, 112, lookahead)) ADVANCE(77);
      END_STATE();
    case 9:
      ADVANCE_MAP(
        '(', 96,
        ')', 97,
        ',', 98,
        '-', 25,
        '.', 11,
        '/', 23,
        ':', 18,
        ';', 188,
        '<', 144,
        '=', 84,
        '>', 145,
        '@', 83,
        '}', 100,
        0x2192, 172,
        0x21d2, 155,
        0x21d4, 157,
        0x2227, 151,
        0x2228, 152,
        0x2260, 142,
        0x2264, 147,
        0x2265, 149,
        0x22bb, 153,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(8);
      if (set_contains(sym_identifier_character_set_1, 112, lookahead)) ADVANCE(77);
      END_STATE();
    case 10:
      if (lookahead == '-') ADVANCE(175);
      END_STATE();
    case 11:
      if (lookahead == '.') ADVANCE(140);
      END_STATE();
    case 12:
      if (lookahead == '0') ADVANCE(129);
      if (lookahead == '>') ADVANCE(173);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(130);
      END_STATE();
    case 13:
      if (lookahead == '0') ADVANCE(129);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(130);
      END_STATE();
    case 14:
      if (lookahead == '0') ADVANCE(128);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(133);
      END_STATE();
    case 15:
      if (lookahead == '0') ADVANCE(125);
      if (lookahead == '+' ||
          lookahead == '-' ||
          lookahead == '\\') ADVANCE(16);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(126);
      END_STATE();
    case 16:
      if (lookahead == '0') ADVANCE(125);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(126);
      END_STATE();
    case 17:
      if (lookahead == ':') ADVANCE(75);
      END_STATE();
    case 18:
      if (lookahead == ':') ADVANCE(74);
      END_STATE();
    case 19:
      if (lookahead == ':') ADVANCE(74);
      if (lookahead == '=') ADVANCE(170);
      END_STATE();
    case 20:
      if (lookahead == ';') ADVANCE(188);
      if (lookahead == '<') ADVANCE(10);
      if (lookahead == '@') ADVANCE(82);
      if (lookahead == 0x2190) ADVANCE(174);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(21);
      if (set_contains(sym_identifier_character_set_1, 112, lookahead)) ADVANCE(77);
      END_STATE();
    case 21:
      if (lookahead == ';') ADVANCE(188);
      if (lookahead == '<') ADVANCE(10);
      if (lookahead == '@') ADVANCE(81);
      if (lookahead == 0x2190) ADVANCE(174);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(21);
      if (set_contains(sym_identifier_character_set_1, 112, lookahead)) ADVANCE(77);
      END_STATE();
    case 22:
      if (lookahead == ';') ADVANCE(188);
      if (lookahead == ']') ADVANCE(73);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(22);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(47);
      END_STATE();
    case 23:
      if (lookahead == '=') ADVANCE(141);
      END_STATE();
    case 24:
      if (lookahead == '=') ADVANCE(170);
      END_STATE();
    case 25:
      if (lookahead == '>') ADVANCE(173);
      END_STATE();
    case 26:
      if (lookahead == '>') ADVANCE(154);
      END_STATE();
    case 27:
      if (lookahead == '>') ADVANCE(156);
      END_STATE();
    case 28:
      if (lookahead == 'U') ADVANCE(57);
      if (lookahead == 'u') ADVANCE(53);
      END_STATE();
    case 29:
      if (lookahead == '[') ADVANCE(122);
      END_STATE();
    case 30:
      if (lookahead == '_') ADVANCE(30);
      if (set_contains(sym_identifier_character_set_2, 151, lookahead)) ADVANCE(77);
      END_STATE();
    case 31:
      ADVANCE_MAP(
        'u', 32,
        '"', 5,
        '/', 5,
        '\\', 5,
        'a', 5,
        'b', 5,
        'e', 5,
        'f', 5,
        'n', 5,
        'r', 5,
        't', 5,
        'v', 5,
      );
      END_STATE();
    case 32:
      if (lookahead == '{') ADVANCE(50);
      END_STATE();
    case 33:
      if (lookahead == '}') ADVANCE(5);
      END_STATE();
    case 34:
      if (lookahead == '}') ADVANCE(5);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(33);
      END_STATE();
    case 35:
      if (lookahead == '}') ADVANCE(5);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(34);
      END_STATE();
    case 36:
      if (lookahead == '}') ADVANCE(5);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(35);
      END_STATE();
    case 37:
      if (lookahead == '}') ADVANCE(5);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(36);
      END_STATE();
    case 38:
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(134);
      END_STATE();
    case 39:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(127);
      END_STATE();
    case 40:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(102);
      END_STATE();
    case 41:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(46);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(59);
      END_STATE();
    case 42:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(46);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(60);
      END_STATE();
    case 43:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(46);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(61);
      END_STATE();
    case 44:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(46);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(62);
      END_STATE();
    case 45:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(46);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(63);
      END_STATE();
    case 46:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(40);
      END_STATE();
    case 47:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(123);
      END_STATE();
    case 48:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(37);
      END_STATE();
    case 49:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(119);
      END_STATE();
    case 50:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(48);
      END_STATE();
    case 51:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(49);
      END_STATE();
    case 52:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(51);
      END_STATE();
    case 53:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(52);
      END_STATE();
    case 54:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(53);
      END_STATE();
    case 55:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(54);
      END_STATE();
    case 56:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(55);
      END_STATE();
    case 57:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(56);
      END_STATE();
    case 58:
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(69);
      END_STATE();
    case 59:
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(114);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(68);
      END_STATE();
    case 60:
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(102);
      END_STATE();
    case 61:
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(102);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(68);
      END_STATE();
    case 62:
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(115);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(68);
      END_STATE();
    case 63:
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(116);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(68);
      END_STATE();
    case 64:
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(87);
      END_STATE();
    case 65:
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(108);
      END_STATE();
    case 66:
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(65);
      END_STATE();
    case 67:
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(110);
      END_STATE();
    case 68:
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(67);
      END_STATE();
    case 69:
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(95);
      END_STATE();
    case 70:
      if (eof) ADVANCE(71);
      ADVANCE_MAP(
        '"', 5,
        '#', 29,
        '(', 96,
        ')', 97,
        '+', 176,
        ',', 98,
        '-', 12,
        '.', 11,
        '/', 23,
        '0', 132,
        ':', 19,
        ';', 188,
        '<', 143,
        '=', 84,
        '>', 145,
        '@', 81,
        '[', 72,
        '\\', 14,
        ']', 73,
        '_', 139,
        '{', 99,
        '|', 166,
        '}', 100,
        0xac, 150,
        0x2190, 174,
        0x2192, 172,
        0x21d2, 155,
        0x21d4, 157,
        0x2200, 158,
        0x2203, 159,
        0x2205, 178,
        0x2208, 165,
        0x2216, 164,
        0x2227, 151,
        0x2228, 152,
        0x2229, 161,
        0x222a, 160,
        0x2254, 171,
        0x2260, 142,
        0x2264, 147,
        0x2265, 149,
        0x2282, 162,
        0x2286, 163,
        0x2295, 177,
        0x22a4, 137,
        0x22a5, 138,
        0x22bb, 153,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(70);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(131);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(76);
      if (set_contains(sym_identifier_character_set_1, 112, lookahead)) ADVANCE(77);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_COLON_COLON2);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(30);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(77);
      if (set_contains(sym_identifier_character_set_2, 151, lookahead)) ADVANCE(77);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(30);
      if (set_contains(sym_identifier_character_set_2, 151, lookahead)) ADVANCE(77);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == '=') ADVANCE(170);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '=') ADVANCE(170);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_AT);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(64);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_AT);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(65);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(26);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(sym_controlled_language_tag);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(sym_controlled_language_tag);
      if (lookahead == '-') ADVANCE(58);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(sym_controlled_language_tag);
      if (lookahead == '-') ADVANCE(58);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(86);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(sym_controlled_language_tag);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(85);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(sym_controlled_language_tag);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(88);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym_controlled_language_tag);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(89);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(sym_controlled_language_tag);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(90);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(sym_controlled_language_tag);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(91);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(sym_controlled_language_tag);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(92);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(sym_controlled_language_tag);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(93);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(sym_controlled_language_tag);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(94);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(sym_quoted_string);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(sym_language_tag);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(sym_language_tag);
      if (lookahead == '-') ADVANCE(41);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(sym_language_tag);
      if (lookahead == '-') ADVANCE(41);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(109);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(sym_language_tag);
      if (lookahead == '-') ADVANCE(41);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(104);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(sym_language_tag);
      if (lookahead == '-') ADVANCE(41);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(105);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(sym_language_tag);
      if (lookahead == '-') ADVANCE(41);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(106);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(sym_language_tag);
      if (lookahead == '-') ADVANCE(41);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(107);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(sym_language_tag);
      if (lookahead == '-') ADVANCE(41);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(103);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(sym_language_tag);
      if (lookahead == '-') ADVANCE(42);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(sym_language_tag);
      if (lookahead == '-') ADVANCE(43);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(sym_language_tag);
      if (lookahead == '-') ADVANCE(44);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(sym_language_tag);
      if (lookahead == '-') ADVANCE(45);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(sym_language_tag);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(113);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(sym_language_tag);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(111);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(sym_language_tag);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(112);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(aux_sym_iri_token1);
      if (lookahead == ';') ADVANCE(120);
      if (lookahead == '\\') ADVANCE(28);
      if (lookahead > ' ' &&
          lookahead != '"' &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(119);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(aux_sym_iri_token1);
      if (lookahead == '\\') ADVANCE(28);
      if (lookahead > ' ' &&
          lookahead != '"' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(119);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(aux_sym_iri_token1);
      if (lookahead == '\\') ADVANCE(179);
      if ((!eof && lookahead <= '\t') ||
          (0x0b <= lookahead && lookahead <= ' ') ||
          lookahead == '"' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '^' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}')) ADVANCE(188);
      if (lookahead > ' ') ADVANCE(120);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_POUND_LBRACK);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(sym_hex_byte);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(sym_hex_byte);
      if (lookahead == '.') ADVANCE(39);
      if (lookahead == '/') ADVANCE(38);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(130);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(sym_double);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(sym_double);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(126);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(sym_decimal);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(15);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(127);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(39);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(39);
      if (lookahead == '/') ADVANCE(38);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(39);
      if (lookahead == '/') ADVANCE(38);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(130);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(39);
      if (lookahead == '/') ADVANCE(38);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(124);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(123);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(39);
      if (lookahead == '/') ADVANCE(38);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(123);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(39);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(133);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(sym_rational);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(134);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(sym_unsigned);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(sym_unsigned);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(136);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_u22a4);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_u22a5);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(sym_wildcard);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_u2260);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(sym_op_less_than);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(sym_op_less_than);
      if (lookahead == '=') ADVANCE(146);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(sym_op_greater_than);
      if (lookahead == '=') ADVANCE(148);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      if (lookahead == '=') ADVANCE(27);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_u2264);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_u2265);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_u00ac);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_u2227);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_u2228);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_u22bb);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_GT);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_u21d2);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_LT_EQ_EQ_GT);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_u21d4);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_u2200);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_u2203);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_u222a);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_u2229);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_u2282);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_u2286);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_u2216);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_u2208);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(sym_set_op_builder);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_u00b7);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(140);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_COLON_EQ);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_u2254);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_u2192);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_u2190);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_LT_DASH);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_u2295);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym__value_empty_sequence);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym_line_comment);
      if (lookahead == 'U') ADVANCE(187);
      if (lookahead == 'u') ADVANCE(183);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(188);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(sym_line_comment);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(120);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(188);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym_line_comment);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(180);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(188);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym_line_comment);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(181);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(188);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(sym_line_comment);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(182);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(188);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(sym_line_comment);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(183);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(188);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(sym_line_comment);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(184);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(188);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(sym_line_comment);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(185);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(188);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(sym_line_comment);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(186);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(188);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym_line_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(188);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      ADVANCE_MAP(
        'N', 1,
        'T', 2,
        'a', 3,
        'b', 4,
        'c', 5,
        'd', 6,
        'e', 7,
        'f', 8,
        'g', 9,
        'h', 10,
        'i', 11,
        'l', 12,
        'm', 13,
        'n', 14,
        'o', 15,
        'p', 16,
        'r', 17,
        's', 18,
        't', 19,
        'u', 20,
        'v', 21,
        'w', 22,
        'x', 23,
        'y', 24,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == 'o') ADVANCE(25);
      END_STATE();
    case 2:
      if (lookahead == 'h') ADVANCE(26);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(anon_sym_a);
      if (lookahead == 'n') ADVANCE(27);
      if (lookahead == 's') ADVANCE(28);
      END_STATE();
    case 4:
      if (lookahead == 'a') ADVANCE(29);
      if (lookahead == 'i') ADVANCE(30);
      if (lookahead == 'o') ADVANCE(31);
      if (lookahead == 'y') ADVANCE(32);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(33);
      if (lookahead == 'o') ADVANCE(34);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(35);
      if (lookahead == 'e') ADVANCE(36);
      if (lookahead == 'i') ADVANCE(37);
      if (lookahead == 'o') ADVANCE(38);
      if (lookahead == 'u') ADVANCE(39);
      END_STATE();
    case 7:
      if (lookahead == 'n') ADVANCE(40);
      if (lookahead == 'v') ADVANCE(41);
      if (lookahead == 'x') ADVANCE(42);
      END_STATE();
    case 8:
      if (lookahead == 'a') ADVANCE(43);
      if (lookahead == 'i') ADVANCE(44);
      if (lookahead == 'l') ADVANCE(45);
      if (lookahead == 'o') ADVANCE(46);
      if (lookahead == 'r') ADVANCE(47);
      END_STATE();
    case 9:
      if (lookahead == 'D') ADVANCE(48);
      if (lookahead == 'M') ADVANCE(49);
      if (lookahead == 'Y') ADVANCE(50);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(51);
      END_STATE();
    case 11:
      if (lookahead == 'd') ADVANCE(52);
      if (lookahead == 'f') ADVANCE(53);
      if (lookahead == 'm') ADVANCE(54);
      if (lookahead == 'n') ADVANCE(55);
      if (lookahead == 'r') ADVANCE(56);
      if (lookahead == 's') ADVANCE(57);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(58);
      if (lookahead == 'e') ADVANCE(59);
      if (lookahead == 'o') ADVANCE(60);
      END_STATE();
    case 13:
      if (lookahead == 'a') ADVANCE(61);
      if (lookahead == 'i') ADVANCE(62);
      if (lookahead == 'o') ADVANCE(63);
      END_STATE();
    case 14:
      if (lookahead == 'e') ADVANCE(64);
      if (lookahead == 'o') ADVANCE(65);
      END_STATE();
    case 15:
      if (lookahead == 'f') ADVANCE(66);
      if (lookahead == 'p') ADVANCE(67);
      if (lookahead == 'r') ADVANCE(68);
      END_STATE();
    case 16:
      if (lookahead == 'a') ADVANCE(69);
      if (lookahead == 'o') ADVANCE(70);
      if (lookahead == 'r') ADVANCE(71);
      END_STATE();
    case 17:
      if (lookahead == 'a') ADVANCE(72);
      if (lookahead == 'd') ADVANCE(73);
      if (lookahead == 'e') ADVANCE(74);
      END_STATE();
    case 18:
      if (lookahead == 'e') ADVANCE(75);
      if (lookahead == 'h') ADVANCE(76);
      if (lookahead == 'o') ADVANCE(77);
      if (lookahead == 't') ADVANCE(78);
      if (lookahead == 'u') ADVANCE(79);
      END_STATE();
    case 19:
      if (lookahead == 'i') ADVANCE(80);
      if (lookahead == 'o') ADVANCE(81);
      if (lookahead == 'r') ADVANCE(82);
      if (lookahead == 'y') ADVANCE(83);
      END_STATE();
    case 20:
      if (lookahead == 'n') ADVANCE(84);
      END_STATE();
    case 21:
      if (lookahead == 'e') ADVANCE(85);
      END_STATE();
    case 22:
      if (lookahead == 'i') ADVANCE(86);
      END_STATE();
    case 23:
      if (lookahead == 'o') ADVANCE(87);
      END_STATE();
    case 24:
      if (lookahead == 'e') ADVANCE(88);
      END_STATE();
    case 25:
      if (lookahead == 't') ADVANCE(89);
      END_STATE();
    case 26:
      if (lookahead == 'i') ADVANCE(90);
      END_STATE();
    case 27:
      if (lookahead == 'd') ADVANCE(91);
      if (lookahead == 'y') ADVANCE(92);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 's') ADVANCE(93);
      END_STATE();
    case 29:
      if (lookahead == 's') ADVANCE(94);
      END_STATE();
    case 30:
      if (lookahead == 'n') ADVANCE(95);
      END_STATE();
    case 31:
      if (lookahead == 'o') ADVANCE(96);
      END_STATE();
    case 32:
      if (lookahead == 't') ADVANCE(97);
      END_STATE();
    case 33:
      if (lookahead == 'a') ADVANCE(98);
      END_STATE();
    case 34:
      if (lookahead == 'm') ADVANCE(99);
      END_STATE();
    case 35:
      if (lookahead == 't') ADVANCE(100);
      if (lookahead == 'y') ADVANCE(101);
      END_STATE();
    case 36:
      if (lookahead == 'c') ADVANCE(102);
      if (lookahead == 'f') ADVANCE(103);
      END_STATE();
    case 37:
      if (lookahead == 'm') ADVANCE(104);
      END_STATE();
    case 38:
      if (lookahead == 'u') ADVANCE(105);
      END_STATE();
    case 39:
      if (lookahead == 'r') ADVANCE(106);
      END_STATE();
    case 40:
      if (lookahead == 'd') ADVANCE(107);
      if (lookahead == 't') ADVANCE(108);
      if (lookahead == 'u') ADVANCE(109);
      END_STATE();
    case 41:
      if (lookahead == 'e') ADVANCE(110);
      END_STATE();
    case 42:
      if (lookahead == 'i') ADVANCE(111);
      if (lookahead == 'p') ADVANCE(112);
      END_STATE();
    case 43:
      if (lookahead == 'l') ADVANCE(113);
      END_STATE();
    case 44:
      if (lookahead == 'x') ADVANCE(114);
      END_STATE();
    case 45:
      if (lookahead == 'o') ADVANCE(115);
      END_STATE();
    case 46:
      if (lookahead == 'r') ADVANCE(116);
      END_STATE();
    case 47:
      if (lookahead == 'a') ADVANCE(117);
      if (lookahead == 'o') ADVANCE(118);
      END_STATE();
    case 48:
      if (lookahead == 'a') ADVANCE(119);
      END_STATE();
    case 49:
      if (lookahead == 'o') ADVANCE(120);
      END_STATE();
    case 50:
      if (lookahead == 'e') ADVANCE(121);
      END_STATE();
    case 51:
      if (lookahead == 'x') ADVANCE(122);
      END_STATE();
    case 52:
      if (lookahead == 'e') ADVANCE(123);
      END_STATE();
    case 53:
      if (lookahead == 'f') ADVANCE(124);
      END_STATE();
    case 54:
      if (lookahead == 'p') ADVANCE(125);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 't') ADVANCE(126);
      END_STATE();
    case 56:
      if (lookahead == 'i') ADVANCE(127);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 58:
      if (lookahead == 'n') ADVANCE(128);
      END_STATE();
    case 59:
      if (lookahead == 'n') ADVANCE(129);
      END_STATE();
    case 60:
      if (lookahead == 'n') ADVANCE(130);
      END_STATE();
    case 61:
      if (lookahead == 'x') ADVANCE(131);
      END_STATE();
    case 62:
      if (lookahead == 'n') ADVANCE(132);
      END_STATE();
    case 63:
      if (lookahead == 'd') ADVANCE(133);
      END_STATE();
    case 64:
      if (lookahead == 'g') ADVANCE(134);
      END_STATE();
    case 65:
      if (lookahead == 'n') ADVANCE(135);
      if (lookahead == 'r') ADVANCE(136);
      if (lookahead == 't') ADVANCE(137);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_of);
      END_STATE();
    case 67:
      if (lookahead == 'a') ADVANCE(138);
      if (lookahead == 't') ADVANCE(139);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_or);
      if (lookahead == 'd') ADVANCE(140);
      END_STATE();
    case 69:
      if (lookahead == 'r') ADVANCE(141);
      if (lookahead == 't') ADVANCE(142);
      END_STATE();
    case 70:
      if (lookahead == 's') ADVANCE(143);
      END_STATE();
    case 71:
      if (lookahead == 'o') ADVANCE(144);
      END_STATE();
    case 72:
      if (lookahead == 't') ADVANCE(145);
      END_STATE();
    case 73:
      if (lookahead == 'f') ADVANCE(146);
      END_STATE();
    case 74:
      if (lookahead == 'a') ADVANCE(147);
      if (lookahead == 'f') ADVANCE(148);
      if (lookahead == 'q') ADVANCE(149);
      END_STATE();
    case 75:
      if (lookahead == 'l') ADVANCE(150);
      END_STATE();
    case 76:
      if (lookahead == 'o') ADVANCE(151);
      END_STATE();
    case 77:
      if (lookahead == 'u') ADVANCE(152);
      END_STATE();
    case 78:
      if (lookahead == 'r') ADVANCE(153);
      END_STATE();
    case 79:
      if (lookahead == 'b') ADVANCE(154);
      END_STATE();
    case 80:
      if (lookahead == 'm') ADVANCE(155);
      END_STATE();
    case 81:
      if (lookahead == 'k') ADVANCE(156);
      if (lookahead == 't') ADVANCE(157);
      END_STATE();
    case 82:
      if (lookahead == 'u') ADVANCE(158);
      END_STATE();
    case 83:
      if (lookahead == 'p') ADVANCE(159);
      END_STATE();
    case 84:
      if (lookahead == 'i') ADVANCE(160);
      if (lookahead == 'k') ADVANCE(161);
      if (lookahead == 'o') ADVANCE(162);
      if (lookahead == 's') ADVANCE(163);
      END_STATE();
    case 85:
      if (lookahead == 'r') ADVANCE(164);
      END_STATE();
    case 86:
      if (lookahead == 't') ADVANCE(165);
      END_STATE();
    case 87:
      if (lookahead == 'r') ADVANCE(166);
      END_STATE();
    case 88:
      if (lookahead == 'a') ADVANCE(167);
      END_STATE();
    case 89:
      if (lookahead == 'h') ADVANCE(168);
      END_STATE();
    case 90:
      if (lookahead == 'n') ADVANCE(169);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 92:
      if (lookahead == 'U') ADVANCE(170);
      END_STATE();
    case 93:
      if (lookahead == 'e') ADVANCE(171);
      END_STATE();
    case 94:
      if (lookahead == 'e') ADVANCE(172);
      END_STATE();
    case 95:
      if (lookahead == 'a') ADVANCE(173);
      END_STATE();
    case 96:
      if (lookahead == 'l') ADVANCE(174);
      END_STATE();
    case 97:
      if (lookahead == 'e') ADVANCE(175);
      END_STATE();
    case 98:
      if (lookahead == 's') ADVANCE(176);
      END_STATE();
    case 99:
      if (lookahead == 'p') ADVANCE(177);
      END_STATE();
    case 100:
      if (lookahead == 'a') ADVANCE(178);
      if (lookahead == 'e') ADVANCE(179);
      END_STATE();
    case 101:
      if (lookahead == 'T') ADVANCE(180);
      END_STATE();
    case 102:
      if (lookahead == 'i') ADVANCE(181);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_def);
      END_STATE();
    case 104:
      if (lookahead == 'e') ADVANCE(182);
      END_STATE();
    case 105:
      if (lookahead == 'b') ADVANCE(183);
      END_STATE();
    case 106:
      if (lookahead == 'a') ADVANCE(184);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_end);
      END_STATE();
    case 108:
      if (lookahead == 'i') ADVANCE(185);
      END_STATE();
    case 109:
      if (lookahead == 'm') ADVANCE(186);
      END_STATE();
    case 110:
      if (lookahead == 'n') ADVANCE(187);
      END_STATE();
    case 111:
      if (lookahead == 's') ADVANCE(188);
      END_STATE();
    case 112:
      if (lookahead == 'l') ADVANCE(189);
      END_STATE();
    case 113:
      if (lookahead == 's') ADVANCE(190);
      END_STATE();
    case 114:
      if (lookahead == 'e') ADVANCE(191);
      END_STATE();
    case 115:
      if (lookahead == 'a') ADVANCE(192);
      END_STATE();
    case 116:
      if (lookahead == 'a') ADVANCE(193);
      END_STATE();
    case 117:
      if (lookahead == 'c') ADVANCE(194);
      END_STATE();
    case 118:
      if (lookahead == 'm') ADVANCE(195);
      END_STATE();
    case 119:
      if (lookahead == 'y') ADVANCE(196);
      END_STATE();
    case 120:
      if (lookahead == 'n') ADVANCE(197);
      END_STATE();
    case 121:
      if (lookahead == 'a') ADVANCE(198);
      END_STATE();
    case 122:
      if (lookahead == 'B') ADVANCE(199);
      END_STATE();
    case 123:
      if (lookahead == 'n') ADVANCE(200);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_iff);
      END_STATE();
    case 125:
      if (lookahead == 'l') ADVANCE(201);
      if (lookahead == 'o') ADVANCE(202);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_int);
      if (lookahead == 'e') ADVANCE(203);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_iri);
      END_STATE();
    case 128:
      if (lookahead == 'g') ADVANCE(204);
      END_STATE();
    case 129:
      if (lookahead == 'g') ADVANCE(205);
      END_STATE();
    case 130:
      if (lookahead == 'g') ADVANCE(206);
      END_STATE();
    case 131:
      if (lookahead == 'E') ADVANCE(207);
      if (lookahead == 'I') ADVANCE(208);
      if (lookahead == 'L') ADVANCE(209);
      END_STATE();
    case 132:
      if (lookahead == 'E') ADVANCE(210);
      if (lookahead == 'I') ADVANCE(211);
      if (lookahead == 'L') ADVANCE(212);
      END_STATE();
    case 133:
      if (lookahead == 'u') ADVANCE(213);
      END_STATE();
    case 134:
      if (lookahead == 'a') ADVANCE(214);
      END_STATE();
    case 135:
      if (lookahead == 'N') ADVANCE(215);
      if (lookahead == 'P') ADVANCE(216);
      if (lookahead == 'u') ADVANCE(217);
      END_STATE();
    case 136:
      if (lookahead == 'm') ADVANCE(218);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_not);
      END_STATE();
    case 138:
      if (lookahead == 'q') ADVANCE(219);
      END_STATE();
    case 139:
      if (lookahead == 'i') ADVANCE(220);
      END_STATE();
    case 140:
      if (lookahead == 'e') ADVANCE(221);
      END_STATE();
    case 141:
      if (lookahead == 'e') ADVANCE(222);
      END_STATE();
    case 142:
      if (lookahead == 't') ADVANCE(223);
      END_STATE();
    case 143:
      if (lookahead == 'i') ADVANCE(224);
      END_STATE();
    case 144:
      if (lookahead == 'h') ADVANCE(225);
      if (lookahead == 'p') ADVANCE(226);
      END_STATE();
    case 145:
      if (lookahead == 'i') ADVANCE(227);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_rdf);
      END_STATE();
    case 147:
      if (lookahead == 'l') ADVANCE(228);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_ref);
      END_STATE();
    case 149:
      if (lookahead == 'u') ADVANCE(229);
      END_STATE();
    case 150:
      if (lookahead == 'f') ADVANCE(230);
      END_STATE();
    case 151:
      if (lookahead == 'r') ADVANCE(231);
      END_STATE();
    case 152:
      if (lookahead == 'r') ADVANCE(232);
      END_STATE();
    case 153:
      if (lookahead == 'i') ADVANCE(233);
      if (lookahead == 'u') ADVANCE(234);
      END_STATE();
    case 154:
      if (lookahead == 's') ADVANCE(235);
      END_STATE();
    case 155:
      if (lookahead == 'e') ADVANCE(236);
      END_STATE();
    case 156:
      if (lookahead == 'e') ADVANCE(237);
      END_STATE();
    case 157:
      if (lookahead == 'a') ADVANCE(238);
      END_STATE();
    case 158:
      if (lookahead == 'e') ADVANCE(239);
      END_STATE();
    case 159:
      if (lookahead == 'e') ADVANCE(240);
      END_STATE();
    case 160:
      if (lookahead == 'o') ADVANCE(241);
      if (lookahead == 'q') ADVANCE(242);
      END_STATE();
    case 161:
      if (lookahead == 'n') ADVANCE(243);
      END_STATE();
    case 162:
      if (lookahead == 'r') ADVANCE(244);
      END_STATE();
    case 163:
      if (lookahead == 'i') ADVANCE(245);
      END_STATE();
    case 164:
      if (lookahead == 's') ADVANCE(246);
      END_STATE();
    case 165:
      if (lookahead == 'h') ADVANCE(247);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_xor);
      END_STATE();
    case 167:
      if (lookahead == 'r') ADVANCE(248);
      END_STATE();
    case 168:
      if (lookahead == 'i') ADVANCE(249);
      END_STATE();
    case 169:
      if (lookahead == 'g') ADVANCE(250);
      END_STATE();
    case 170:
      if (lookahead == 'R') ADVANCE(251);
      END_STATE();
    case 171:
      if (lookahead == 'r') ADVANCE(252);
      END_STATE();
    case 172:
      if (lookahead == '6') ADVANCE(253);
      END_STATE();
    case 173:
      if (lookahead == 'r') ADVANCE(254);
      END_STATE();
    case 174:
      if (lookahead == 'e') ADVANCE(255);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_byte);
      END_STATE();
    case 176:
      if (lookahead == 's') ADVANCE(256);
      END_STATE();
    case 177:
      if (lookahead == 'l') ADVANCE(257);
      END_STATE();
    case 178:
      if (lookahead == 't') ADVANCE(258);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_date);
      if (lookahead == 'T') ADVANCE(259);
      END_STATE();
    case 180:
      if (lookahead == 'i') ADVANCE(260);
      END_STATE();
    case 181:
      if (lookahead == 'm') ADVANCE(261);
      END_STATE();
    case 182:
      if (lookahead == 'n') ADVANCE(262);
      END_STATE();
    case 183:
      if (lookahead == 'l') ADVANCE(263);
      END_STATE();
    case 184:
      if (lookahead == 't') ADVANCE(264);
      END_STATE();
    case 185:
      if (lookahead == 't') ADVANCE(265);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 187:
      if (lookahead == 't') ADVANCE(266);
      END_STATE();
    case 188:
      if (lookahead == 't') ADVANCE(267);
      END_STATE();
    case 189:
      if (lookahead == 'i') ADVANCE(268);
      END_STATE();
    case 190:
      if (lookahead == 'e') ADVANCE(269);
      END_STATE();
    case 191:
      if (lookahead == 'd') ADVANCE(270);
      END_STATE();
    case 192:
      if (lookahead == 't') ADVANCE(271);
      END_STATE();
    case 193:
      if (lookahead == 'l') ADVANCE(272);
      END_STATE();
    case 194:
      if (lookahead == 't') ADVANCE(273);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_gDay);
      END_STATE();
    case 197:
      if (lookahead == 't') ADVANCE(274);
      END_STATE();
    case 198:
      if (lookahead == 'r') ADVANCE(275);
      END_STATE();
    case 199:
      if (lookahead == 'i') ADVANCE(276);
      END_STATE();
    case 200:
      if (lookahead == 't') ADVANCE(277);
      END_STATE();
    case 201:
      if (lookahead == 'i') ADVANCE(278);
      END_STATE();
    case 202:
      if (lookahead == 'r') ADVANCE(279);
      END_STATE();
    case 203:
      if (lookahead == 'g') ADVANCE(280);
      if (lookahead == 'r') ADVANCE(281);
      END_STATE();
    case 204:
      if (lookahead == 'u') ADVANCE(282);
      END_STATE();
    case 205:
      if (lookahead == 't') ADVANCE(283);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_long);
      END_STATE();
    case 207:
      if (lookahead == 'x') ADVANCE(284);
      END_STATE();
    case 208:
      if (lookahead == 'n') ADVANCE(285);
      END_STATE();
    case 209:
      if (lookahead == 'e') ADVANCE(286);
      END_STATE();
    case 210:
      if (lookahead == 'x') ADVANCE(287);
      END_STATE();
    case 211:
      if (lookahead == 'n') ADVANCE(288);
      END_STATE();
    case 212:
      if (lookahead == 'e') ADVANCE(289);
      END_STATE();
    case 213:
      if (lookahead == 'l') ADVANCE(290);
      END_STATE();
    case 214:
      if (lookahead == 't') ADVANCE(291);
      END_STATE();
    case 215:
      if (lookahead == 'e') ADVANCE(292);
      END_STATE();
    case 216:
      if (lookahead == 'o') ADVANCE(293);
      END_STATE();
    case 217:
      if (lookahead == 'n') ADVANCE(294);
      END_STATE();
    case 218:
      if (lookahead == 'a') ADVANCE(295);
      END_STATE();
    case 219:
      if (lookahead == 'u') ADVANCE(296);
      END_STATE();
    case 220:
      if (lookahead == 'o') ADVANCE(297);
      END_STATE();
    case 221:
      if (lookahead == 'r') ADVANCE(298);
      END_STATE();
    case 222:
      if (lookahead == 'n') ADVANCE(299);
      END_STATE();
    case 223:
      if (lookahead == 'e') ADVANCE(300);
      END_STATE();
    case 224:
      if (lookahead == 't') ADVANCE(301);
      END_STATE();
    case 225:
      if (lookahead == 'i') ADVANCE(302);
      END_STATE();
    case 226:
      if (lookahead == 'e') ADVANCE(303);
      END_STATE();
    case 227:
      if (lookahead == 'o') ADVANCE(304);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(anon_sym_real);
      END_STATE();
    case 229:
      if (lookahead == 'i') ADVANCE(305);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(sym_reserved_self);
      END_STATE();
    case 231:
      if (lookahead == 't') ADVANCE(306);
      END_STATE();
    case 232:
      if (lookahead == 'c') ADVANCE(307);
      END_STATE();
    case 233:
      if (lookahead == 'n') ADVANCE(308);
      END_STATE();
    case 234:
      if (lookahead == 'c') ADVANCE(309);
      END_STATE();
    case 235:
      if (lookahead == 'e') ADVANCE(310);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(anon_sym_time);
      END_STATE();
    case 237:
      if (lookahead == 'n') ADVANCE(311);
      END_STATE();
    case 238:
      if (lookahead == 'l') ADVANCE(312);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(anon_sym_type);
      END_STATE();
    case 241:
      if (lookahead == 'n') ADVANCE(313);
      END_STATE();
    case 242:
      if (lookahead == 'u') ADVANCE(314);
      END_STATE();
    case 243:
      if (lookahead == 'o') ADVANCE(315);
      END_STATE();
    case 244:
      if (lookahead == 'd') ADVANCE(316);
      END_STATE();
    case 245:
      if (lookahead == 'g') ADVANCE(317);
      END_STATE();
    case 246:
      if (lookahead == 'i') ADVANCE(318);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 248:
      if (lookahead == 'M') ADVANCE(319);
      END_STATE();
    case 249:
      if (lookahead == 'n') ADVANCE(320);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(anon_sym_Thing);
      END_STATE();
    case 251:
      if (lookahead == 'I') ADVANCE(321);
      END_STATE();
    case 252:
      if (lookahead == 't') ADVANCE(322);
      END_STATE();
    case 253:
      if (lookahead == '4') ADVANCE(323);
      END_STATE();
    case 254:
      if (lookahead == 'y') ADVANCE(324);
      END_STATE();
    case 255:
      if (lookahead == 'a') ADVANCE(325);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 257:
      if (lookahead == 'e') ADVANCE(326);
      END_STATE();
    case 258:
      if (lookahead == 'y') ADVANCE(327);
      END_STATE();
    case 259:
      if (lookahead == 'i') ADVANCE(328);
      END_STATE();
    case 260:
      if (lookahead == 'm') ADVANCE(329);
      END_STATE();
    case 261:
      if (lookahead == 'a') ADVANCE(330);
      END_STATE();
    case 262:
      if (lookahead == 's') ADVANCE(331);
      END_STATE();
    case 263:
      if (lookahead == 'e') ADVANCE(332);
      END_STATE();
    case 264:
      if (lookahead == 'i') ADVANCE(333);
      END_STATE();
    case 265:
      if (lookahead == 'y') ADVANCE(334);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(anon_sym_event);
      END_STATE();
    case 267:
      if (lookahead == 's') ADVANCE(335);
      END_STATE();
    case 268:
      if (lookahead == 'c') ADVANCE(336);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(sym_kw_is_fixed);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(anon_sym_float);
      END_STATE();
    case 272:
      if (lookahead == 'l') ADVANCE(337);
      END_STATE();
    case 273:
      if (lookahead == 'i') ADVANCE(338);
      END_STATE();
    case 274:
      if (lookahead == 'h') ADVANCE(339);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(anon_sym_gYear);
      if (lookahead == 'M') ADVANCE(340);
      END_STATE();
    case 276:
      if (lookahead == 'n') ADVANCE(341);
      END_STATE();
    case 277:
      if (lookahead == 'i') ADVANCE(342);
      END_STATE();
    case 278:
      if (lookahead == 'e') ADVANCE(343);
      END_STATE();
    case 279:
      if (lookahead == 't') ADVANCE(344);
      END_STATE();
    case 280:
      if (lookahead == 'e') ADVANCE(345);
      END_STATE();
    case 281:
      if (lookahead == 's') ADVANCE(346);
      END_STATE();
    case 282:
      if (lookahead == 'a') ADVANCE(347);
      END_STATE();
    case 283:
      if (lookahead == 'h') ADVANCE(348);
      END_STATE();
    case 284:
      if (lookahead == 'c') ADVANCE(349);
      END_STATE();
    case 285:
      if (lookahead == 'c') ADVANCE(350);
      END_STATE();
    case 286:
      if (lookahead == 'n') ADVANCE(351);
      END_STATE();
    case 287:
      if (lookahead == 'c') ADVANCE(352);
      END_STATE();
    case 288:
      if (lookahead == 'c') ADVANCE(353);
      END_STATE();
    case 289:
      if (lookahead == 'n') ADVANCE(354);
      END_STATE();
    case 290:
      if (lookahead == 'e') ADVANCE(355);
      END_STATE();
    case 291:
      if (lookahead == 'i') ADVANCE(356);
      END_STATE();
    case 292:
      if (lookahead == 'g') ADVANCE(357);
      END_STATE();
    case 293:
      if (lookahead == 's') ADVANCE(358);
      END_STATE();
    case 294:
      if (lookahead == 'i') ADVANCE(359);
      END_STATE();
    case 295:
      if (lookahead == 'l') ADVANCE(360);
      END_STATE();
    case 296:
      if (lookahead == 'e') ADVANCE(361);
      END_STATE();
    case 297:
      if (lookahead == 'n') ADVANCE(362);
      END_STATE();
    case 298:
      if (lookahead == 'e') ADVANCE(363);
      END_STATE();
    case 299:
      if (lookahead == 't') ADVANCE(364);
      END_STATE();
    case 300:
      if (lookahead == 'r') ADVANCE(365);
      END_STATE();
    case 301:
      if (lookahead == 'i') ADVANCE(366);
      END_STATE();
    case 302:
      if (lookahead == 'b') ADVANCE(367);
      END_STATE();
    case 303:
      if (lookahead == 'r') ADVANCE(368);
      END_STATE();
    case 304:
      if (lookahead == 'n') ADVANCE(369);
      END_STATE();
    case 305:
      if (lookahead == 'r') ADVANCE(370);
      END_STATE();
    case 306:
      ACCEPT_TOKEN(anon_sym_short);
      END_STATE();
    case 307:
      if (lookahead == 'e') ADVANCE(371);
      END_STATE();
    case 308:
      if (lookahead == 'g') ADVANCE(372);
      END_STATE();
    case 309:
      if (lookahead == 't') ADVANCE(373);
      END_STATE();
    case 310:
      if (lookahead == 't') ADVANCE(374);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(anon_sym_token);
      END_STATE();
    case 312:
      if (lookahead == 'D') ADVANCE(375);
      END_STATE();
    case 313:
      ACCEPT_TOKEN(anon_sym_union);
      END_STATE();
    case 314:
      if (lookahead == 'e') ADVANCE(376);
      END_STATE();
    case 315:
      if (lookahead == 'w') ADVANCE(377);
      END_STATE();
    case 316:
      if (lookahead == 'e') ADVANCE(378);
      END_STATE();
    case 317:
      if (lookahead == 'n') ADVANCE(379);
      END_STATE();
    case 318:
      if (lookahead == 'o') ADVANCE(380);
      END_STATE();
    case 319:
      if (lookahead == 'o') ADVANCE(381);
      END_STATE();
    case 320:
      if (lookahead == 'g') ADVANCE(382);
      END_STATE();
    case 321:
      ACCEPT_TOKEN(anon_sym_anyURI);
      END_STATE();
    case 322:
      ACCEPT_TOKEN(anon_sym_assert);
      END_STATE();
    case 323:
      if (lookahead == 'B') ADVANCE(383);
      END_STATE();
    case 324:
      ACCEPT_TOKEN(anon_sym_binary);
      END_STATE();
    case 325:
      if (lookahead == 'n') ADVANCE(384);
      END_STATE();
    case 326:
      if (lookahead == 'm') ADVANCE(385);
      END_STATE();
    case 327:
      if (lookahead == 'p') ADVANCE(386);
      END_STATE();
    case 328:
      if (lookahead == 'm') ADVANCE(387);
      END_STATE();
    case 329:
      if (lookahead == 'e') ADVANCE(388);
      END_STATE();
    case 330:
      if (lookahead == 'l') ADVANCE(389);
      END_STATE();
    case 331:
      if (lookahead == 'i') ADVANCE(390);
      END_STATE();
    case 332:
      ACCEPT_TOKEN(anon_sym_double);
      END_STATE();
    case 333:
      if (lookahead == 'o') ADVANCE(391);
      END_STATE();
    case 334:
      ACCEPT_TOKEN(anon_sym_entity);
      END_STATE();
    case 335:
      ACCEPT_TOKEN(anon_sym_exists);
      END_STATE();
    case 336:
      if (lookahead == 'i') ADVANCE(392);
      END_STATE();
    case 337:
      ACCEPT_TOKEN(anon_sym_forall);
      END_STATE();
    case 338:
      if (lookahead == 'o') ADVANCE(393);
      END_STATE();
    case 339:
      ACCEPT_TOKEN(anon_sym_gMonth);
      if (lookahead == 'D') ADVANCE(394);
      END_STATE();
    case 340:
      if (lookahead == 'o') ADVANCE(395);
      END_STATE();
    case 341:
      if (lookahead == 'a') ADVANCE(396);
      END_STATE();
    case 342:
      if (lookahead == 't') ADVANCE(397);
      END_STATE();
    case 343:
      if (lookahead == 's') ADVANCE(398);
      END_STATE();
    case 344:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 345:
      if (lookahead == 'r') ADVANCE(399);
      END_STATE();
    case 346:
      if (lookahead == 'e') ADVANCE(400);
      END_STATE();
    case 347:
      if (lookahead == 'g') ADVANCE(401);
      END_STATE();
    case 348:
      ACCEPT_TOKEN(anon_sym_length);
      END_STATE();
    case 349:
      if (lookahead == 'l') ADVANCE(402);
      END_STATE();
    case 350:
      if (lookahead == 'l') ADVANCE(403);
      END_STATE();
    case 351:
      if (lookahead == 'g') ADVANCE(404);
      END_STATE();
    case 352:
      if (lookahead == 'l') ADVANCE(405);
      END_STATE();
    case 353:
      if (lookahead == 'l') ADVANCE(406);
      END_STATE();
    case 354:
      if (lookahead == 'g') ADVANCE(407);
      END_STATE();
    case 355:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 356:
      if (lookahead == 'v') ADVANCE(408);
      END_STATE();
    case 357:
      if (lookahead == 'a') ADVANCE(409);
      END_STATE();
    case 358:
      if (lookahead == 'i') ADVANCE(410);
      END_STATE();
    case 359:
      if (lookahead == 'q') ADVANCE(411);
      END_STATE();
    case 360:
      if (lookahead == 'i') ADVANCE(412);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(sym_opaque);
      END_STATE();
    case 362:
      if (lookahead == 'a') ADVANCE(413);
      END_STATE();
    case 363:
      if (lookahead == 'd') ADVANCE(414);
      END_STATE();
    case 364:
      ACCEPT_TOKEN(anon_sym_parent);
      END_STATE();
    case 365:
      if (lookahead == 'n') ADVANCE(415);
      END_STATE();
    case 366:
      if (lookahead == 'v') ADVANCE(416);
      END_STATE();
    case 367:
      if (lookahead == 'i') ADVANCE(417);
      END_STATE();
    case 368:
      if (lookahead == 't') ADVANCE(418);
      END_STATE();
    case 369:
      if (lookahead == 'a') ADVANCE(419);
      END_STATE();
    case 370:
      if (lookahead == 'e') ADVANCE(420);
      END_STATE();
    case 371:
      ACCEPT_TOKEN(anon_sym_source);
      END_STATE();
    case 372:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 373:
      if (lookahead == 'u') ADVANCE(421);
      END_STATE();
    case 374:
      ACCEPT_TOKEN(anon_sym_subset);
      if (lookahead == 'e') ADVANCE(422);
      END_STATE();
    case 375:
      if (lookahead == 'i') ADVANCE(423);
      END_STATE();
    case 376:
      ACCEPT_TOKEN(anon_sym_unique);
      END_STATE();
    case 377:
      if (lookahead == 'n') ADVANCE(424);
      END_STATE();
    case 378:
      if (lookahead == 'r') ADVANCE(425);
      END_STATE();
    case 379:
      if (lookahead == 'e') ADVANCE(426);
      END_STATE();
    case 380:
      if (lookahead == 'n') ADVANCE(427);
      END_STATE();
    case 381:
      if (lookahead == 'n') ADVANCE(428);
      END_STATE();
    case 382:
      ACCEPT_TOKEN(anon_sym_Nothing);
      END_STATE();
    case 383:
      if (lookahead == 'i') ADVANCE(429);
      END_STATE();
    case 384:
      ACCEPT_TOKEN(anon_sym_boolean);
      END_STATE();
    case 385:
      if (lookahead == 'e') ADVANCE(430);
      END_STATE();
    case 386:
      if (lookahead == 'e') ADVANCE(431);
      END_STATE();
    case 387:
      if (lookahead == 'e') ADVANCE(432);
      END_STATE();
    case 388:
      if (lookahead == 'D') ADVANCE(433);
      END_STATE();
    case 389:
      ACCEPT_TOKEN(anon_sym_decimal);
      END_STATE();
    case 390:
      if (lookahead == 'o') ADVANCE(434);
      END_STATE();
    case 391:
      if (lookahead == 'n') ADVANCE(435);
      END_STATE();
    case 392:
      if (lookahead == 't') ADVANCE(436);
      END_STATE();
    case 393:
      if (lookahead == 'n') ADVANCE(437);
      END_STATE();
    case 394:
      if (lookahead == 'a') ADVANCE(438);
      END_STATE();
    case 395:
      if (lookahead == 'n') ADVANCE(439);
      END_STATE();
    case 396:
      if (lookahead == 'r') ADVANCE(440);
      END_STATE();
    case 397:
      if (lookahead == 'y') ADVANCE(441);
      END_STATE();
    case 398:
      ACCEPT_TOKEN(anon_sym_implies);
      END_STATE();
    case 399:
      ACCEPT_TOKEN(anon_sym_integer);
      END_STATE();
    case 400:
      if (lookahead == 'c') ADVANCE(442);
      END_STATE();
    case 401:
      if (lookahead == 'e') ADVANCE(443);
      END_STATE();
    case 402:
      if (lookahead == 'u') ADVANCE(444);
      END_STATE();
    case 403:
      if (lookahead == 'u') ADVANCE(445);
      END_STATE();
    case 404:
      if (lookahead == 't') ADVANCE(446);
      END_STATE();
    case 405:
      if (lookahead == 'u') ADVANCE(447);
      END_STATE();
    case 406:
      if (lookahead == 'u') ADVANCE(448);
      END_STATE();
    case 407:
      if (lookahead == 't') ADVANCE(449);
      END_STATE();
    case 408:
      if (lookahead == 'e') ADVANCE(450);
      END_STATE();
    case 409:
      if (lookahead == 't') ADVANCE(451);
      END_STATE();
    case 410:
      if (lookahead == 't') ADVANCE(452);
      END_STATE();
    case 411:
      if (lookahead == 'u') ADVANCE(453);
      END_STATE();
    case 412:
      if (lookahead == 'z') ADVANCE(454);
      END_STATE();
    case 413:
      if (lookahead == 'l') ADVANCE(455);
      END_STATE();
    case 414:
      ACCEPT_TOKEN(anon_sym_ordered);
      END_STATE();
    case 415:
      ACCEPT_TOKEN(anon_sym_pattern);
      END_STATE();
    case 416:
      if (lookahead == 'e') ADVANCE(456);
      END_STATE();
    case 417:
      if (lookahead == 't') ADVANCE(457);
      END_STATE();
    case 418:
      if (lookahead == 'y') ADVANCE(458);
      END_STATE();
    case 419:
      if (lookahead == 'l') ADVANCE(459);
      END_STATE();
    case 420:
      if (lookahead == 'd') ADVANCE(460);
      END_STATE();
    case 421:
      if (lookahead == 'r') ADVANCE(461);
      END_STATE();
    case 422:
      if (lookahead == 'q') ADVANCE(462);
      END_STATE();
    case 423:
      if (lookahead == 'g') ADVANCE(463);
      END_STATE();
    case 424:
      ACCEPT_TOKEN(sym_unknown_type);
      END_STATE();
    case 425:
      if (lookahead == 'e') ADVANCE(464);
      END_STATE();
    case 426:
      if (lookahead == 'd') ADVANCE(465);
      END_STATE();
    case 427:
      ACCEPT_TOKEN(anon_sym_version);
      END_STATE();
    case 428:
      if (lookahead == 't') ADVANCE(466);
      END_STATE();
    case 429:
      if (lookahead == 'n') ADVANCE(467);
      END_STATE();
    case 430:
      if (lookahead == 'n') ADVANCE(468);
      END_STATE();
    case 431:
      ACCEPT_TOKEN(anon_sym_datatype);
      END_STATE();
    case 432:
      ACCEPT_TOKEN(anon_sym_dateTime);
      if (lookahead == 'S') ADVANCE(469);
      END_STATE();
    case 433:
      if (lookahead == 'u') ADVANCE(470);
      END_STATE();
    case 434:
      if (lookahead == 'n') ADVANCE(471);
      END_STATE();
    case 435:
      ACCEPT_TOKEN(anon_sym_duration);
      END_STATE();
    case 436:
      if (lookahead == 'T') ADVANCE(472);
      END_STATE();
    case 437:
      if (lookahead == 'D') ADVANCE(473);
      END_STATE();
    case 438:
      if (lookahead == 'y') ADVANCE(474);
      END_STATE();
    case 439:
      if (lookahead == 't') ADVANCE(475);
      END_STATE();
    case 440:
      if (lookahead == 'y') ADVANCE(476);
      END_STATE();
    case 441:
      ACCEPT_TOKEN(anon_sym_identity);
      END_STATE();
    case 442:
      if (lookahead == 't') ADVANCE(477);
      END_STATE();
    case 443:
      ACCEPT_TOKEN(anon_sym_language);
      END_STATE();
    case 444:
      if (lookahead == 's') ADVANCE(478);
      END_STATE();
    case 445:
      if (lookahead == 's') ADVANCE(479);
      END_STATE();
    case 446:
      if (lookahead == 'h') ADVANCE(480);
      END_STATE();
    case 447:
      if (lookahead == 's') ADVANCE(481);
      END_STATE();
    case 448:
      if (lookahead == 's') ADVANCE(482);
      END_STATE();
    case 449:
      if (lookahead == 'h') ADVANCE(483);
      END_STATE();
    case 450:
      if (lookahead == 'I') ADVANCE(484);
      END_STATE();
    case 451:
      if (lookahead == 'i') ADVANCE(485);
      END_STATE();
    case 452:
      if (lookahead == 'i') ADVANCE(486);
      END_STATE();
    case 453:
      if (lookahead == 'e') ADVANCE(487);
      END_STATE();
    case 454:
      if (lookahead == 'e') ADVANCE(488);
      END_STATE();
    case 455:
      ACCEPT_TOKEN(anon_sym_optional);
      END_STATE();
    case 456:
      if (lookahead == 'I') ADVANCE(489);
      END_STATE();
    case 457:
      if (lookahead == 'e') ADVANCE(490);
      END_STATE();
    case 458:
      ACCEPT_TOKEN(anon_sym_property);
      END_STATE();
    case 459:
      ACCEPT_TOKEN(anon_sym_rational);
      END_STATE();
    case 460:
      ACCEPT_TOKEN(anon_sym_required);
      END_STATE();
    case 461:
      if (lookahead == 'e') ADVANCE(491);
      END_STATE();
    case 462:
      ACCEPT_TOKEN(anon_sym_subseteq);
      END_STATE();
    case 463:
      if (lookahead == 'i') ADVANCE(492);
      END_STATE();
    case 464:
      if (lookahead == 'd') ADVANCE(493);
      END_STATE();
    case 465:
      ACCEPT_TOKEN(anon_sym_unsigned);
      if (lookahead == 'B') ADVANCE(494);
      if (lookahead == 'I') ADVANCE(495);
      if (lookahead == 'L') ADVANCE(496);
      if (lookahead == 'S') ADVANCE(497);
      END_STATE();
    case 466:
      if (lookahead == 'h') ADVANCE(498);
      END_STATE();
    case 467:
      if (lookahead == 'a') ADVANCE(499);
      END_STATE();
    case 468:
      if (lookahead == 't') ADVANCE(500);
      END_STATE();
    case 469:
      if (lookahead == 't') ADVANCE(501);
      END_STATE();
    case 470:
      if (lookahead == 'r') ADVANCE(502);
      END_STATE();
    case 471:
      ACCEPT_TOKEN(anon_sym_dimension);
      END_STATE();
    case 472:
      if (lookahead == 'i') ADVANCE(503);
      END_STATE();
    case 473:
      if (lookahead == 'i') ADVANCE(504);
      END_STATE();
    case 474:
      ACCEPT_TOKEN(anon_sym_gMonthDay);
      END_STATE();
    case 475:
      if (lookahead == 'h') ADVANCE(505);
      END_STATE();
    case 476:
      ACCEPT_TOKEN(anon_sym_hexBinary);
      END_STATE();
    case 477:
      if (lookahead == 'i') ADVANCE(506);
      END_STATE();
    case 478:
      if (lookahead == 'i') ADVANCE(507);
      END_STATE();
    case 479:
      if (lookahead == 'i') ADVANCE(508);
      END_STATE();
    case 480:
      ACCEPT_TOKEN(anon_sym_maxLength);
      END_STATE();
    case 481:
      if (lookahead == 'i') ADVANCE(509);
      END_STATE();
    case 482:
      if (lookahead == 'i') ADVANCE(510);
      END_STATE();
    case 483:
      ACCEPT_TOKEN(anon_sym_minLength);
      END_STATE();
    case 484:
      if (lookahead == 'n') ADVANCE(511);
      END_STATE();
    case 485:
      if (lookahead == 'v') ADVANCE(512);
      END_STATE();
    case 486:
      if (lookahead == 'v') ADVANCE(513);
      END_STATE();
    case 487:
      ACCEPT_TOKEN(anon_sym_nonunique);
      END_STATE();
    case 488:
      if (lookahead == 'd') ADVANCE(514);
      END_STATE();
    case 489:
      if (lookahead == 'n') ADVANCE(515);
      END_STATE();
    case 490:
      if (lookahead == 'd') ADVANCE(516);
      END_STATE();
    case 491:
      ACCEPT_TOKEN(anon_sym_structure);
      END_STATE();
    case 492:
      if (lookahead == 't') ADVANCE(517);
      END_STATE();
    case 493:
      ACCEPT_TOKEN(anon_sym_unordered);
      END_STATE();
    case 494:
      if (lookahead == 'y') ADVANCE(518);
      END_STATE();
    case 495:
      if (lookahead == 'n') ADVANCE(519);
      END_STATE();
    case 496:
      if (lookahead == 'o') ADVANCE(520);
      END_STATE();
    case 497:
      if (lookahead == 'h') ADVANCE(521);
      END_STATE();
    case 498:
      if (lookahead == 'D') ADVANCE(522);
      END_STATE();
    case 499:
      if (lookahead == 'r') ADVANCE(523);
      END_STATE();
    case 500:
      ACCEPT_TOKEN(anon_sym_complement);
      END_STATE();
    case 501:
      if (lookahead == 'a') ADVANCE(524);
      END_STATE();
    case 502:
      if (lookahead == 'a') ADVANCE(525);
      END_STATE();
    case 503:
      if (lookahead == 'm') ADVANCE(526);
      END_STATE();
    case 504:
      if (lookahead == 'g') ADVANCE(527);
      END_STATE();
    case 505:
      ACCEPT_TOKEN(anon_sym_gYearMonth);
      END_STATE();
    case 506:
      if (lookahead == 'o') ADVANCE(528);
      END_STATE();
    case 507:
      if (lookahead == 'v') ADVANCE(529);
      END_STATE();
    case 508:
      if (lookahead == 'v') ADVANCE(530);
      END_STATE();
    case 509:
      if (lookahead == 'v') ADVANCE(531);
      END_STATE();
    case 510:
      if (lookahead == 'v') ADVANCE(532);
      END_STATE();
    case 511:
      if (lookahead == 't') ADVANCE(533);
      END_STATE();
    case 512:
      if (lookahead == 'e') ADVANCE(534);
      END_STATE();
    case 513:
      if (lookahead == 'e') ADVANCE(535);
      END_STATE();
    case 514:
      if (lookahead == 'S') ADVANCE(536);
      END_STATE();
    case 515:
      if (lookahead == 't') ADVANCE(537);
      END_STATE();
    case 516:
      ACCEPT_TOKEN(anon_sym_prohibited);
      END_STATE();
    case 517:
      if (lookahead == 's') ADVANCE(538);
      END_STATE();
    case 518:
      if (lookahead == 't') ADVANCE(539);
      END_STATE();
    case 519:
      if (lookahead == 't') ADVANCE(540);
      END_STATE();
    case 520:
      if (lookahead == 'n') ADVANCE(541);
      END_STATE();
    case 521:
      if (lookahead == 'o') ADVANCE(542);
      END_STATE();
    case 522:
      if (lookahead == 'u') ADVANCE(543);
      END_STATE();
    case 523:
      if (lookahead == 'y') ADVANCE(544);
      END_STATE();
    case 524:
      if (lookahead == 'm') ADVANCE(545);
      END_STATE();
    case 525:
      if (lookahead == 't') ADVANCE(546);
      END_STATE();
    case 526:
      if (lookahead == 'e') ADVANCE(547);
      END_STATE();
    case 527:
      if (lookahead == 'i') ADVANCE(548);
      END_STATE();
    case 528:
      if (lookahead == 'n') ADVANCE(549);
      END_STATE();
    case 529:
      if (lookahead == 'e') ADVANCE(550);
      END_STATE();
    case 530:
      if (lookahead == 'e') ADVANCE(551);
      END_STATE();
    case 531:
      if (lookahead == 'e') ADVANCE(552);
      END_STATE();
    case 532:
      if (lookahead == 'e') ADVANCE(553);
      END_STATE();
    case 533:
      if (lookahead == 'e') ADVANCE(554);
      END_STATE();
    case 534:
      if (lookahead == 'I') ADVANCE(555);
      END_STATE();
    case 535:
      if (lookahead == 'I') ADVANCE(556);
      END_STATE();
    case 536:
      if (lookahead == 't') ADVANCE(557);
      END_STATE();
    case 537:
      if (lookahead == 'e') ADVANCE(558);
      END_STATE();
    case 538:
      ACCEPT_TOKEN(anon_sym_totalDigits);
      END_STATE();
    case 539:
      if (lookahead == 'e') ADVANCE(559);
      END_STATE();
    case 540:
      ACCEPT_TOKEN(anon_sym_unsignedInt);
      END_STATE();
    case 541:
      if (lookahead == 'g') ADVANCE(560);
      END_STATE();
    case 542:
      if (lookahead == 'r') ADVANCE(561);
      END_STATE();
    case 543:
      if (lookahead == 'r') ADVANCE(562);
      END_STATE();
    case 544:
      ACCEPT_TOKEN(anon_sym_base64Binary);
      END_STATE();
    case 545:
      if (lookahead == 'p') ADVANCE(563);
      END_STATE();
    case 546:
      if (lookahead == 'i') ADVANCE(564);
      END_STATE();
    case 547:
      if (lookahead == 'z') ADVANCE(565);
      END_STATE();
    case 548:
      if (lookahead == 't') ADVANCE(566);
      END_STATE();
    case 549:
      ACCEPT_TOKEN(anon_sym_intersection);
      END_STATE();
    case 550:
      ACCEPT_TOKEN(anon_sym_maxExclusive);
      END_STATE();
    case 551:
      ACCEPT_TOKEN(anon_sym_maxInclusive);
      END_STATE();
    case 552:
      ACCEPT_TOKEN(anon_sym_minExclusive);
      END_STATE();
    case 553:
      ACCEPT_TOKEN(anon_sym_minInclusive);
      END_STATE();
    case 554:
      if (lookahead == 'g') ADVANCE(567);
      END_STATE();
    case 555:
      if (lookahead == 'n') ADVANCE(568);
      END_STATE();
    case 556:
      if (lookahead == 'n') ADVANCE(569);
      END_STATE();
    case 557:
      if (lookahead == 'r') ADVANCE(570);
      END_STATE();
    case 558:
      if (lookahead == 'g') ADVANCE(571);
      END_STATE();
    case 559:
      ACCEPT_TOKEN(anon_sym_unsignedByte);
      END_STATE();
    case 560:
      ACCEPT_TOKEN(anon_sym_unsignedLong);
      END_STATE();
    case 561:
      if (lookahead == 't') ADVANCE(572);
      END_STATE();
    case 562:
      if (lookahead == 'a') ADVANCE(573);
      END_STATE();
    case 563:
      ACCEPT_TOKEN(anon_sym_dateTimeStamp);
      END_STATE();
    case 564:
      if (lookahead == 'o') ADVANCE(574);
      END_STATE();
    case 565:
      if (lookahead == 'o') ADVANCE(575);
      END_STATE();
    case 566:
      if (lookahead == 's') ADVANCE(576);
      END_STATE();
    case 567:
      if (lookahead == 'e') ADVANCE(577);
      END_STATE();
    case 568:
      if (lookahead == 't') ADVANCE(578);
      END_STATE();
    case 569:
      if (lookahead == 't') ADVANCE(579);
      END_STATE();
    case 570:
      if (lookahead == 'i') ADVANCE(580);
      END_STATE();
    case 571:
      if (lookahead == 'e') ADVANCE(581);
      END_STATE();
    case 572:
      ACCEPT_TOKEN(anon_sym_unsignedShort);
      END_STATE();
    case 573:
      if (lookahead == 't') ADVANCE(582);
      END_STATE();
    case 574:
      if (lookahead == 'n') ADVANCE(583);
      END_STATE();
    case 575:
      if (lookahead == 'n') ADVANCE(584);
      END_STATE();
    case 576:
      ACCEPT_TOKEN(anon_sym_fractionDigits);
      END_STATE();
    case 577:
      if (lookahead == 'r') ADVANCE(585);
      END_STATE();
    case 578:
      if (lookahead == 'e') ADVANCE(586);
      END_STATE();
    case 579:
      if (lookahead == 'e') ADVANCE(587);
      END_STATE();
    case 580:
      if (lookahead == 'n') ADVANCE(588);
      END_STATE();
    case 581:
      if (lookahead == 'r') ADVANCE(589);
      END_STATE();
    case 582:
      if (lookahead == 'i') ADVANCE(590);
      END_STATE();
    case 583:
      ACCEPT_TOKEN(anon_sym_dayTimeDuration);
      END_STATE();
    case 584:
      if (lookahead == 'e') ADVANCE(591);
      END_STATE();
    case 585:
      ACCEPT_TOKEN(anon_sym_negativeInteger);
      END_STATE();
    case 586:
      if (lookahead == 'g') ADVANCE(592);
      END_STATE();
    case 587:
      if (lookahead == 'g') ADVANCE(593);
      END_STATE();
    case 588:
      if (lookahead == 'g') ADVANCE(594);
      END_STATE();
    case 589:
      ACCEPT_TOKEN(anon_sym_positiveInteger);
      END_STATE();
    case 590:
      if (lookahead == 'o') ADVANCE(595);
      END_STATE();
    case 591:
      ACCEPT_TOKEN(anon_sym_explicitTimezone);
      END_STATE();
    case 592:
      if (lookahead == 'e') ADVANCE(596);
      END_STATE();
    case 593:
      if (lookahead == 'e') ADVANCE(597);
      END_STATE();
    case 594:
      ACCEPT_TOKEN(anon_sym_normalizedString);
      END_STATE();
    case 595:
      if (lookahead == 'n') ADVANCE(598);
      END_STATE();
    case 596:
      if (lookahead == 'r') ADVANCE(599);
      END_STATE();
    case 597:
      if (lookahead == 'r') ADVANCE(600);
      END_STATE();
    case 598:
      ACCEPT_TOKEN(anon_sym_yearMonthDuration);
      END_STATE();
    case 599:
      ACCEPT_TOKEN(anon_sym_nonNegativeInteger);
      END_STATE();
    case 600:
      ACCEPT_TOKEN(anon_sym_nonPositiveInteger);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 6},
  [2] = {.lex_state = 6},
  [3] = {.lex_state = 6},
  [4] = {.lex_state = 9},
  [5] = {.lex_state = 6},
  [6] = {.lex_state = 6},
  [7] = {.lex_state = 6},
  [8] = {.lex_state = 6},
  [9] = {.lex_state = 6},
  [10] = {.lex_state = 6},
  [11] = {.lex_state = 6},
  [12] = {.lex_state = 6},
  [13] = {.lex_state = 6},
  [14] = {.lex_state = 6},
  [15] = {.lex_state = 6},
  [16] = {.lex_state = 6},
  [17] = {.lex_state = 6},
  [18] = {.lex_state = 6},
  [19] = {.lex_state = 6},
  [20] = {.lex_state = 1},
  [21] = {.lex_state = 1},
  [22] = {.lex_state = 1},
  [23] = {.lex_state = 1},
  [24] = {.lex_state = 1},
  [25] = {.lex_state = 1},
  [26] = {.lex_state = 6},
  [27] = {.lex_state = 1},
  [28] = {.lex_state = 1},
  [29] = {.lex_state = 1},
  [30] = {.lex_state = 1},
  [31] = {.lex_state = 1},
  [32] = {.lex_state = 1},
  [33] = {.lex_state = 6},
  [34] = {.lex_state = 6},
  [35] = {.lex_state = 6},
  [36] = {.lex_state = 6},
  [37] = {.lex_state = 6},
  [38] = {.lex_state = 6},
  [39] = {.lex_state = 6},
  [40] = {.lex_state = 6},
  [41] = {.lex_state = 6},
  [42] = {.lex_state = 6},
  [43] = {.lex_state = 6},
  [44] = {.lex_state = 6},
  [45] = {.lex_state = 6},
  [46] = {.lex_state = 1},
  [47] = {.lex_state = 1},
  [48] = {.lex_state = 1},
  [49] = {.lex_state = 1},
  [50] = {.lex_state = 1},
  [51] = {.lex_state = 1},
  [52] = {.lex_state = 1},
  [53] = {.lex_state = 1},
  [54] = {.lex_state = 1},
  [55] = {.lex_state = 1},
  [56] = {.lex_state = 1},
  [57] = {.lex_state = 1},
  [58] = {.lex_state = 1},
  [59] = {.lex_state = 1},
  [60] = {.lex_state = 6},
  [61] = {.lex_state = 6},
  [62] = {.lex_state = 1},
  [63] = {.lex_state = 6},
  [64] = {.lex_state = 1},
  [65] = {.lex_state = 1},
  [66] = {.lex_state = 6},
  [67] = {.lex_state = 1},
  [68] = {.lex_state = 1},
  [69] = {.lex_state = 1},
  [70] = {.lex_state = 1},
  [71] = {.lex_state = 6},
  [72] = {.lex_state = 1},
  [73] = {.lex_state = 6},
  [74] = {.lex_state = 6},
  [75] = {.lex_state = 1},
  [76] = {.lex_state = 1},
  [77] = {.lex_state = 1},
  [78] = {.lex_state = 1},
  [79] = {.lex_state = 1},
  [80] = {.lex_state = 1},
  [81] = {.lex_state = 1},
  [82] = {.lex_state = 6},
  [83] = {.lex_state = 6},
  [84] = {.lex_state = 6},
  [85] = {.lex_state = 6},
  [86] = {.lex_state = 6},
  [87] = {.lex_state = 6},
  [88] = {.lex_state = 6},
  [89] = {.lex_state = 6},
  [90] = {.lex_state = 6},
  [91] = {.lex_state = 6},
  [92] = {.lex_state = 6},
  [93] = {.lex_state = 6},
  [94] = {.lex_state = 6},
  [95] = {.lex_state = 6},
  [96] = {.lex_state = 6},
  [97] = {.lex_state = 1},
  [98] = {.lex_state = 1},
  [99] = {.lex_state = 1},
  [100] = {.lex_state = 1},
  [101] = {.lex_state = 1},
  [102] = {.lex_state = 6},
  [103] = {.lex_state = 1},
  [104] = {.lex_state = 6},
  [105] = {.lex_state = 1},
  [106] = {.lex_state = 1},
  [107] = {.lex_state = 1},
  [108] = {.lex_state = 1},
  [109] = {.lex_state = 1},
  [110] = {.lex_state = 1},
  [111] = {.lex_state = 1},
  [112] = {.lex_state = 1},
  [113] = {.lex_state = 6},
  [114] = {.lex_state = 6},
  [115] = {.lex_state = 6},
  [116] = {.lex_state = 1},
  [117] = {.lex_state = 1},
  [118] = {.lex_state = 1},
  [119] = {.lex_state = 1},
  [120] = {.lex_state = 2},
  [121] = {.lex_state = 1},
  [122] = {.lex_state = 6},
  [123] = {.lex_state = 6},
  [124] = {.lex_state = 6},
  [125] = {.lex_state = 1},
  [126] = {.lex_state = 1},
  [127] = {.lex_state = 6},
  [128] = {.lex_state = 1},
  [129] = {.lex_state = 1},
  [130] = {.lex_state = 1},
  [131] = {.lex_state = 1},
  [132] = {.lex_state = 1},
  [133] = {.lex_state = 1},
  [134] = {.lex_state = 6},
  [135] = {.lex_state = 1},
  [136] = {.lex_state = 1},
  [137] = {.lex_state = 6},
  [138] = {.lex_state = 6},
  [139] = {.lex_state = 6},
  [140] = {.lex_state = 6},
  [141] = {.lex_state = 6},
  [142] = {.lex_state = 6},
  [143] = {.lex_state = 6},
  [144] = {.lex_state = 1},
  [145] = {.lex_state = 1},
  [146] = {.lex_state = 1},
  [147] = {.lex_state = 1},
  [148] = {.lex_state = 1},
  [149] = {.lex_state = 1},
  [150] = {.lex_state = 1},
  [151] = {.lex_state = 1},
  [152] = {.lex_state = 20},
  [153] = {.lex_state = 1},
  [154] = {.lex_state = 1},
  [155] = {.lex_state = 1},
  [156] = {.lex_state = 6},
  [157] = {.lex_state = 6},
  [158] = {.lex_state = 6},
  [159] = {.lex_state = 1},
  [160] = {.lex_state = 6},
  [161] = {.lex_state = 1},
  [162] = {.lex_state = 6},
  [163] = {.lex_state = 6},
  [164] = {.lex_state = 6},
  [165] = {.lex_state = 1},
  [166] = {.lex_state = 6},
  [167] = {.lex_state = 6},
  [168] = {.lex_state = 6},
  [169] = {.lex_state = 1},
  [170] = {.lex_state = 6},
  [171] = {.lex_state = 6},
  [172] = {.lex_state = 1},
  [173] = {.lex_state = 1},
  [174] = {.lex_state = 6},
  [175] = {.lex_state = 1},
  [176] = {.lex_state = 6},
  [177] = {.lex_state = 6},
  [178] = {.lex_state = 1},
  [179] = {.lex_state = 6},
  [180] = {.lex_state = 6},
  [181] = {.lex_state = 6},
  [182] = {.lex_state = 6},
  [183] = {.lex_state = 1},
  [184] = {.lex_state = 6},
  [185] = {.lex_state = 6},
  [186] = {.lex_state = 1},
  [187] = {.lex_state = 1},
  [188] = {.lex_state = 6},
  [189] = {.lex_state = 6},
  [190] = {.lex_state = 6},
  [191] = {.lex_state = 6},
  [192] = {.lex_state = 6},
  [193] = {.lex_state = 6},
  [194] = {.lex_state = 6},
  [195] = {.lex_state = 6},
  [196] = {.lex_state = 6},
  [197] = {.lex_state = 1},
  [198] = {.lex_state = 1},
  [199] = {.lex_state = 6},
  [200] = {.lex_state = 1},
  [201] = {.lex_state = 6},
  [202] = {.lex_state = 6},
  [203] = {.lex_state = 6},
  [204] = {.lex_state = 6},
  [205] = {.lex_state = 6},
  [206] = {.lex_state = 6},
  [207] = {.lex_state = 6},
  [208] = {.lex_state = 6},
  [209] = {.lex_state = 1},
  [210] = {.lex_state = 6},
  [211] = {.lex_state = 6},
  [212] = {.lex_state = 6},
  [213] = {.lex_state = 6},
  [214] = {.lex_state = 6},
  [215] = {.lex_state = 6},
  [216] = {.lex_state = 6},
  [217] = {.lex_state = 6},
  [218] = {.lex_state = 6},
  [219] = {.lex_state = 1},
  [220] = {.lex_state = 6},
  [221] = {.lex_state = 6},
  [222] = {.lex_state = 6},
  [223] = {.lex_state = 6},
  [224] = {.lex_state = 6},
  [225] = {.lex_state = 6},
  [226] = {.lex_state = 6},
  [227] = {.lex_state = 6},
  [228] = {.lex_state = 6},
  [229] = {.lex_state = 6},
  [230] = {.lex_state = 6},
  [231] = {.lex_state = 6},
  [232] = {.lex_state = 6},
  [233] = {.lex_state = 6},
  [234] = {.lex_state = 6},
  [235] = {.lex_state = 6},
  [236] = {.lex_state = 6},
  [237] = {.lex_state = 6},
  [238] = {.lex_state = 6},
  [239] = {.lex_state = 6},
  [240] = {.lex_state = 6},
  [241] = {.lex_state = 6},
  [242] = {.lex_state = 6},
  [243] = {.lex_state = 6},
  [244] = {.lex_state = 6},
  [245] = {.lex_state = 6},
  [246] = {.lex_state = 6},
  [247] = {.lex_state = 6},
  [248] = {.lex_state = 6},
  [249] = {.lex_state = 6},
  [250] = {.lex_state = 6},
  [251] = {.lex_state = 6},
  [252] = {.lex_state = 6},
  [253] = {.lex_state = 6},
  [254] = {.lex_state = 6},
  [255] = {.lex_state = 6},
  [256] = {.lex_state = 6},
  [257] = {.lex_state = 6},
  [258] = {.lex_state = 6},
  [259] = {.lex_state = 6},
  [260] = {.lex_state = 6},
  [261] = {.lex_state = 6},
  [262] = {.lex_state = 6},
  [263] = {.lex_state = 6},
  [264] = {.lex_state = 6},
  [265] = {.lex_state = 6},
  [266] = {.lex_state = 6},
  [267] = {.lex_state = 6},
  [268] = {.lex_state = 6},
  [269] = {.lex_state = 6},
  [270] = {.lex_state = 6},
  [271] = {.lex_state = 6},
  [272] = {.lex_state = 6},
  [273] = {.lex_state = 6},
  [274] = {.lex_state = 6},
  [275] = {.lex_state = 6},
  [276] = {.lex_state = 6},
  [277] = {.lex_state = 6},
  [278] = {.lex_state = 6},
  [279] = {.lex_state = 6},
  [280] = {.lex_state = 6},
  [281] = {.lex_state = 6},
  [282] = {.lex_state = 6},
  [283] = {.lex_state = 6},
  [284] = {.lex_state = 6},
  [285] = {.lex_state = 6},
  [286] = {.lex_state = 6},
  [287] = {.lex_state = 6},
  [288] = {.lex_state = 6},
  [289] = {.lex_state = 6},
  [290] = {.lex_state = 6},
  [291] = {.lex_state = 6},
  [292] = {.lex_state = 6},
  [293] = {.lex_state = 6},
  [294] = {.lex_state = 6},
  [295] = {.lex_state = 6},
  [296] = {.lex_state = 6},
  [297] = {.lex_state = 6},
  [298] = {.lex_state = 6},
  [299] = {.lex_state = 6},
  [300] = {.lex_state = 6},
  [301] = {.lex_state = 6},
  [302] = {.lex_state = 6},
  [303] = {.lex_state = 6},
  [304] = {.lex_state = 6},
  [305] = {.lex_state = 6},
  [306] = {.lex_state = 6},
  [307] = {.lex_state = 6},
  [308] = {.lex_state = 6},
  [309] = {.lex_state = 6},
  [310] = {.lex_state = 6},
  [311] = {.lex_state = 6},
  [312] = {.lex_state = 6},
  [313] = {.lex_state = 6},
  [314] = {.lex_state = 6},
  [315] = {.lex_state = 6},
  [316] = {.lex_state = 6},
  [317] = {.lex_state = 6},
  [318] = {.lex_state = 6},
  [319] = {.lex_state = 6},
  [320] = {.lex_state = 6},
  [321] = {.lex_state = 6},
  [322] = {.lex_state = 6},
  [323] = {.lex_state = 6},
  [324] = {.lex_state = 6},
  [325] = {.lex_state = 6},
  [326] = {.lex_state = 6},
  [327] = {.lex_state = 6},
  [328] = {.lex_state = 6},
  [329] = {.lex_state = 6},
  [330] = {.lex_state = 6},
  [331] = {.lex_state = 6},
  [332] = {.lex_state = 6},
  [333] = {.lex_state = 6},
  [334] = {.lex_state = 6},
  [335] = {.lex_state = 6},
  [336] = {.lex_state = 6},
  [337] = {.lex_state = 6},
  [338] = {.lex_state = 6},
  [339] = {.lex_state = 6},
  [340] = {.lex_state = 6},
  [341] = {.lex_state = 6},
  [342] = {.lex_state = 6},
  [343] = {.lex_state = 6},
  [344] = {.lex_state = 6},
  [345] = {.lex_state = 6},
  [346] = {.lex_state = 6},
  [347] = {.lex_state = 6},
  [348] = {.lex_state = 6},
  [349] = {.lex_state = 6},
  [350] = {.lex_state = 6},
  [351] = {.lex_state = 6},
  [352] = {.lex_state = 6},
  [353] = {.lex_state = 6},
  [354] = {.lex_state = 6},
  [355] = {.lex_state = 6},
  [356] = {.lex_state = 6},
  [357] = {.lex_state = 6},
  [358] = {.lex_state = 6},
  [359] = {.lex_state = 6},
  [360] = {.lex_state = 6},
  [361] = {.lex_state = 6},
  [362] = {.lex_state = 6},
  [363] = {.lex_state = 1},
  [364] = {.lex_state = 6},
  [365] = {.lex_state = 6},
  [366] = {.lex_state = 6},
  [367] = {.lex_state = 6},
  [368] = {.lex_state = 6},
  [369] = {.lex_state = 6},
  [370] = {.lex_state = 6},
  [371] = {.lex_state = 6},
  [372] = {.lex_state = 6},
  [373] = {.lex_state = 6},
  [374] = {.lex_state = 6},
  [375] = {.lex_state = 6},
  [376] = {.lex_state = 6},
  [377] = {.lex_state = 6},
  [378] = {.lex_state = 6},
  [379] = {.lex_state = 6},
  [380] = {.lex_state = 6},
  [381] = {.lex_state = 6},
  [382] = {.lex_state = 6},
  [383] = {.lex_state = 6},
  [384] = {.lex_state = 6},
  [385] = {.lex_state = 6},
  [386] = {.lex_state = 6},
  [387] = {.lex_state = 6},
  [388] = {.lex_state = 6},
  [389] = {.lex_state = 6},
  [390] = {.lex_state = 6},
  [391] = {.lex_state = 6},
  [392] = {.lex_state = 6},
  [393] = {.lex_state = 6},
  [394] = {.lex_state = 6},
  [395] = {.lex_state = 6},
  [396] = {.lex_state = 6},
  [397] = {.lex_state = 6},
  [398] = {.lex_state = 6},
  [399] = {.lex_state = 6},
  [400] = {.lex_state = 6},
  [401] = {.lex_state = 6},
  [402] = {.lex_state = 6},
  [403] = {.lex_state = 6},
  [404] = {.lex_state = 6},
  [405] = {.lex_state = 6},
  [406] = {.lex_state = 6},
  [407] = {.lex_state = 6},
  [408] = {.lex_state = 6},
  [409] = {.lex_state = 6},
  [410] = {.lex_state = 6},
  [411] = {.lex_state = 6},
  [412] = {.lex_state = 6},
  [413] = {.lex_state = 6},
  [414] = {.lex_state = 6},
  [415] = {.lex_state = 6},
  [416] = {.lex_state = 6},
  [417] = {.lex_state = 6},
  [418] = {.lex_state = 6},
  [419] = {.lex_state = 0},
  [420] = {.lex_state = 6},
  [421] = {.lex_state = 6},
  [422] = {.lex_state = 6},
  [423] = {.lex_state = 6},
  [424] = {.lex_state = 6},
  [425] = {.lex_state = 6},
  [426] = {.lex_state = 6},
  [427] = {.lex_state = 6},
  [428] = {.lex_state = 6},
  [429] = {.lex_state = 6},
  [430] = {.lex_state = 6},
  [431] = {.lex_state = 6},
  [432] = {.lex_state = 6},
  [433] = {.lex_state = 6},
  [434] = {.lex_state = 6},
  [435] = {.lex_state = 6},
  [436] = {.lex_state = 6},
  [437] = {.lex_state = 6},
  [438] = {.lex_state = 6},
  [439] = {.lex_state = 6},
  [440] = {.lex_state = 6},
  [441] = {.lex_state = 6},
  [442] = {.lex_state = 6},
  [443] = {.lex_state = 6},
  [444] = {.lex_state = 6},
  [445] = {.lex_state = 6},
  [446] = {.lex_state = 9},
  [447] = {.lex_state = 6},
  [448] = {.lex_state = 6},
  [449] = {.lex_state = 6},
  [450] = {.lex_state = 1},
  [451] = {.lex_state = 6},
  [452] = {.lex_state = 6},
  [453] = {.lex_state = 6},
  [454] = {.lex_state = 0},
  [455] = {.lex_state = 0},
  [456] = {.lex_state = 6},
  [457] = {.lex_state = 6},
  [458] = {.lex_state = 6},
  [459] = {.lex_state = 0},
  [460] = {.lex_state = 6},
  [461] = {.lex_state = 6},
  [462] = {.lex_state = 6},
  [463] = {.lex_state = 6},
  [464] = {.lex_state = 6},
  [465] = {.lex_state = 6},
  [466] = {.lex_state = 6},
  [467] = {.lex_state = 6},
  [468] = {.lex_state = 6},
  [469] = {.lex_state = 6},
  [470] = {.lex_state = 6},
  [471] = {.lex_state = 6},
  [472] = {.lex_state = 6},
  [473] = {.lex_state = 6},
  [474] = {.lex_state = 6},
  [475] = {.lex_state = 6},
  [476] = {.lex_state = 0},
  [477] = {.lex_state = 6},
  [478] = {.lex_state = 6},
  [479] = {.lex_state = 6},
  [480] = {.lex_state = 6},
  [481] = {.lex_state = 6},
  [482] = {.lex_state = 6},
  [483] = {.lex_state = 6},
  [484] = {.lex_state = 6},
  [485] = {.lex_state = 22},
  [486] = {.lex_state = 2},
  [487] = {.lex_state = 6},
  [488] = {.lex_state = 6},
  [489] = {.lex_state = 0},
  [490] = {.lex_state = 6},
  [491] = {.lex_state = 6},
  [492] = {.lex_state = 0},
  [493] = {.lex_state = 6},
  [494] = {.lex_state = 6},
  [495] = {.lex_state = 6},
  [496] = {.lex_state = 6},
  [497] = {.lex_state = 6},
  [498] = {.lex_state = 0},
  [499] = {.lex_state = 6},
  [500] = {.lex_state = 0},
  [501] = {.lex_state = 2},
  [502] = {.lex_state = 9},
  [503] = {.lex_state = 2},
  [504] = {.lex_state = 0},
  [505] = {.lex_state = 6},
  [506] = {.lex_state = 6},
  [507] = {.lex_state = 22},
  [508] = {.lex_state = 6},
  [509] = {.lex_state = 6},
  [510] = {.lex_state = 6},
  [511] = {.lex_state = 22},
  [512] = {.lex_state = 6},
  [513] = {.lex_state = 6},
  [514] = {.lex_state = 20},
  [515] = {.lex_state = 2},
  [516] = {.lex_state = 22},
  [517] = {.lex_state = 22},
  [518] = {.lex_state = 1},
  [519] = {.lex_state = 2},
  [520] = {.lex_state = 6},
  [521] = {.lex_state = 6},
  [522] = {.lex_state = 2},
  [523] = {.lex_state = 6},
  [524] = {.lex_state = 6},
  [525] = {.lex_state = 6},
  [526] = {.lex_state = 0},
  [527] = {.lex_state = 6},
  [528] = {.lex_state = 0},
  [529] = {.lex_state = 6},
  [530] = {.lex_state = 0},
  [531] = {.lex_state = 6},
  [532] = {.lex_state = 6},
  [533] = {.lex_state = 6},
  [534] = {.lex_state = 6},
  [535] = {.lex_state = 1},
  [536] = {.lex_state = 6},
  [537] = {.lex_state = 0},
  [538] = {.lex_state = 6},
  [539] = {.lex_state = 22},
  [540] = {.lex_state = 6},
  [541] = {.lex_state = 6},
  [542] = {.lex_state = 6},
  [543] = {.lex_state = 6},
  [544] = {.lex_state = 6},
  [545] = {.lex_state = 6},
  [546] = {.lex_state = 0},
  [547] = {.lex_state = 6},
  [548] = {.lex_state = 0},
  [549] = {.lex_state = 6},
  [550] = {.lex_state = 6},
  [551] = {.lex_state = 6},
  [552] = {.lex_state = 0},
  [553] = {.lex_state = 0},
  [554] = {.lex_state = 6},
  [555] = {.lex_state = 6},
  [556] = {.lex_state = 6},
  [557] = {.lex_state = 0},
  [558] = {.lex_state = 0},
  [559] = {.lex_state = 0},
  [560] = {.lex_state = 0},
  [561] = {.lex_state = 0},
  [562] = {.lex_state = 6},
  [563] = {.lex_state = 0},
  [564] = {.lex_state = 0},
  [565] = {.lex_state = 0},
  [566] = {.lex_state = 6},
  [567] = {.lex_state = 6},
  [568] = {.lex_state = 6},
  [569] = {.lex_state = 6},
  [570] = {.lex_state = 0},
  [571] = {.lex_state = 0},
  [572] = {.lex_state = 6},
  [573] = {.lex_state = 6},
  [574] = {.lex_state = 0},
  [575] = {.lex_state = 6},
  [576] = {.lex_state = 6},
  [577] = {.lex_state = 0},
  [578] = {.lex_state = 6},
  [579] = {.lex_state = 0},
  [580] = {.lex_state = 0},
  [581] = {.lex_state = 6},
  [582] = {.lex_state = 6},
  [583] = {.lex_state = 0},
  [584] = {.lex_state = 6},
  [585] = {.lex_state = 0},
  [586] = {.lex_state = 0},
  [587] = {.lex_state = 6},
  [588] = {.lex_state = 0},
  [589] = {.lex_state = 6},
  [590] = {.lex_state = 6},
  [591] = {.lex_state = 0},
  [592] = {.lex_state = 0},
  [593] = {.lex_state = 1},
  [594] = {.lex_state = 0},
  [595] = {.lex_state = 6},
  [596] = {.lex_state = 6},
  [597] = {.lex_state = 6},
  [598] = {.lex_state = 6},
  [599] = {.lex_state = 6},
  [600] = {.lex_state = 1},
  [601] = {.lex_state = 6},
  [602] = {.lex_state = 0},
  [603] = {.lex_state = 6},
  [604] = {.lex_state = 6},
  [605] = {.lex_state = 6},
  [606] = {.lex_state = 6},
  [607] = {.lex_state = 6},
  [608] = {.lex_state = 0},
  [609] = {.lex_state = 6},
  [610] = {.lex_state = 6},
  [611] = {.lex_state = 6},
  [612] = {.lex_state = 6},
  [613] = {.lex_state = 0},
  [614] = {.lex_state = 0},
  [615] = {.lex_state = 0},
  [616] = {.lex_state = 0},
  [617] = {.lex_state = 0},
  [618] = {.lex_state = 0},
  [619] = {.lex_state = 0},
  [620] = {.lex_state = 118},
  [621] = {.lex_state = 0},
  [622] = {.lex_state = 118},
  [623] = {.lex_state = 0},
  [624] = {.lex_state = 0},
  [625] = {.lex_state = 0},
  [626] = {.lex_state = 0},
  [627] = {.lex_state = 6},
  [628] = {.lex_state = 0},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_version] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_end] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_COLON_COLON2] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_assert] = ACTIONS(1),
    [sym_controlled_language_tag] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [sym_reserved_self] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_def] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_Thing] = ACTIONS(1),
    [anon_sym_Nothing] = ACTIONS(1),
    [anon_sym_real] = ACTIONS(1),
    [anon_sym_rational] = ACTIONS(1),
    [anon_sym_anyURI] = ACTIONS(1),
    [anon_sym_iri] = ACTIONS(1),
    [anon_sym_base64Binary] = ACTIONS(1),
    [anon_sym_boolean] = ACTIONS(1),
    [anon_sym_date] = ACTIONS(1),
    [anon_sym_dateTime] = ACTIONS(1),
    [anon_sym_decimal] = ACTIONS(1),
    [anon_sym_double] = ACTIONS(1),
    [anon_sym_duration] = ACTIONS(1),
    [anon_sym_float] = ACTIONS(1),
    [anon_sym_gDay] = ACTIONS(1),
    [anon_sym_gMonth] = ACTIONS(1),
    [anon_sym_gMonthDay] = ACTIONS(1),
    [anon_sym_gYearMonth] = ACTIONS(1),
    [anon_sym_gYear] = ACTIONS(1),
    [anon_sym_hexBinary] = ACTIONS(1),
    [anon_sym_binary] = ACTIONS(1),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_time] = ACTIONS(1),
    [anon_sym_dateTimeStamp] = ACTIONS(1),
    [anon_sym_dayTimeDuration] = ACTIONS(1),
    [anon_sym_yearMonthDuration] = ACTIONS(1),
    [anon_sym_integer] = ACTIONS(1),
    [anon_sym_long] = ACTIONS(1),
    [anon_sym_int] = ACTIONS(1),
    [anon_sym_short] = ACTIONS(1),
    [anon_sym_byte] = ACTIONS(1),
    [anon_sym_nonNegativeInteger] = ACTIONS(1),
    [anon_sym_positiveInteger] = ACTIONS(1),
    [anon_sym_unsignedLong] = ACTIONS(1),
    [anon_sym_unsignedInt] = ACTIONS(1),
    [anon_sym_unsigned] = ACTIONS(1),
    [anon_sym_unsignedShort] = ACTIONS(1),
    [anon_sym_unsignedByte] = ACTIONS(1),
    [anon_sym_nonPositiveInteger] = ACTIONS(1),
    [anon_sym_negativeInteger] = ACTIONS(1),
    [anon_sym_normalizedString] = ACTIONS(1),
    [anon_sym_token] = ACTIONS(1),
    [anon_sym_language] = ACTIONS(1),
    [sym_quoted_string] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_POUND_LBRACK] = ACTIONS(1),
    [sym_hex_byte] = ACTIONS(1),
    [sym_double] = ACTIONS(1),
    [sym_decimal] = ACTIONS(1),
    [sym_integer] = ACTIONS(1),
    [sym_rational] = ACTIONS(1),
    [sym_unsigned] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_u22a4] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [anon_sym_u22a5] = ACTIONS(1),
    [anon_sym_datatype] = ACTIONS(1),
    [sym_opaque] = ACTIONS(1),
    [anon_sym_length] = ACTIONS(1),
    [anon_sym_maxLength] = ACTIONS(1),
    [anon_sym_minLength] = ACTIONS(1),
    [anon_sym_fractionDigits] = ACTIONS(1),
    [anon_sym_totalDigits] = ACTIONS(1),
    [anon_sym_maxExclusive] = ACTIONS(1),
    [anon_sym_maxInclusive] = ACTIONS(1),
    [anon_sym_minExclusive] = ACTIONS(1),
    [anon_sym_minInclusive] = ACTIONS(1),
    [anon_sym_explicitTimezone] = ACTIONS(1),
    [anon_sym_required] = ACTIONS(1),
    [anon_sym_prohibited] = ACTIONS(1),
    [anon_sym_optional] = ACTIONS(1),
    [anon_sym_pattern] = ACTIONS(1),
    [sym_kw_is_fixed] = ACTIONS(1),
    [anon_sym_dimension] = ACTIONS(1),
    [anon_sym_source] = ACTIONS(1),
    [anon_sym_parent] = ACTIONS(1),
    [anon_sym_entity] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_of] = ACTIONS(1),
    [anon_sym_event] = ACTIONS(1),
    [anon_sym_property] = ACTIONS(1),
    [anon_sym_structure] = ACTIONS(1),
    [anon_sym_union] = ACTIONS(1),
    [anon_sym_rdf] = ACTIONS(1),
    [anon_sym_a] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [sym_wildcard] = ACTIONS(1),
    [anon_sym_identity] = ACTIONS(1),
    [anon_sym_ref] = ACTIONS(1),
    [sym_unknown_type] = ACTIONS(1),
    [anon_sym_ordered] = ACTIONS(1),
    [anon_sym_unordered] = ACTIONS(1),
    [anon_sym_unique] = ACTIONS(1),
    [anon_sym_nonunique] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_u2260] = ACTIONS(1),
    [sym_op_less_than] = ACTIONS(1),
    [sym_op_greater_than] = ACTIONS(1),
    [anon_sym_u2264] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_u2265] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_u00ac] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_u2227] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_u2228] = ACTIONS(1),
    [anon_sym_xor] = ACTIONS(1),
    [anon_sym_u22bb] = ACTIONS(1),
    [anon_sym_implies] = ACTIONS(1),
    [anon_sym_EQ_EQ_GT] = ACTIONS(1),
    [anon_sym_u21d2] = ACTIONS(1),
    [anon_sym_iff] = ACTIONS(1),
    [anon_sym_u21d4] = ACTIONS(1),
    [anon_sym_forall] = ACTIONS(1),
    [anon_sym_u2200] = ACTIONS(1),
    [anon_sym_exists] = ACTIONS(1),
    [anon_sym_u2203] = ACTIONS(1),
    [anon_sym_u222a] = ACTIONS(1),
    [anon_sym_intersection] = ACTIONS(1),
    [anon_sym_u2229] = ACTIONS(1),
    [anon_sym_subset] = ACTIONS(1),
    [anon_sym_u2282] = ACTIONS(1),
    [anon_sym_subseteq] = ACTIONS(1),
    [anon_sym_u2286] = ACTIONS(1),
    [anon_sym_complement] = ACTIONS(1),
    [anon_sym_u2216] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_u2208] = ACTIONS(1),
    [sym_set_op_builder] = ACTIONS(1),
    [anon_sym_u00b7] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_COLON_EQ] = ACTIONS(1),
    [anon_sym_u2254] = ACTIONS(1),
    [anon_sym_u2192] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_u2190] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_u2295] = ACTIONS(1),
    [sym__value_empty_sequence] = ACTIONS(1),
    [sym_line_comment] = ACTIONS(3),
  },
  [1] = {
    [sym_module] = STATE(625),
    [anon_sym_module] = ACTIONS(5),
    [sym_line_comment] = ACTIONS(3),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(7), 6,
      anon_sym_as,
      sym_identifier,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(9), 55,
      anon_sym_version,
      anon_sym_is,
      anon_sym_end,
      anon_sym_import,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_datatype,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [69] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(11), 6,
      anon_sym_as,
      sym_identifier,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(13), 54,
      anon_sym_is,
      anon_sym_end,
      anon_sym_import,
      anon_sym_RBRACK,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_with,
      anon_sym_def,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_parent,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
      anon_sym_in,
      anon_sym_u2208,
      sym_set_op_builder,
      anon_sym_COLON_EQ,
      anon_sym_u2254,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PLUS,
      anon_sym_u2295,
  [137] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(19), 1,
      sym_language_tag,
    ACTIONS(15), 6,
      sym_identifier,
      anon_sym_AT,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(17), 52,
      anon_sym_is,
      anon_sym_end,
      anon_sym_from,
      anon_sym_assert,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_datatype,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [206] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(21), 5,
      sym_identifier,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(23), 53,
      anon_sym_is,
      anon_sym_end,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_datatype,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [272] = 12,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(25), 1,
      sym_identifier,
    ACTIONS(27), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_LBRACE,
    ACTIONS(35), 1,
      sym_unknown_type,
    STATE(8), 1,
      sym_qualified_identifier,
    STATE(16), 1,
      sym_cardinality_expression,
    STATE(203), 1,
      sym_type_reference,
    STATE(177), 3,
      sym_identifier_reference,
      sym_builtin_simple_type,
      sym_mapping_type,
    STATE(114), 5,
      sym__owl_builtin_types,
      sym__builtin_primitive_datatypes,
      sym__derived_date_datetypes,
      sym__derived_numeric_datatypes,
      sym__derived_string_datatypes,
    ACTIONS(33), 6,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(31), 37,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
  [356] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(37), 5,
      sym_identifier,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(39), 53,
      anon_sym_is,
      anon_sym_end,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_datatype,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [422] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(41), 5,
      sym_identifier,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(43), 53,
      anon_sym_is,
      anon_sym_end,
      anon_sym_RBRACK,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_with,
      anon_sym_def,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_parent,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
      anon_sym_in,
      anon_sym_u2208,
      sym_set_op_builder,
      anon_sym_COLON_EQ,
      anon_sym_u2254,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PLUS,
      anon_sym_u2295,
  [488] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 5,
      sym_identifier,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(47), 53,
      anon_sym_is,
      anon_sym_end,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_datatype,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [554] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(49), 5,
      sym_identifier,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(51), 53,
      anon_sym_is,
      anon_sym_end,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_datatype,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [620] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(53), 5,
      sym_identifier,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(55), 53,
      anon_sym_is,
      anon_sym_end,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_datatype,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [686] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(57), 5,
      sym_identifier,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(59), 53,
      anon_sym_is,
      anon_sym_end,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_datatype,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [752] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(61), 5,
      sym_identifier,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(63), 53,
      anon_sym_is,
      anon_sym_end,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_datatype,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [818] = 11,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(25), 1,
      sym_identifier,
    ACTIONS(27), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_LBRACE,
    STATE(8), 1,
      sym_qualified_identifier,
    STATE(18), 1,
      sym_function_cardinality_expression,
    STATE(353), 1,
      sym_function_type_reference,
    STATE(351), 3,
      sym_identifier_reference,
      sym_builtin_simple_type,
      sym_mapping_type,
    STATE(114), 5,
      sym__owl_builtin_types,
      sym__builtin_primitive_datatypes,
      sym__derived_date_datetypes,
      sym__derived_numeric_datatypes,
      sym__derived_string_datatypes,
    ACTIONS(33), 6,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(31), 37,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
  [899] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(25), 1,
      sym_identifier,
    ACTIONS(27), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      sym_unknown_type,
    STATE(8), 1,
      sym_qualified_identifier,
    STATE(617), 1,
      sym_type_reference,
    STATE(177), 3,
      sym_identifier_reference,
      sym_builtin_simple_type,
      sym_mapping_type,
    STATE(114), 5,
      sym__owl_builtin_types,
      sym__builtin_primitive_datatypes,
      sym__derived_date_datetypes,
      sym__derived_numeric_datatypes,
      sym__derived_string_datatypes,
    ACTIONS(33), 6,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(31), 37,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
  [977] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(25), 1,
      sym_identifier,
    ACTIONS(27), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      sym_unknown_type,
    STATE(8), 1,
      sym_qualified_identifier,
    STATE(205), 1,
      sym_type_reference,
    STATE(177), 3,
      sym_identifier_reference,
      sym_builtin_simple_type,
      sym_mapping_type,
    STATE(114), 5,
      sym__owl_builtin_types,
      sym__builtin_primitive_datatypes,
      sym__derived_date_datetypes,
      sym__derived_numeric_datatypes,
      sym__derived_string_datatypes,
    ACTIONS(33), 6,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(31), 37,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
  [1055] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(25), 1,
      sym_identifier,
    ACTIONS(27), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      sym_unknown_type,
    STATE(8), 1,
      sym_qualified_identifier,
    STATE(504), 1,
      sym_type_reference,
    STATE(177), 3,
      sym_identifier_reference,
      sym_builtin_simple_type,
      sym_mapping_type,
    STATE(114), 5,
      sym__owl_builtin_types,
      sym__builtin_primitive_datatypes,
      sym__derived_date_datetypes,
      sym__derived_numeric_datatypes,
      sym__derived_string_datatypes,
    ACTIONS(33), 6,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(31), 37,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
  [1133] = 9,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(25), 1,
      sym_identifier,
    ACTIONS(27), 1,
      anon_sym_LPAREN,
    STATE(8), 1,
      sym_qualified_identifier,
    STATE(379), 1,
      sym_function_type_reference,
    STATE(351), 3,
      sym_identifier_reference,
      sym_builtin_simple_type,
      sym_mapping_type,
    STATE(114), 5,
      sym__owl_builtin_types,
      sym__builtin_primitive_datatypes,
      sym__derived_date_datetypes,
      sym__derived_numeric_datatypes,
      sym__derived_string_datatypes,
    ACTIONS(33), 6,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(31), 37,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
  [1208] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(25), 1,
      sym_identifier,
    ACTIONS(67), 1,
      sym_opaque,
    STATE(8), 1,
      sym_qualified_identifier,
    STATE(214), 3,
      sym_identifier_reference,
      sym_builtin_simple_type,
      sym__datatype_base,
    STATE(114), 5,
      sym__owl_builtin_types,
      sym__builtin_primitive_datatypes,
      sym__derived_date_datetypes,
      sym__derived_numeric_datatypes,
      sym__derived_string_datatypes,
    ACTIONS(33), 6,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(31), 37,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
  [1280] = 33,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_LBRACK,
    ACTIONS(73), 1,
      anon_sym_LPAREN,
    ACTIONS(75), 1,
      sym_reserved_self,
    ACTIONS(77), 1,
      anon_sym_LBRACE,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(99), 1,
      sym__value_empty_sequence,
    STATE(8), 1,
      sym_qualified_identifier,
    STATE(20), 1,
      sym_logical_op_negation,
    STATE(138), 1,
      sym_constraint_sentence,
    STATE(184), 1,
      sym_quantified_sentence,
    STATE(192), 1,
      sym_boolean_sentence,
    STATE(199), 1,
      sym_simple_sentence,
    STATE(220), 1,
      sym_term,
    STATE(528), 1,
      sym__sequence_value_constraints,
    STATE(565), 1,
      sym_quantified_variable_binding,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    ACTIONS(93), 2,
      anon_sym_not,
      anon_sym_u00ac,
    ACTIONS(95), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(97), 2,
      anon_sym_exists,
      anon_sym_u2203,
    STATE(13), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(95), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    STATE(190), 2,
      sym_unary_boolean_sentence,
      sym_binary_boolean_sentence,
    STATE(513), 2,
      sym_logical_quantifier_universal,
      sym_logical_quantifier_existential,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(196), 3,
      sym_atomic_sentence,
      sym_equation,
      sym_inequation,
    STATE(12), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(85), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [1401] = 33,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_LBRACK,
    ACTIONS(73), 1,
      anon_sym_LPAREN,
    ACTIONS(75), 1,
      sym_reserved_self,
    ACTIONS(77), 1,
      anon_sym_LBRACE,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(99), 1,
      sym__value_empty_sequence,
    STATE(8), 1,
      sym_qualified_identifier,
    STATE(20), 1,
      sym_logical_op_negation,
    STATE(143), 1,
      sym_constraint_sentence,
    STATE(184), 1,
      sym_quantified_sentence,
    STATE(192), 1,
      sym_boolean_sentence,
    STATE(199), 1,
      sym_simple_sentence,
    STATE(220), 1,
      sym_term,
    STATE(528), 1,
      sym__sequence_value_constraints,
    STATE(565), 1,
      sym_quantified_variable_binding,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    ACTIONS(93), 2,
      anon_sym_not,
      anon_sym_u00ac,
    ACTIONS(95), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(97), 2,
      anon_sym_exists,
      anon_sym_u2203,
    STATE(13), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(95), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    STATE(190), 2,
      sym_unary_boolean_sentence,
      sym_binary_boolean_sentence,
    STATE(513), 2,
      sym_logical_quantifier_universal,
      sym_logical_quantifier_existential,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(196), 3,
      sym_atomic_sentence,
      sym_equation,
      sym_inequation,
    STATE(12), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(85), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [1522] = 33,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_LBRACK,
    ACTIONS(73), 1,
      anon_sym_LPAREN,
    ACTIONS(75), 1,
      sym_reserved_self,
    ACTIONS(77), 1,
      anon_sym_LBRACE,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(99), 1,
      sym__value_empty_sequence,
    STATE(8), 1,
      sym_qualified_identifier,
    STATE(28), 1,
      sym_logical_op_negation,
    STATE(142), 1,
      sym_constraint_sentence,
    STATE(184), 1,
      sym_quantified_sentence,
    STATE(192), 1,
      sym_boolean_sentence,
    STATE(199), 1,
      sym_simple_sentence,
    STATE(202), 1,
      sym_term,
    STATE(528), 1,
      sym__sequence_value_constraints,
    STATE(624), 1,
      sym_quantified_variable_binding,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    ACTIONS(93), 2,
      anon_sym_not,
      anon_sym_u00ac,
    ACTIONS(95), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(97), 2,
      anon_sym_exists,
      anon_sym_u2203,
    STATE(13), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(95), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    STATE(190), 2,
      sym_unary_boolean_sentence,
      sym_binary_boolean_sentence,
    STATE(513), 2,
      sym_logical_quantifier_universal,
      sym_logical_quantifier_existential,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(196), 3,
      sym_atomic_sentence,
      sym_equation,
      sym_inequation,
    STATE(12), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(85), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [1643] = 33,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_LBRACK,
    ACTIONS(73), 1,
      anon_sym_LPAREN,
    ACTIONS(75), 1,
      sym_reserved_self,
    ACTIONS(77), 1,
      anon_sym_LBRACE,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(99), 1,
      sym__value_empty_sequence,
    STATE(8), 1,
      sym_qualified_identifier,
    STATE(28), 1,
      sym_logical_op_negation,
    STATE(142), 1,
      sym_constraint_sentence,
    STATE(184), 1,
      sym_quantified_sentence,
    STATE(185), 1,
      sym_term,
    STATE(192), 1,
      sym_boolean_sentence,
    STATE(199), 1,
      sym_simple_sentence,
    STATE(528), 1,
      sym__sequence_value_constraints,
    STATE(624), 1,
      sym_quantified_variable_binding,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    ACTIONS(93), 2,
      anon_sym_not,
      anon_sym_u00ac,
    ACTIONS(95), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(97), 2,
      anon_sym_exists,
      anon_sym_u2203,
    STATE(13), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(95), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    STATE(190), 2,
      sym_unary_boolean_sentence,
      sym_binary_boolean_sentence,
    STATE(513), 2,
      sym_logical_quantifier_universal,
      sym_logical_quantifier_existential,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(196), 3,
      sym_atomic_sentence,
      sym_equation,
      sym_inequation,
    STATE(12), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(85), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [1764] = 33,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_LBRACK,
    ACTIONS(73), 1,
      anon_sym_LPAREN,
    ACTIONS(75), 1,
      sym_reserved_self,
    ACTIONS(77), 1,
      anon_sym_LBRACE,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(99), 1,
      sym__value_empty_sequence,
    STATE(8), 1,
      sym_qualified_identifier,
    STATE(20), 1,
      sym_logical_op_negation,
    STATE(137), 1,
      sym_constraint_sentence,
    STATE(184), 1,
      sym_quantified_sentence,
    STATE(192), 1,
      sym_boolean_sentence,
    STATE(199), 1,
      sym_simple_sentence,
    STATE(220), 1,
      sym_term,
    STATE(528), 1,
      sym__sequence_value_constraints,
    STATE(565), 1,
      sym_quantified_variable_binding,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    ACTIONS(93), 2,
      anon_sym_not,
      anon_sym_u00ac,
    ACTIONS(95), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(97), 2,
      anon_sym_exists,
      anon_sym_u2203,
    STATE(13), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(95), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    STATE(190), 2,
      sym_unary_boolean_sentence,
      sym_binary_boolean_sentence,
    STATE(513), 2,
      sym_logical_quantifier_universal,
      sym_logical_quantifier_existential,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(196), 3,
      sym_atomic_sentence,
      sym_equation,
      sym_inequation,
    STATE(12), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(85), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [1885] = 33,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_LBRACK,
    ACTIONS(73), 1,
      anon_sym_LPAREN,
    ACTIONS(75), 1,
      sym_reserved_self,
    ACTIONS(77), 1,
      anon_sym_LBRACE,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(99), 1,
      sym__value_empty_sequence,
    STATE(8), 1,
      sym_qualified_identifier,
    STATE(20), 1,
      sym_logical_op_negation,
    STATE(162), 1,
      sym_constraint_sentence,
    STATE(184), 1,
      sym_quantified_sentence,
    STATE(192), 1,
      sym_boolean_sentence,
    STATE(199), 1,
      sym_simple_sentence,
    STATE(220), 1,
      sym_term,
    STATE(528), 1,
      sym__sequence_value_constraints,
    STATE(565), 1,
      sym_quantified_variable_binding,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    ACTIONS(93), 2,
      anon_sym_not,
      anon_sym_u00ac,
    ACTIONS(95), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(97), 2,
      anon_sym_exists,
      anon_sym_u2203,
    STATE(13), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(95), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    STATE(190), 2,
      sym_unary_boolean_sentence,
      sym_binary_boolean_sentence,
    STATE(513), 2,
      sym_logical_quantifier_universal,
      sym_logical_quantifier_existential,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(196), 3,
      sym_atomic_sentence,
      sym_equation,
      sym_inequation,
    STATE(12), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(85), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [2006] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(25), 1,
      sym_identifier,
    STATE(8), 1,
      sym_qualified_identifier,
    STATE(211), 3,
      sym_identifier_reference,
      sym_builtin_simple_type,
      sym__datatype_base,
    STATE(114), 5,
      sym__owl_builtin_types,
      sym__builtin_primitive_datatypes,
      sym__derived_date_datetypes,
      sym__derived_numeric_datatypes,
      sym__derived_string_datatypes,
    ACTIONS(33), 6,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(31), 37,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
  [2075] = 33,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_LBRACK,
    ACTIONS(73), 1,
      anon_sym_LPAREN,
    ACTIONS(75), 1,
      sym_reserved_self,
    ACTIONS(77), 1,
      anon_sym_LBRACE,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(99), 1,
      sym__value_empty_sequence,
    STATE(8), 1,
      sym_qualified_identifier,
    STATE(20), 1,
      sym_logical_op_negation,
    STATE(156), 1,
      sym_constraint_sentence,
    STATE(184), 1,
      sym_quantified_sentence,
    STATE(192), 1,
      sym_boolean_sentence,
    STATE(199), 1,
      sym_simple_sentence,
    STATE(220), 1,
      sym_term,
    STATE(528), 1,
      sym__sequence_value_constraints,
    STATE(565), 1,
      sym_quantified_variable_binding,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    ACTIONS(93), 2,
      anon_sym_not,
      anon_sym_u00ac,
    ACTIONS(95), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(97), 2,
      anon_sym_exists,
      anon_sym_u2203,
    STATE(13), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(95), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    STATE(190), 2,
      sym_unary_boolean_sentence,
      sym_binary_boolean_sentence,
    STATE(513), 2,
      sym_logical_quantifier_universal,
      sym_logical_quantifier_existential,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(196), 3,
      sym_atomic_sentence,
      sym_equation,
      sym_inequation,
    STATE(12), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(85), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [2196] = 33,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_LBRACK,
    ACTIONS(73), 1,
      anon_sym_LPAREN,
    ACTIONS(75), 1,
      sym_reserved_self,
    ACTIONS(77), 1,
      anon_sym_LBRACE,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(99), 1,
      sym__value_empty_sequence,
    STATE(8), 1,
      sym_qualified_identifier,
    STATE(28), 1,
      sym_logical_op_negation,
    STATE(141), 1,
      sym_constraint_sentence,
    STATE(184), 1,
      sym_quantified_sentence,
    STATE(192), 1,
      sym_boolean_sentence,
    STATE(199), 1,
      sym_simple_sentence,
    STATE(217), 1,
      sym_term,
    STATE(528), 1,
      sym__sequence_value_constraints,
    STATE(624), 1,
      sym_quantified_variable_binding,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    ACTIONS(93), 2,
      anon_sym_not,
      anon_sym_u00ac,
    ACTIONS(95), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(97), 2,
      anon_sym_exists,
      anon_sym_u2203,
    STATE(13), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(95), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    STATE(190), 2,
      sym_unary_boolean_sentence,
      sym_binary_boolean_sentence,
    STATE(513), 2,
      sym_logical_quantifier_universal,
      sym_logical_quantifier_existential,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(196), 3,
      sym_atomic_sentence,
      sym_equation,
      sym_inequation,
    STATE(12), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(85), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [2317] = 33,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_LBRACK,
    ACTIONS(73), 1,
      anon_sym_LPAREN,
    ACTIONS(75), 1,
      sym_reserved_self,
    ACTIONS(77), 1,
      anon_sym_LBRACE,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(99), 1,
      sym__value_empty_sequence,
    STATE(8), 1,
      sym_qualified_identifier,
    STATE(20), 1,
      sym_logical_op_negation,
    STATE(164), 1,
      sym_constraint_sentence,
    STATE(184), 1,
      sym_quantified_sentence,
    STATE(192), 1,
      sym_boolean_sentence,
    STATE(199), 1,
      sym_simple_sentence,
    STATE(220), 1,
      sym_term,
    STATE(528), 1,
      sym__sequence_value_constraints,
    STATE(565), 1,
      sym_quantified_variable_binding,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    ACTIONS(93), 2,
      anon_sym_not,
      anon_sym_u00ac,
    ACTIONS(95), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(97), 2,
      anon_sym_exists,
      anon_sym_u2203,
    STATE(13), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(95), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    STATE(190), 2,
      sym_unary_boolean_sentence,
      sym_binary_boolean_sentence,
    STATE(513), 2,
      sym_logical_quantifier_universal,
      sym_logical_quantifier_existential,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(196), 3,
      sym_atomic_sentence,
      sym_equation,
      sym_inequation,
    STATE(12), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(85), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [2438] = 33,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_LBRACK,
    ACTIONS(73), 1,
      anon_sym_LPAREN,
    ACTIONS(75), 1,
      sym_reserved_self,
    ACTIONS(77), 1,
      anon_sym_LBRACE,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(99), 1,
      sym__value_empty_sequence,
    STATE(8), 1,
      sym_qualified_identifier,
    STATE(28), 1,
      sym_logical_op_negation,
    STATE(140), 1,
      sym_constraint_sentence,
    STATE(184), 1,
      sym_quantified_sentence,
    STATE(192), 1,
      sym_boolean_sentence,
    STATE(199), 1,
      sym_simple_sentence,
    STATE(217), 1,
      sym_term,
    STATE(528), 1,
      sym__sequence_value_constraints,
    STATE(624), 1,
      sym_quantified_variable_binding,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    ACTIONS(93), 2,
      anon_sym_not,
      anon_sym_u00ac,
    ACTIONS(95), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(97), 2,
      anon_sym_exists,
      anon_sym_u2203,
    STATE(13), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(95), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    STATE(190), 2,
      sym_unary_boolean_sentence,
      sym_binary_boolean_sentence,
    STATE(513), 2,
      sym_logical_quantifier_universal,
      sym_logical_quantifier_existential,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(196), 3,
      sym_atomic_sentence,
      sym_equation,
      sym_inequation,
    STATE(12), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(85), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [2559] = 33,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_LBRACK,
    ACTIONS(73), 1,
      anon_sym_LPAREN,
    ACTIONS(75), 1,
      sym_reserved_self,
    ACTIONS(77), 1,
      anon_sym_LBRACE,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(99), 1,
      sym__value_empty_sequence,
    STATE(8), 1,
      sym_qualified_identifier,
    STATE(28), 1,
      sym_logical_op_negation,
    STATE(139), 1,
      sym_constraint_sentence,
    STATE(184), 1,
      sym_quantified_sentence,
    STATE(192), 1,
      sym_boolean_sentence,
    STATE(199), 1,
      sym_simple_sentence,
    STATE(217), 1,
      sym_term,
    STATE(528), 1,
      sym__sequence_value_constraints,
    STATE(624), 1,
      sym_quantified_variable_binding,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    ACTIONS(93), 2,
      anon_sym_not,
      anon_sym_u00ac,
    ACTIONS(95), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(97), 2,
      anon_sym_exists,
      anon_sym_u2203,
    STATE(13), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(95), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    STATE(190), 2,
      sym_unary_boolean_sentence,
      sym_binary_boolean_sentence,
    STATE(513), 2,
      sym_logical_quantifier_universal,
      sym_logical_quantifier_existential,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(196), 3,
      sym_atomic_sentence,
      sym_equation,
      sym_inequation,
    STATE(12), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(85), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [2680] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(101), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(103), 43,
      anon_sym_end,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_datatype,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      sym__value_empty_sequence,
  [2735] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(105), 7,
      sym_identifier,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(107), 39,
      anon_sym_LPAREN,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
      sym_unknown_type,
  [2789] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(109), 7,
      sym_identifier,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(111), 39,
      anon_sym_LPAREN,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
      sym_unknown_type,
  [2843] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(113), 7,
      sym_identifier,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(115), 39,
      anon_sym_LPAREN,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
      sym_unknown_type,
  [2897] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(117), 7,
      sym_identifier,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(119), 39,
      anon_sym_LPAREN,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
      sym_unknown_type,
  [2951] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(121), 7,
      sym_identifier,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(123), 38,
      anon_sym_LPAREN,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
  [3004] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(125), 7,
      sym_identifier,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(127), 38,
      anon_sym_LPAREN,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
  [3057] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(129), 7,
      sym_identifier,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(131), 38,
      anon_sym_LPAREN,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
  [3110] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(133), 7,
      sym_identifier,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(135), 38,
      anon_sym_LPAREN,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
  [3163] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(137), 7,
      sym_identifier,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(139), 38,
      anon_sym_LPAREN,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
  [3216] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(141), 7,
      sym_identifier,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(143), 38,
      anon_sym_LPAREN,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
  [3269] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(145), 7,
      sym_identifier,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(147), 38,
      anon_sym_LPAREN,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
  [3322] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(149), 7,
      sym_identifier,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(151), 38,
      anon_sym_LPAREN,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
  [3375] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(41), 1,
      sym_identifier,
    ACTIONS(153), 1,
      anon_sym_COLON,
    ACTIONS(43), 35,
      anon_sym_is,
      anon_sym_end,
      anon_sym_RBRACK,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_assert,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_with,
      anon_sym_def,
      anon_sym_LBRACE,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_parent,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      anon_sym_in,
      anon_sym_u2208,
      sym_set_op_builder,
      anon_sym_COLON_EQ,
      anon_sym_u2254,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PLUS,
      anon_sym_u2295,
  [3422] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(159), 1,
      anon_sym_LPAREN,
    ACTIONS(155), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(157), 31,
      anon_sym_end,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      sym__value_empty_sequence,
  [3468] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(161), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(163), 31,
      anon_sym_end,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      sym__value_empty_sequence,
  [3511] = 22,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(165), 1,
      sym_identifier,
    ACTIONS(167), 1,
      anon_sym_LBRACK,
    ACTIONS(169), 1,
      anon_sym_RPAREN,
    ACTIONS(171), 1,
      sym_reserved_self,
    ACTIONS(173), 1,
      anon_sym_LBRACE,
    ACTIONS(175), 1,
      sym_quoted_string,
    ACTIONS(177), 1,
      anon_sym_LT,
    ACTIONS(179), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(189), 1,
      sym__value_empty_sequence,
    STATE(52), 1,
      aux_sym__actual_arguments_repeat1,
    STATE(116), 1,
      sym_qualified_identifier,
    STATE(148), 1,
      sym_term,
    STATE(526), 1,
      sym__sequence_value_constraints,
    ACTIONS(181), 2,
      sym_double,
      sym_rational,
    ACTIONS(185), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(187), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(135), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(146), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    ACTIONS(183), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(129), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(165), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [3592] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(191), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(193), 31,
      anon_sym_end,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      sym__value_empty_sequence,
  [3635] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(195), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(197), 31,
      anon_sym_end,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      sym__value_empty_sequence,
  [3678] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(199), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(201), 31,
      anon_sym_end,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      sym__value_empty_sequence,
  [3721] = 22,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(165), 1,
      sym_identifier,
    ACTIONS(167), 1,
      anon_sym_LBRACK,
    ACTIONS(171), 1,
      sym_reserved_self,
    ACTIONS(173), 1,
      anon_sym_LBRACE,
    ACTIONS(175), 1,
      sym_quoted_string,
    ACTIONS(177), 1,
      anon_sym_LT,
    ACTIONS(179), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(189), 1,
      sym__value_empty_sequence,
    ACTIONS(203), 1,
      anon_sym_RPAREN,
    STATE(57), 1,
      aux_sym__actual_arguments_repeat1,
    STATE(116), 1,
      sym_qualified_identifier,
    STATE(148), 1,
      sym_term,
    STATE(526), 1,
      sym__sequence_value_constraints,
    ACTIONS(181), 2,
      sym_double,
      sym_rational,
    ACTIONS(185), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(187), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(135), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(146), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    ACTIONS(183), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(129), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(165), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [3802] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(155), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(157), 31,
      anon_sym_end,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      sym__value_empty_sequence,
  [3845] = 22,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(165), 1,
      sym_identifier,
    ACTIONS(167), 1,
      anon_sym_LBRACK,
    ACTIONS(171), 1,
      sym_reserved_self,
    ACTIONS(173), 1,
      anon_sym_LBRACE,
    ACTIONS(175), 1,
      sym_quoted_string,
    ACTIONS(177), 1,
      anon_sym_LT,
    ACTIONS(179), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(189), 1,
      sym__value_empty_sequence,
    ACTIONS(205), 1,
      anon_sym_RPAREN,
    STATE(56), 1,
      aux_sym__actual_arguments_repeat1,
    STATE(116), 1,
      sym_qualified_identifier,
    STATE(148), 1,
      sym_term,
    STATE(526), 1,
      sym__sequence_value_constraints,
    ACTIONS(181), 2,
      sym_double,
      sym_rational,
    ACTIONS(185), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(187), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(135), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(146), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    ACTIONS(183), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(129), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(165), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [3926] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(207), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(209), 31,
      anon_sym_end,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      sym__value_empty_sequence,
  [3969] = 22,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(165), 1,
      sym_identifier,
    ACTIONS(167), 1,
      anon_sym_LBRACK,
    ACTIONS(171), 1,
      sym_reserved_self,
    ACTIONS(173), 1,
      anon_sym_LBRACE,
    ACTIONS(175), 1,
      sym_quoted_string,
    ACTIONS(177), 1,
      anon_sym_LT,
    ACTIONS(179), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(189), 1,
      sym__value_empty_sequence,
    ACTIONS(211), 1,
      anon_sym_RPAREN,
    STATE(57), 1,
      aux_sym__actual_arguments_repeat1,
    STATE(116), 1,
      sym_qualified_identifier,
    STATE(148), 1,
      sym_term,
    STATE(526), 1,
      sym__sequence_value_constraints,
    ACTIONS(181), 2,
      sym_double,
      sym_rational,
    ACTIONS(185), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(187), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(135), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(146), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    ACTIONS(183), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(129), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(165), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [4050] = 22,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(213), 1,
      sym_identifier,
    ACTIONS(216), 1,
      anon_sym_LBRACK,
    ACTIONS(219), 1,
      anon_sym_RPAREN,
    ACTIONS(221), 1,
      sym_reserved_self,
    ACTIONS(224), 1,
      anon_sym_LBRACE,
    ACTIONS(227), 1,
      sym_quoted_string,
    ACTIONS(230), 1,
      anon_sym_LT,
    ACTIONS(233), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(248), 1,
      sym__value_empty_sequence,
    STATE(57), 1,
      aux_sym__actual_arguments_repeat1,
    STATE(116), 1,
      sym_qualified_identifier,
    STATE(148), 1,
      sym_term,
    STATE(526), 1,
      sym__sequence_value_constraints,
    ACTIONS(236), 2,
      sym_double,
      sym_rational,
    ACTIONS(242), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(245), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(135), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(146), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    ACTIONS(239), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(129), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(165), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [4131] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(251), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(253), 31,
      anon_sym_end,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      sym__value_empty_sequence,
  [4174] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(255), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(257), 31,
      anon_sym_end,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      sym__value_empty_sequence,
  [4217] = 22,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(259), 1,
      anon_sym_end,
    ACTIONS(261), 1,
      anon_sym_import,
    ACTIONS(263), 1,
      anon_sym_from,
    ACTIONS(265), 1,
      anon_sym_AT,
    ACTIONS(267), 1,
      anon_sym_assert,
    ACTIONS(269), 1,
      anon_sym_datatype,
    ACTIONS(271), 1,
      anon_sym_dimension,
    ACTIONS(273), 1,
      anon_sym_entity,
    ACTIONS(275), 1,
      anon_sym_enum,
    ACTIONS(277), 1,
      anon_sym_event,
    ACTIONS(279), 1,
      anon_sym_property,
    ACTIONS(281), 1,
      anon_sym_structure,
    ACTIONS(283), 1,
      anon_sym_union,
    ACTIONS(285), 1,
      anon_sym_rdf,
    ACTIONS(287), 1,
      anon_sym_class,
    STATE(595), 1,
      sym_from_clause,
    STATE(61), 2,
      sym_import_statement,
      aux_sym_module_body_repeat1,
    STATE(83), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
    STATE(113), 2,
      sym_definition,
      aux_sym_module_body_repeat3,
    STATE(170), 2,
      sym_annotation_property,
      sym_constraint,
    STATE(261), 10,
      sym_data_type_def,
      sym_dimension_def,
      sym_entity_def,
      sym_enum_def,
      sym_event_def,
      sym_property_def,
      sym_structure_def,
      sym_union_def,
      sym_rdf_def,
      sym_type_class_def,
  [4297] = 22,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(261), 1,
      anon_sym_import,
    ACTIONS(263), 1,
      anon_sym_from,
    ACTIONS(265), 1,
      anon_sym_AT,
    ACTIONS(267), 1,
      anon_sym_assert,
    ACTIONS(269), 1,
      anon_sym_datatype,
    ACTIONS(271), 1,
      anon_sym_dimension,
    ACTIONS(273), 1,
      anon_sym_entity,
    ACTIONS(275), 1,
      anon_sym_enum,
    ACTIONS(277), 1,
      anon_sym_event,
    ACTIONS(279), 1,
      anon_sym_property,
    ACTIONS(281), 1,
      anon_sym_structure,
    ACTIONS(283), 1,
      anon_sym_union,
    ACTIONS(285), 1,
      anon_sym_rdf,
    ACTIONS(287), 1,
      anon_sym_class,
    ACTIONS(289), 1,
      anon_sym_end,
    STATE(595), 1,
      sym_from_clause,
    STATE(84), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
    STATE(124), 2,
      sym_definition,
      aux_sym_module_body_repeat3,
    STATE(170), 2,
      sym_annotation_property,
      sym_constraint,
    STATE(179), 2,
      sym_import_statement,
      aux_sym_module_body_repeat1,
    STATE(261), 10,
      sym_data_type_def,
      sym_dimension_def,
      sym_entity_def,
      sym_enum_def,
      sym_event_def,
      sym_property_def,
      sym_structure_def,
      sym_union_def,
      sym_rdf_def,
      sym_type_class_def,
  [4377] = 20,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_LBRACK,
    ACTIONS(75), 1,
      sym_reserved_self,
    ACTIONS(77), 1,
      anon_sym_LBRACE,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(99), 1,
      sym__value_empty_sequence,
    STATE(8), 1,
      sym_qualified_identifier,
    STATE(174), 1,
      sym_term,
    STATE(528), 1,
      sym__sequence_value_constraints,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(13), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(95), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(12), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(85), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [4452] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(291), 1,
      anon_sym_COLON,
    STATE(73), 1,
      aux_sym_function_composition_repeat1,
    STATE(572), 1,
      sym__function_op_composition,
    ACTIONS(293), 2,
      anon_sym_u00b7,
      anon_sym_DOT,
    ACTIONS(41), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(43), 24,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [4501] = 20,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_LBRACK,
    ACTIONS(75), 1,
      sym_reserved_self,
    ACTIONS(77), 1,
      anon_sym_LBRACE,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(99), 1,
      sym__value_empty_sequence,
    STATE(8), 1,
      sym_qualified_identifier,
    STATE(157), 1,
      sym_term,
    STATE(528), 1,
      sym__sequence_value_constraints,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(13), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(95), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(12), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(85), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [4576] = 20,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_LBRACK,
    ACTIONS(75), 1,
      sym_reserved_self,
    ACTIONS(77), 1,
      anon_sym_LBRACE,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(99), 1,
      sym__value_empty_sequence,
    STATE(8), 1,
      sym_qualified_identifier,
    STATE(500), 1,
      sym_term,
    STATE(528), 1,
      sym__sequence_value_constraints,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(13), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(95), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(12), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(85), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [4651] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(66), 1,
      aux_sym_function_composition_repeat1,
    STATE(572), 1,
      sym__function_op_composition,
    ACTIONS(299), 2,
      anon_sym_u00b7,
      anon_sym_DOT,
    ACTIONS(297), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(295), 24,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [4697] = 22,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(302), 1,
      sym_identifier,
    ACTIONS(305), 1,
      anon_sym_LBRACK,
    ACTIONS(308), 1,
      anon_sym_RBRACK,
    ACTIONS(310), 1,
      anon_sym_LBRACE,
    ACTIONS(313), 1,
      sym_quoted_string,
    ACTIONS(316), 1,
      anon_sym_LT,
    ACTIONS(319), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(334), 1,
      sym__value_empty_sequence,
    STATE(67), 1,
      aux_sym_sequence_of_predicate_values_repeat1,
    STATE(116), 1,
      sym_qualified_identifier,
    STATE(146), 1,
      sym_sequence_of_predicate_values,
    STATE(155), 1,
      sym_simple_value,
    STATE(178), 1,
      sym_identifier_reference,
    STATE(526), 1,
      sym__sequence_value_constraints,
    ACTIONS(322), 2,
      sym_double,
      sym_rational,
    ACTIONS(328), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(331), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(135), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    ACTIONS(325), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(183), 3,
      sym_predicate_value,
      sym_value_constructor,
      sym_mapping_value,
    STATE(129), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [4775] = 22,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(167), 1,
      anon_sym_LBRACK,
    ACTIONS(175), 1,
      sym_quoted_string,
    ACTIONS(177), 1,
      anon_sym_LT,
    ACTIONS(179), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(189), 1,
      sym__value_empty_sequence,
    ACTIONS(337), 1,
      sym_identifier,
    ACTIONS(339), 1,
      anon_sym_RBRACK,
    ACTIONS(341), 1,
      anon_sym_LBRACE,
    STATE(67), 1,
      aux_sym_sequence_of_predicate_values_repeat1,
    STATE(116), 1,
      sym_qualified_identifier,
    STATE(146), 1,
      sym_sequence_of_predicate_values,
    STATE(155), 1,
      sym_simple_value,
    STATE(178), 1,
      sym_identifier_reference,
    STATE(526), 1,
      sym__sequence_value_constraints,
    ACTIONS(181), 2,
      sym_double,
      sym_rational,
    ACTIONS(185), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(187), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(135), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    ACTIONS(183), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(183), 3,
      sym_predicate_value,
      sym_value_constructor,
      sym_mapping_value,
    STATE(129), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [4853] = 22,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(167), 1,
      anon_sym_LBRACK,
    ACTIONS(175), 1,
      sym_quoted_string,
    ACTIONS(177), 1,
      anon_sym_LT,
    ACTIONS(179), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(189), 1,
      sym__value_empty_sequence,
    ACTIONS(337), 1,
      sym_identifier,
    ACTIONS(341), 1,
      anon_sym_LBRACE,
    ACTIONS(343), 1,
      anon_sym_RBRACK,
    STATE(67), 1,
      aux_sym_sequence_of_predicate_values_repeat1,
    STATE(116), 1,
      sym_qualified_identifier,
    STATE(146), 1,
      sym_sequence_of_predicate_values,
    STATE(155), 1,
      sym_simple_value,
    STATE(178), 1,
      sym_identifier_reference,
    STATE(526), 1,
      sym__sequence_value_constraints,
    ACTIONS(181), 2,
      sym_double,
      sym_rational,
    ACTIONS(185), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(187), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(135), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    ACTIONS(183), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(183), 3,
      sym_predicate_value,
      sym_value_constructor,
      sym_mapping_value,
    STATE(129), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [4931] = 22,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(167), 1,
      anon_sym_LBRACK,
    ACTIONS(175), 1,
      sym_quoted_string,
    ACTIONS(177), 1,
      anon_sym_LT,
    ACTIONS(179), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(189), 1,
      sym__value_empty_sequence,
    ACTIONS(337), 1,
      sym_identifier,
    ACTIONS(341), 1,
      anon_sym_LBRACE,
    ACTIONS(345), 1,
      anon_sym_RBRACK,
    STATE(77), 1,
      aux_sym_sequence_of_predicate_values_repeat1,
    STATE(116), 1,
      sym_qualified_identifier,
    STATE(146), 1,
      sym_sequence_of_predicate_values,
    STATE(155), 1,
      sym_simple_value,
    STATE(178), 1,
      sym_identifier_reference,
    STATE(526), 1,
      sym__sequence_value_constraints,
    ACTIONS(181), 2,
      sym_double,
      sym_rational,
    ACTIONS(185), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(187), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(135), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    ACTIONS(183), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(183), 3,
      sym_predicate_value,
      sym_value_constructor,
      sym_mapping_value,
    STATE(129), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [5009] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(74), 1,
      aux_sym_function_composition_repeat1,
    STATE(572), 1,
      sym__function_op_composition,
    ACTIONS(293), 2,
      anon_sym_u00b7,
      anon_sym_DOT,
    ACTIONS(349), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(347), 24,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [5055] = 22,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(167), 1,
      anon_sym_LBRACK,
    ACTIONS(175), 1,
      sym_quoted_string,
    ACTIONS(177), 1,
      anon_sym_LT,
    ACTIONS(179), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(189), 1,
      sym__value_empty_sequence,
    ACTIONS(337), 1,
      sym_identifier,
    ACTIONS(341), 1,
      anon_sym_LBRACE,
    ACTIONS(351), 1,
      anon_sym_RBRACK,
    STATE(67), 1,
      aux_sym_sequence_of_predicate_values_repeat1,
    STATE(116), 1,
      sym_qualified_identifier,
    STATE(146), 1,
      sym_sequence_of_predicate_values,
    STATE(155), 1,
      sym_simple_value,
    STATE(178), 1,
      sym_identifier_reference,
    STATE(526), 1,
      sym__sequence_value_constraints,
    ACTIONS(181), 2,
      sym_double,
      sym_rational,
    ACTIONS(185), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(187), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(135), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    ACTIONS(183), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(183), 3,
      sym_predicate_value,
      sym_value_constructor,
      sym_mapping_value,
    STATE(129), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [5133] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(66), 1,
      aux_sym_function_composition_repeat1,
    STATE(572), 1,
      sym__function_op_composition,
    ACTIONS(293), 2,
      anon_sym_u00b7,
      anon_sym_DOT,
    ACTIONS(355), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(353), 24,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [5179] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(66), 1,
      aux_sym_function_composition_repeat1,
    STATE(572), 1,
      sym__function_op_composition,
    ACTIONS(293), 2,
      anon_sym_u00b7,
      anon_sym_DOT,
    ACTIONS(355), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(353), 24,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [5225] = 22,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(167), 1,
      anon_sym_LBRACK,
    ACTIONS(175), 1,
      sym_quoted_string,
    ACTIONS(177), 1,
      anon_sym_LT,
    ACTIONS(179), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(189), 1,
      sym__value_empty_sequence,
    ACTIONS(337), 1,
      sym_identifier,
    ACTIONS(341), 1,
      anon_sym_LBRACE,
    ACTIONS(357), 1,
      anon_sym_RBRACK,
    STATE(72), 1,
      aux_sym_sequence_of_predicate_values_repeat1,
    STATE(116), 1,
      sym_qualified_identifier,
    STATE(146), 1,
      sym_sequence_of_predicate_values,
    STATE(155), 1,
      sym_simple_value,
    STATE(178), 1,
      sym_identifier_reference,
    STATE(526), 1,
      sym__sequence_value_constraints,
    ACTIONS(181), 2,
      sym_double,
      sym_rational,
    ACTIONS(185), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(187), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(135), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    ACTIONS(183), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(183), 3,
      sym_predicate_value,
      sym_value_constructor,
      sym_mapping_value,
    STATE(129), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [5303] = 22,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(167), 1,
      anon_sym_LBRACK,
    ACTIONS(175), 1,
      sym_quoted_string,
    ACTIONS(177), 1,
      anon_sym_LT,
    ACTIONS(179), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(189), 1,
      sym__value_empty_sequence,
    ACTIONS(337), 1,
      sym_identifier,
    ACTIONS(341), 1,
      anon_sym_LBRACE,
    ACTIONS(359), 1,
      anon_sym_RBRACK,
    STATE(69), 1,
      aux_sym_sequence_of_predicate_values_repeat1,
    STATE(116), 1,
      sym_qualified_identifier,
    STATE(146), 1,
      sym_sequence_of_predicate_values,
    STATE(155), 1,
      sym_simple_value,
    STATE(178), 1,
      sym_identifier_reference,
    STATE(526), 1,
      sym__sequence_value_constraints,
    ACTIONS(181), 2,
      sym_double,
      sym_rational,
    ACTIONS(185), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(187), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(135), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    ACTIONS(183), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(183), 3,
      sym_predicate_value,
      sym_value_constructor,
      sym_mapping_value,
    STATE(129), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [5381] = 22,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(167), 1,
      anon_sym_LBRACK,
    ACTIONS(175), 1,
      sym_quoted_string,
    ACTIONS(177), 1,
      anon_sym_LT,
    ACTIONS(179), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(189), 1,
      sym__value_empty_sequence,
    ACTIONS(337), 1,
      sym_identifier,
    ACTIONS(341), 1,
      anon_sym_LBRACE,
    ACTIONS(361), 1,
      anon_sym_RBRACK,
    STATE(67), 1,
      aux_sym_sequence_of_predicate_values_repeat1,
    STATE(116), 1,
      sym_qualified_identifier,
    STATE(146), 1,
      sym_sequence_of_predicate_values,
    STATE(155), 1,
      sym_simple_value,
    STATE(178), 1,
      sym_identifier_reference,
    STATE(526), 1,
      sym__sequence_value_constraints,
    ACTIONS(181), 2,
      sym_double,
      sym_rational,
    ACTIONS(185), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(187), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(135), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    ACTIONS(183), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(183), 3,
      sym_predicate_value,
      sym_value_constructor,
      sym_mapping_value,
    STATE(129), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [5459] = 22,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(167), 1,
      anon_sym_LBRACK,
    ACTIONS(175), 1,
      sym_quoted_string,
    ACTIONS(177), 1,
      anon_sym_LT,
    ACTIONS(179), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(189), 1,
      sym__value_empty_sequence,
    ACTIONS(337), 1,
      sym_identifier,
    ACTIONS(341), 1,
      anon_sym_LBRACE,
    ACTIONS(363), 1,
      anon_sym_RBRACK,
    STATE(68), 1,
      aux_sym_sequence_of_predicate_values_repeat1,
    STATE(116), 1,
      sym_qualified_identifier,
    STATE(146), 1,
      sym_sequence_of_predicate_values,
    STATE(155), 1,
      sym_simple_value,
    STATE(178), 1,
      sym_identifier_reference,
    STATE(526), 1,
      sym__sequence_value_constraints,
    ACTIONS(181), 2,
      sym_double,
      sym_rational,
    ACTIONS(185), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(187), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(135), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    ACTIONS(183), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(183), 3,
      sym_predicate_value,
      sym_value_constructor,
      sym_mapping_value,
    STATE(129), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [5537] = 20,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(175), 1,
      sym_quoted_string,
    ACTIONS(177), 1,
      anon_sym_LT,
    ACTIONS(179), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(337), 1,
      sym_identifier,
    ACTIONS(341), 1,
      anon_sym_LBRACE,
    ACTIONS(365), 1,
      anon_sym_LBRACK,
    ACTIONS(367), 1,
      sym__value_empty_sequence,
    STATE(46), 1,
      sym_identifier_reference,
    STATE(49), 1,
      sym_value,
    STATE(116), 1,
      sym_qualified_identifier,
    STATE(147), 1,
      sym_simple_value,
    STATE(553), 1,
      sym__sequence_value_constraints,
    ACTIONS(181), 2,
      sym_double,
      sym_rational,
    ACTIONS(185), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(187), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(135), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    ACTIONS(183), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(53), 3,
      sym_sequence_of_values,
      sym_value_constructor,
      sym_mapping_value,
    STATE(129), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [5609] = 20,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(25), 1,
      sym_identifier,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(341), 1,
      anon_sym_LBRACE,
    ACTIONS(365), 1,
      anon_sym_LBRACK,
    ACTIONS(367), 1,
      sym__value_empty_sequence,
    STATE(8), 1,
      sym_qualified_identifier,
    STATE(46), 1,
      sym_identifier_reference,
    STATE(49), 1,
      sym_value,
    STATE(127), 1,
      sym_simple_value,
    STATE(553), 1,
      sym__sequence_value_constraints,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(13), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(53), 3,
      sym_sequence_of_values,
      sym_value_constructor,
      sym_mapping_value,
    STATE(12), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [5681] = 20,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(25), 1,
      sym_identifier,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(341), 1,
      anon_sym_LBRACE,
    ACTIONS(365), 1,
      anon_sym_LBRACK,
    ACTIONS(367), 1,
      sym__value_empty_sequence,
    STATE(8), 1,
      sym_qualified_identifier,
    STATE(46), 1,
      sym_identifier_reference,
    STATE(127), 1,
      sym_simple_value,
    STATE(166), 1,
      sym_value,
    STATE(553), 1,
      sym__sequence_value_constraints,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(13), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(53), 3,
      sym_sequence_of_values,
      sym_value_constructor,
      sym_mapping_value,
    STATE(12), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [5753] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(371), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(369), 26,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
      anon_sym_u00b7,
      anon_sym_DOT,
  [5791] = 18,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(265), 1,
      anon_sym_AT,
    ACTIONS(267), 1,
      anon_sym_assert,
    ACTIONS(269), 1,
      anon_sym_datatype,
    ACTIONS(271), 1,
      anon_sym_dimension,
    ACTIONS(273), 1,
      anon_sym_entity,
    ACTIONS(275), 1,
      anon_sym_enum,
    ACTIONS(277), 1,
      anon_sym_event,
    ACTIONS(279), 1,
      anon_sym_property,
    ACTIONS(281), 1,
      anon_sym_structure,
    ACTIONS(283), 1,
      anon_sym_union,
    ACTIONS(285), 1,
      anon_sym_rdf,
    ACTIONS(287), 1,
      anon_sym_class,
    ACTIONS(289), 1,
      anon_sym_end,
    STATE(123), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
    STATE(124), 2,
      sym_definition,
      aux_sym_module_body_repeat3,
    STATE(170), 2,
      sym_annotation_property,
      sym_constraint,
    STATE(261), 10,
      sym_data_type_def,
      sym_dimension_def,
      sym_entity_def,
      sym_enum_def,
      sym_event_def,
      sym_property_def,
      sym_structure_def,
      sym_union_def,
      sym_rdf_def,
      sym_type_class_def,
  [5858] = 18,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(265), 1,
      anon_sym_AT,
    ACTIONS(267), 1,
      anon_sym_assert,
    ACTIONS(269), 1,
      anon_sym_datatype,
    ACTIONS(271), 1,
      anon_sym_dimension,
    ACTIONS(273), 1,
      anon_sym_entity,
    ACTIONS(275), 1,
      anon_sym_enum,
    ACTIONS(277), 1,
      anon_sym_event,
    ACTIONS(279), 1,
      anon_sym_property,
    ACTIONS(281), 1,
      anon_sym_structure,
    ACTIONS(283), 1,
      anon_sym_union,
    ACTIONS(285), 1,
      anon_sym_rdf,
    ACTIONS(287), 1,
      anon_sym_class,
    ACTIONS(373), 1,
      anon_sym_end,
    STATE(115), 2,
      sym_definition,
      aux_sym_module_body_repeat3,
    STATE(123), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
    STATE(170), 2,
      sym_annotation_property,
      sym_constraint,
    STATE(261), 10,
      sym_data_type_def,
      sym_dimension_def,
      sym_entity_def,
      sym_enum_def,
      sym_event_def,
      sym_property_def,
      sym_structure_def,
      sym_union_def,
      sym_rdf_def,
      sym_type_class_def,
  [5925] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(349), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(347), 24,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [5961] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(377), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(375), 24,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [5997] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(381), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(379), 24,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [6033] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(385), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(383), 24,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [6069] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(389), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(387), 24,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [6105] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(393), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(391), 24,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [6141] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(397), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(395), 24,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [6177] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(401), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(399), 24,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [6213] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(405), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(403), 24,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [6249] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(409), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(407), 24,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [6285] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(413), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(411), 24,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [6321] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(419), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(415), 8,
      anon_sym_is,
      anon_sym_LPAREN,
      anon_sym_def,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
    ACTIONS(417), 15,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [6358] = 17,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(175), 1,
      sym_quoted_string,
    ACTIONS(177), 1,
      anon_sym_LT,
    ACTIONS(179), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(337), 1,
      sym_identifier,
    ACTIONS(421), 1,
      anon_sym_RBRACK,
    STATE(100), 1,
      aux_sym_sequence_of_values_repeat1,
    STATE(116), 1,
      sym_qualified_identifier,
    STATE(186), 1,
      sym_simple_value,
    STATE(209), 1,
      sym_identifier_reference,
    ACTIONS(181), 2,
      sym_double,
      sym_rational,
    ACTIONS(185), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(187), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(135), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(219), 2,
      sym_value_constructor,
      sym_mapping_value,
    ACTIONS(183), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(129), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [6420] = 17,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(175), 1,
      sym_quoted_string,
    ACTIONS(177), 1,
      anon_sym_LT,
    ACTIONS(179), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(337), 1,
      sym_identifier,
    ACTIONS(423), 1,
      anon_sym_RBRACK,
    STATE(101), 1,
      aux_sym_sequence_of_values_repeat1,
    STATE(116), 1,
      sym_qualified_identifier,
    STATE(186), 1,
      sym_simple_value,
    STATE(209), 1,
      sym_identifier_reference,
    ACTIONS(181), 2,
      sym_double,
      sym_rational,
    ACTIONS(185), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(187), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(135), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(219), 2,
      sym_value_constructor,
      sym_mapping_value,
    ACTIONS(183), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(129), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [6482] = 17,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(175), 1,
      sym_quoted_string,
    ACTIONS(177), 1,
      anon_sym_LT,
    ACTIONS(179), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(337), 1,
      sym_identifier,
    ACTIONS(425), 1,
      anon_sym_RBRACK,
    STATE(98), 1,
      aux_sym_sequence_of_values_repeat1,
    STATE(116), 1,
      sym_qualified_identifier,
    STATE(186), 1,
      sym_simple_value,
    STATE(209), 1,
      sym_identifier_reference,
    ACTIONS(181), 2,
      sym_double,
      sym_rational,
    ACTIONS(185), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(187), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(135), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(219), 2,
      sym_value_constructor,
      sym_mapping_value,
    ACTIONS(183), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(129), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [6544] = 17,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(175), 1,
      sym_quoted_string,
    ACTIONS(177), 1,
      anon_sym_LT,
    ACTIONS(179), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(337), 1,
      sym_identifier,
    ACTIONS(427), 1,
      anon_sym_RBRACK,
    STATE(101), 1,
      aux_sym_sequence_of_values_repeat1,
    STATE(116), 1,
      sym_qualified_identifier,
    STATE(186), 1,
      sym_simple_value,
    STATE(209), 1,
      sym_identifier_reference,
    ACTIONS(181), 2,
      sym_double,
      sym_rational,
    ACTIONS(185), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(187), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(135), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(219), 2,
      sym_value_constructor,
      sym_mapping_value,
    ACTIONS(183), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(129), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [6606] = 17,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(429), 1,
      sym_identifier,
    ACTIONS(432), 1,
      anon_sym_RBRACK,
    ACTIONS(434), 1,
      sym_quoted_string,
    ACTIONS(437), 1,
      anon_sym_LT,
    ACTIONS(440), 1,
      anon_sym_POUND_LBRACK,
    STATE(101), 1,
      aux_sym_sequence_of_values_repeat1,
    STATE(116), 1,
      sym_qualified_identifier,
    STATE(186), 1,
      sym_simple_value,
    STATE(209), 1,
      sym_identifier_reference,
    ACTIONS(443), 2,
      sym_double,
      sym_rational,
    ACTIONS(449), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(452), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(135), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(219), 2,
      sym_value_constructor,
      sym_mapping_value,
    ACTIONS(446), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(129), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [6668] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(419), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(415), 6,
      anon_sym_LPAREN,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
    ACTIONS(417), 15,
      anon_sym_is,
      anon_sym_end,
      anon_sym_def,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [6703] = 16,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(25), 1,
      sym_identifier,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(455), 1,
      sym_kw_is_fixed,
    STATE(8), 1,
      sym_qualified_identifier,
    STATE(234), 1,
      sym_restriction_value,
    STATE(583), 1,
      sym_identifier_reference,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(13), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(244), 2,
      sym_value_constructor,
      sym_simple_value,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(12), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [6762] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(419), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(415), 9,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_def,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
    ACTIONS(417), 12,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [6797] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(457), 1,
      anon_sym_COLON,
    STATE(125), 1,
      aux_sym_function_composition_repeat1,
    STATE(610), 1,
      sym__function_op_composition,
    ACTIONS(459), 2,
      anon_sym_u00b7,
      anon_sym_DOT,
    ACTIONS(41), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(43), 15,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [6837] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(461), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(463), 20,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_not,
      anon_sym_u00ac,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_exists,
      anon_sym_u2203,
      sym__value_empty_sequence,
  [6869] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(465), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(467), 20,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_not,
      anon_sym_u00ac,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_exists,
      anon_sym_u2203,
      sym__value_empty_sequence,
  [6901] = 15,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(25), 1,
      sym_identifier,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    STATE(8), 1,
      sym_qualified_identifier,
    STATE(248), 1,
      sym_restriction_value,
    STATE(583), 1,
      sym_identifier_reference,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(13), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(244), 2,
      sym_value_constructor,
      sym_simple_value,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(12), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [6957] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(469), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(471), 20,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_not,
      anon_sym_u00ac,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_exists,
      anon_sym_u2203,
      sym__value_empty_sequence,
  [6989] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(473), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(475), 20,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_not,
      anon_sym_u00ac,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_exists,
      anon_sym_u2203,
      sym__value_empty_sequence,
  [7021] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(477), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(479), 20,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_not,
      anon_sym_u00ac,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_exists,
      anon_sym_u2203,
      sym__value_empty_sequence,
  [7053] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(481), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(483), 20,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_not,
      anon_sym_u00ac,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_exists,
      anon_sym_u2203,
      sym__value_empty_sequence,
  [7085] = 14,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(269), 1,
      anon_sym_datatype,
    ACTIONS(271), 1,
      anon_sym_dimension,
    ACTIONS(273), 1,
      anon_sym_entity,
    ACTIONS(275), 1,
      anon_sym_enum,
    ACTIONS(277), 1,
      anon_sym_event,
    ACTIONS(279), 1,
      anon_sym_property,
    ACTIONS(281), 1,
      anon_sym_structure,
    ACTIONS(283), 1,
      anon_sym_union,
    ACTIONS(285), 1,
      anon_sym_rdf,
    ACTIONS(287), 1,
      anon_sym_class,
    ACTIONS(289), 1,
      anon_sym_end,
    STATE(122), 2,
      sym_definition,
      aux_sym_module_body_repeat3,
    STATE(261), 10,
      sym_data_type_def,
      sym_dimension_def,
      sym_entity_def,
      sym_enum_def,
      sym_event_def,
      sym_property_def,
      sym_structure_def,
      sym_union_def,
      sym_rdf_def,
      sym_type_class_def,
  [7138] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(485), 1,
      sym_identifier,
    ACTIONS(487), 22,
      anon_sym_is,
      anon_sym_end,
      anon_sym_from,
      anon_sym_RPAREN,
      anon_sym_def,
      anon_sym_LBRACE,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_parent,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_ref,
      anon_sym_COLON_EQ,
      anon_sym_u2254,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [7169] = 14,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(269), 1,
      anon_sym_datatype,
    ACTIONS(271), 1,
      anon_sym_dimension,
    ACTIONS(273), 1,
      anon_sym_entity,
    ACTIONS(275), 1,
      anon_sym_enum,
    ACTIONS(277), 1,
      anon_sym_event,
    ACTIONS(279), 1,
      anon_sym_property,
    ACTIONS(281), 1,
      anon_sym_structure,
    ACTIONS(283), 1,
      anon_sym_union,
    ACTIONS(285), 1,
      anon_sym_rdf,
    ACTIONS(287), 1,
      anon_sym_class,
    ACTIONS(489), 1,
      anon_sym_end,
    STATE(122), 2,
      sym_definition,
      aux_sym_module_body_repeat3,
    STATE(261), 10,
      sym_data_type_def,
      sym_dimension_def,
      sym_entity_def,
      sym_enum_def,
      sym_event_def,
      sym_property_def,
      sym_structure_def,
      sym_union_def,
      sym_rdf_def,
      sym_type_class_def,
  [7222] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(41), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(43), 19,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [7253] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(117), 1,
      aux_sym_function_composition_repeat1,
    STATE(610), 1,
      sym__function_op_composition,
    ACTIONS(491), 2,
      anon_sym_u00b7,
      anon_sym_DOT,
    ACTIONS(297), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(295), 15,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [7290] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(7), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(9), 19,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__value_empty_sequence,
  [7321] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(11), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(13), 19,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [7352] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(494), 1,
      sym_language_tag,
    ACTIONS(15), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(17), 18,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__value_empty_sequence,
  [7385] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(126), 1,
      aux_sym_function_composition_repeat1,
    STATE(610), 1,
      sym__function_op_composition,
    ACTIONS(459), 2,
      anon_sym_u00b7,
      anon_sym_DOT,
    ACTIONS(349), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(347), 15,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [7422] = 14,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(496), 1,
      anon_sym_end,
    ACTIONS(498), 1,
      anon_sym_datatype,
    ACTIONS(501), 1,
      anon_sym_dimension,
    ACTIONS(504), 1,
      anon_sym_entity,
    ACTIONS(507), 1,
      anon_sym_enum,
    ACTIONS(510), 1,
      anon_sym_event,
    ACTIONS(513), 1,
      anon_sym_property,
    ACTIONS(516), 1,
      anon_sym_structure,
    ACTIONS(519), 1,
      anon_sym_union,
    ACTIONS(522), 1,
      anon_sym_rdf,
    ACTIONS(525), 1,
      anon_sym_class,
    STATE(122), 2,
      sym_definition,
      aux_sym_module_body_repeat3,
    STATE(261), 10,
      sym_data_type_def,
      sym_dimension_def,
      sym_entity_def,
      sym_enum_def,
      sym_event_def,
      sym_property_def,
      sym_structure_def,
      sym_union_def,
      sym_rdf_def,
      sym_type_class_def,
  [7475] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(528), 1,
      sym_identifier,
    ACTIONS(532), 1,
      anon_sym_AT,
    ACTIONS(535), 1,
      anon_sym_assert,
    STATE(123), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
    STATE(170), 2,
      sym_annotation_property,
      sym_constraint,
    ACTIONS(530), 16,
      anon_sym_end,
      anon_sym_from,
      anon_sym_def,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
  [7514] = 14,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(269), 1,
      anon_sym_datatype,
    ACTIONS(271), 1,
      anon_sym_dimension,
    ACTIONS(273), 1,
      anon_sym_entity,
    ACTIONS(275), 1,
      anon_sym_enum,
    ACTIONS(277), 1,
      anon_sym_event,
    ACTIONS(279), 1,
      anon_sym_property,
    ACTIONS(281), 1,
      anon_sym_structure,
    ACTIONS(283), 1,
      anon_sym_union,
    ACTIONS(285), 1,
      anon_sym_rdf,
    ACTIONS(287), 1,
      anon_sym_class,
    ACTIONS(373), 1,
      anon_sym_end,
    STATE(122), 2,
      sym_definition,
      aux_sym_module_body_repeat3,
    STATE(261), 10,
      sym_data_type_def,
      sym_dimension_def,
      sym_entity_def,
      sym_enum_def,
      sym_event_def,
      sym_property_def,
      sym_structure_def,
      sym_union_def,
      sym_rdf_def,
      sym_type_class_def,
  [7567] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(117), 1,
      aux_sym_function_composition_repeat1,
    STATE(610), 1,
      sym__function_op_composition,
    ACTIONS(459), 2,
      anon_sym_u00b7,
      anon_sym_DOT,
    ACTIONS(355), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(353), 15,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [7604] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(117), 1,
      aux_sym_function_composition_repeat1,
    STATE(610), 1,
      sym__function_op_composition,
    ACTIONS(459), 2,
      anon_sym_u00b7,
      anon_sym_DOT,
    ACTIONS(355), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(353), 15,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [7641] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(155), 1,
      sym_identifier,
    STATE(80), 1,
      sym__type_op_has_type,
    ACTIONS(538), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(157), 18,
      anon_sym_end,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
  [7675] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(53), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(55), 18,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__value_empty_sequence,
  [7705] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(57), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(59), 18,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__value_empty_sequence,
  [7735] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(47), 18,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__value_empty_sequence,
  [7765] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(37), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(39), 18,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__value_empty_sequence,
  [7795] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(21), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(23), 18,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__value_empty_sequence,
  [7825] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(49), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(51), 18,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__value_empty_sequence,
  [7855] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(540), 1,
      sym_identifier,
    ACTIONS(542), 21,
      anon_sym_is,
      anon_sym_end,
      anon_sym_from,
      anon_sym_RPAREN,
      anon_sym_def,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_parent,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_ref,
      anon_sym_COLON_EQ,
      anon_sym_u2254,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [7885] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(61), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(63), 18,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__value_empty_sequence,
  [7915] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(371), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(369), 17,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_u00b7,
      anon_sym_DOT,
      sym__value_empty_sequence,
  [7944] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(546), 2,
      anon_sym_and,
      anon_sym_u2227,
    ACTIONS(548), 2,
      anon_sym_or,
      anon_sym_u2228,
    ACTIONS(550), 2,
      anon_sym_xor,
      anon_sym_u22bb,
    ACTIONS(544), 3,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    ACTIONS(552), 3,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
    ACTIONS(554), 3,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
    STATE(21), 6,
      sym__logical_connective,
      sym_logical_op_conjunction,
      sym_logical_op_disjunction,
      sym_logical_op_exclusive_disjunction,
      sym_logical_op_implication,
      sym_logical_op_biconditional,
  [7983] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(21), 6,
      sym__logical_connective,
      sym_logical_op_conjunction,
      sym_logical_op_disjunction,
      sym_logical_op_exclusive_disjunction,
      sym_logical_op_implication,
      sym_logical_op_biconditional,
    ACTIONS(556), 15,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [8012] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(546), 2,
      anon_sym_and,
      anon_sym_u2227,
    ACTIONS(548), 2,
      anon_sym_or,
      anon_sym_u2228,
    ACTIONS(550), 2,
      anon_sym_xor,
      anon_sym_u22bb,
    ACTIONS(544), 3,
      anon_sym_is,
      anon_sym_end,
      anon_sym_def,
    ACTIONS(552), 3,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
    ACTIONS(554), 3,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
    STATE(30), 6,
      sym__logical_connective,
      sym_logical_op_conjunction,
      sym_logical_op_disjunction,
      sym_logical_op_exclusive_disjunction,
      sym_logical_op_implication,
      sym_logical_op_biconditional,
  [8051] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(30), 6,
      sym__logical_connective,
      sym_logical_op_conjunction,
      sym_logical_op_disjunction,
      sym_logical_op_exclusive_disjunction,
      sym_logical_op_implication,
      sym_logical_op_biconditional,
    ACTIONS(558), 15,
      anon_sym_is,
      anon_sym_end,
      anon_sym_def,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [8080] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(30), 6,
      sym__logical_connective,
      sym_logical_op_conjunction,
      sym_logical_op_disjunction,
      sym_logical_op_exclusive_disjunction,
      sym_logical_op_implication,
      sym_logical_op_biconditional,
    ACTIONS(556), 15,
      anon_sym_is,
      anon_sym_end,
      anon_sym_def,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [8109] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(546), 2,
      anon_sym_and,
      anon_sym_u2227,
    ACTIONS(548), 2,
      anon_sym_or,
      anon_sym_u2228,
    ACTIONS(550), 2,
      anon_sym_xor,
      anon_sym_u22bb,
    ACTIONS(552), 3,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
    ACTIONS(554), 3,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
    ACTIONS(560), 3,
      anon_sym_is,
      anon_sym_end,
      anon_sym_def,
    STATE(30), 6,
      sym__logical_connective,
      sym_logical_op_conjunction,
      sym_logical_op_disjunction,
      sym_logical_op_exclusive_disjunction,
      sym_logical_op_implication,
      sym_logical_op_biconditional,
  [8148] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(21), 6,
      sym__logical_connective,
      sym_logical_op_conjunction,
      sym_logical_op_disjunction,
      sym_logical_op_exclusive_disjunction,
      sym_logical_op_implication,
      sym_logical_op_biconditional,
    ACTIONS(558), 15,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [8177] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(401), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(399), 16,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [8205] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(389), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(387), 16,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [8233] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(413), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(411), 16,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [8261] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(79), 1,
      sym__type_op_has_type,
    ACTIONS(562), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(155), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(157), 13,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [8293] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(568), 1,
      anon_sym_LPAREN,
    STATE(172), 1,
      sym__actual_arguments,
    ACTIONS(564), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(566), 14,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [8325] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(381), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(379), 16,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [8353] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(397), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(395), 16,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [8381] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(393), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(391), 16,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [8409] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(574), 1,
      sym_controlled_language_tag,
    ACTIONS(570), 2,
      sym_identifier,
      anon_sym_AT,
    ACTIONS(572), 17,
      anon_sym_end,
      anon_sym_from,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
  [8439] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(385), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(383), 16,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [8467] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(291), 1,
      anon_sym_COLON,
    ACTIONS(578), 1,
      anon_sym_as,
    STATE(189), 1,
      sym_iri,
    STATE(191), 1,
      sym__rename_import,
    ACTIONS(576), 15,
      anon_sym_end,
      anon_sym_import,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [8503] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(79), 1,
      sym__type_op_has_type,
    ACTIONS(562), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(413), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(411), 13,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [8535] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(580), 1,
      anon_sym_end,
    ACTIONS(546), 2,
      anon_sym_and,
      anon_sym_u2227,
    ACTIONS(548), 2,
      anon_sym_or,
      anon_sym_u2228,
    ACTIONS(550), 2,
      anon_sym_xor,
      anon_sym_u22bb,
    ACTIONS(552), 3,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
    ACTIONS(554), 3,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
    STATE(21), 6,
      sym__logical_connective,
      sym_logical_op_conjunction,
      sym_logical_op_disjunction,
      sym_logical_op_exclusive_disjunction,
      sym_logical_op_implication,
      sym_logical_op_biconditional,
  [8572] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(584), 1,
      anon_sym_LPAREN,
    STATE(160), 1,
      sym__actual_arguments,
    ACTIONS(582), 17,
      anon_sym_is,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [8601] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(586), 1,
      sym_identifier,
    ACTIONS(588), 18,
      anon_sym_end,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
  [8628] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(457), 1,
      anon_sym_COLON,
    ACTIONS(41), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(43), 14,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [8657] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(415), 19,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [8682] = 11,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    STATE(585), 1,
      sym_simple_value,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(13), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(12), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [8725] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(590), 1,
      anon_sym_RPAREN,
    ACTIONS(546), 2,
      anon_sym_and,
      anon_sym_u2227,
    ACTIONS(548), 2,
      anon_sym_or,
      anon_sym_u2228,
    ACTIONS(550), 2,
      anon_sym_xor,
      anon_sym_u22bb,
    ACTIONS(552), 3,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
    ACTIONS(554), 3,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
    STATE(21), 6,
      sym__logical_connective,
      sym_logical_op_conjunction,
      sym_logical_op_disjunction,
      sym_logical_op_exclusive_disjunction,
      sym_logical_op_implication,
      sym_logical_op_biconditional,
  [8762] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(592), 1,
      anon_sym_RBRACE,
    ACTIONS(603), 1,
      anon_sym_explicitTimezone,
    ACTIONS(606), 1,
      anon_sym_pattern,
    ACTIONS(597), 2,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
    ACTIONS(594), 3,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
    ACTIONS(600), 4,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
    STATE(163), 7,
      sym__restriction_facet,
      sym_length_restriction_facet,
      sym_digit_restriction_facet,
      sym_value_restriction_facet,
      sym_tz_restriction_facet,
      sym_pattern_restriction_facet,
      aux_sym_datatype_def_restriction_repeat1,
  [8799] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(609), 1,
      anon_sym_end,
    ACTIONS(546), 2,
      anon_sym_and,
      anon_sym_u2227,
    ACTIONS(548), 2,
      anon_sym_or,
      anon_sym_u2228,
    ACTIONS(550), 2,
      anon_sym_xor,
      anon_sym_u22bb,
    ACTIONS(552), 3,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
    ACTIONS(554), 3,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
    STATE(21), 6,
      sym__logical_connective,
      sym_logical_op_conjunction,
      sym_logical_op_disjunction,
      sym_logical_op_exclusive_disjunction,
      sym_logical_op_implication,
      sym_logical_op_biconditional,
  [8836] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(349), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(347), 15,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [8863] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(611), 1,
      sym_identifier,
    ACTIONS(613), 18,
      anon_sym_end,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
  [8890] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(615), 1,
      sym_identifier,
    ACTIONS(617), 18,
      anon_sym_end,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
  [8917] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(619), 1,
      anon_sym_RBRACE,
    ACTIONS(627), 1,
      anon_sym_explicitTimezone,
    ACTIONS(629), 1,
      anon_sym_pattern,
    ACTIONS(623), 2,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
    ACTIONS(621), 3,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
    ACTIONS(625), 4,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
    STATE(163), 7,
      sym__restriction_facet,
      sym_length_restriction_facet,
      sym_digit_restriction_facet,
      sym_value_restriction_facet,
      sym_tz_restriction_facet,
      sym_pattern_restriction_facet,
      aux_sym_datatype_def_restriction_repeat1,
  [8954] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(409), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(407), 15,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [8981] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(631), 1,
      sym_identifier,
    ACTIONS(633), 18,
      anon_sym_end,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
  [9008] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(635), 1,
      sym_identifier,
    ACTIONS(637), 18,
      anon_sym_end,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
  [9035] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(419), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(415), 15,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [9062] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(405), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(403), 15,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [9089] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(584), 1,
      anon_sym_LPAREN,
    STATE(160), 1,
      sym__actual_arguments,
    ACTIONS(639), 17,
      anon_sym_is,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [9118] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(377), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(375), 15,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [9145] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(641), 1,
      sym_identifier,
    ACTIONS(643), 18,
      anon_sym_end,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
  [9172] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(645), 1,
      sym_identifier,
    ACTIONS(647), 18,
      anon_sym_is,
      anon_sym_end,
      anon_sym_from,
      anon_sym_RPAREN,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_parent,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_ref,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [9199] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(159), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(651), 13,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [9227] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(655), 1,
      anon_sym_import,
    ACTIONS(658), 1,
      anon_sym_from,
    STATE(595), 1,
      sym_from_clause,
    STATE(179), 2,
      sym_import_statement,
      aux_sym_module_body_repeat1,
    ACTIONS(653), 13,
      anon_sym_end,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [9259] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(627), 1,
      anon_sym_explicitTimezone,
    ACTIONS(629), 1,
      anon_sym_pattern,
    ACTIONS(623), 2,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
    ACTIONS(621), 3,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
    ACTIONS(625), 4,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
    STATE(168), 7,
      sym__restriction_facet,
      sym_length_restriction_facet,
      sym_digit_restriction_facet,
      sym_value_restriction_facet,
      sym_tz_restriction_facet,
      sym_pattern_restriction_facet,
      aux_sym_datatype_def_restriction_repeat1,
  [9293] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(578), 1,
      anon_sym_as,
    STATE(188), 1,
      sym__rename_import,
    ACTIONS(661), 15,
      anon_sym_end,
      anon_sym_import,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [9320] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(663), 1,
      sym_identifier,
    ACTIONS(665), 1,
      anon_sym_is,
    STATE(213), 1,
      sym_annotation_only_body,
    ACTIONS(667), 14,
      anon_sym_end,
      anon_sym_from,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_parent,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_ref,
  [9349] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(649), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(651), 13,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [9374] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(669), 17,
      anon_sym_is,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [9397] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(584), 1,
      anon_sym_LPAREN,
    ACTIONS(671), 1,
      anon_sym_EQ,
    STATE(104), 1,
      sym__actual_arguments,
    ACTIONS(673), 2,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
    ACTIONS(675), 2,
      sym_op_less_than,
      sym_op_greater_than,
    ACTIONS(677), 2,
      anon_sym_LT_EQ,
      anon_sym_u2264,
    ACTIONS(679), 2,
      anon_sym_GT_EQ,
      anon_sym_u2265,
    ACTIONS(560), 3,
      anon_sym_is,
      anon_sym_end,
      anon_sym_def,
    STATE(64), 3,
      sym_op_inequality,
      sym_op_less_than_or_equal,
      sym_op_greater_than_or_equal,
  [9436] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(79), 1,
      sym__type_op_has_type,
    ACTIONS(562), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(681), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(683), 10,
      anon_sym_RBRACK,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
  [9465] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(685), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(687), 13,
      anon_sym_LBRACK,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [9490] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(689), 1,
      sym_identifier,
    ACTIONS(691), 16,
      anon_sym_end,
      anon_sym_import,
      anon_sym_RBRACK,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [9515] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(578), 1,
      anon_sym_as,
    STATE(195), 1,
      sym__rename_import,
    ACTIONS(693), 15,
      anon_sym_end,
      anon_sym_import,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [9542] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(695), 17,
      anon_sym_is,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [9565] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(697), 1,
      sym_identifier,
    ACTIONS(699), 16,
      anon_sym_end,
      anon_sym_import,
      anon_sym_RBRACK,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [9590] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(669), 17,
      anon_sym_is,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [9613] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(701), 1,
      sym_identifier,
    ACTIONS(703), 16,
      anon_sym_end,
      anon_sym_import,
      anon_sym_RBRACK,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [9638] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(705), 17,
      anon_sym_is,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [9661] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(707), 1,
      sym_identifier,
    ACTIONS(709), 16,
      anon_sym_end,
      anon_sym_import,
      anon_sym_RBRACK,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [9686] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(711), 17,
      anon_sym_is,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [9709] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(713), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(715), 13,
      anon_sym_LBRACK,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [9734] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(717), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(719), 13,
      anon_sym_LBRACK,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [9759] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(669), 17,
      anon_sym_is,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [9782] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(721), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(723), 13,
      anon_sym_LBRACK,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [9807] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(665), 1,
      anon_sym_is,
    STATE(232), 1,
      sym_rdf_types,
    STATE(282), 1,
      sym_annotation_only_body,
    ACTIONS(727), 2,
      anon_sym_a,
      anon_sym_type,
    ACTIONS(725), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [9837] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(584), 1,
      anon_sym_LPAREN,
    ACTIONS(671), 1,
      anon_sym_EQ,
    STATE(96), 1,
      sym__actual_arguments,
    ACTIONS(560), 2,
      anon_sym_is,
      anon_sym_def,
    ACTIONS(673), 2,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
    ACTIONS(675), 2,
      sym_op_less_than,
      sym_op_greater_than,
    ACTIONS(677), 2,
      anon_sym_LT_EQ,
      anon_sym_u2264,
    ACTIONS(679), 2,
      anon_sym_GT_EQ,
      anon_sym_u2265,
    STATE(64), 3,
      sym_op_inequality,
      sym_op_less_than_or_equal,
      sym_op_greater_than_or_equal,
  [9875] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(729), 1,
      sym_identifier,
    ACTIONS(731), 15,
      anon_sym_is,
      anon_sym_end,
      anon_sym_from,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_parent,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_ref,
  [9899] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(733), 1,
      sym_identifier,
    ACTIONS(735), 15,
      anon_sym_end,
      anon_sym_from,
      anon_sym_def,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_parent,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_ref,
  [9923] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(737), 1,
      sym_identifier,
    ACTIONS(739), 15,
      anon_sym_is,
      anon_sym_end,
      anon_sym_from,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_parent,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_ref,
  [9947] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(741), 15,
      anon_sym_end,
      anon_sym_import,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [9968] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(743), 15,
      anon_sym_end,
      anon_sym_import,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [9989] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(745), 15,
      anon_sym_end,
      anon_sym_import,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10010] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(159), 1,
      anon_sym_LPAREN,
    ACTIONS(681), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(683), 10,
      anon_sym_RBRACK,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
  [10035] = 12,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(265), 1,
      anon_sym_AT,
    ACTIONS(267), 1,
      anon_sym_assert,
    ACTIONS(747), 1,
      sym_identifier,
    ACTIONS(749), 1,
      anon_sym_end,
    ACTIONS(751), 1,
      anon_sym_from,
    ACTIONS(753), 1,
      anon_sym_ref,
    STATE(356), 1,
      sym_from_definition_clause,
    STATE(123), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
    STATE(170), 2,
      sym_annotation_property,
      sym_constraint,
    STATE(355), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(428), 2,
      sym_member_def,
      sym_property_ref,
  [10076] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(665), 1,
      anon_sym_is,
    ACTIONS(757), 1,
      anon_sym_LBRACE,
    STATE(224), 1,
      sym_datatype_def_restriction,
    STATE(260), 1,
      sym_annotation_only_body,
    ACTIONS(755), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10105] = 12,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(265), 1,
      anon_sym_AT,
    ACTIONS(267), 1,
      anon_sym_assert,
    ACTIONS(747), 1,
      sym_identifier,
    ACTIONS(751), 1,
      anon_sym_from,
    ACTIONS(753), 1,
      anon_sym_ref,
    ACTIONS(759), 1,
      anon_sym_end,
    STATE(373), 1,
      sym_from_definition_clause,
    STATE(170), 2,
      sym_annotation_property,
      sym_constraint,
    STATE(210), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
    STATE(371), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(428), 2,
      sym_member_def,
      sym_property_ref,
  [10146] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(761), 1,
      sym_identifier,
    ACTIONS(763), 14,
      anon_sym_end,
      anon_sym_from,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_parent,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_ref,
  [10169] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(665), 1,
      anon_sym_is,
    ACTIONS(757), 1,
      anon_sym_LBRACE,
    STATE(230), 1,
      sym_datatype_def_restriction,
    STATE(266), 1,
      sym_annotation_only_body,
    ACTIONS(765), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10198] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(767), 15,
      anon_sym_end,
      anon_sym_import,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10219] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(769), 1,
      anon_sym_is,
    ACTIONS(773), 1,
      anon_sym_LPAREN,
    STATE(284), 1,
      sym_type_class_body,
    ACTIONS(771), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10245] = 9,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(584), 1,
      anon_sym_LPAREN,
    ACTIONS(671), 1,
      anon_sym_EQ,
    STATE(102), 1,
      sym__actual_arguments,
    ACTIONS(673), 2,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
    ACTIONS(675), 2,
      sym_op_less_than,
      sym_op_greater_than,
    ACTIONS(677), 2,
      anon_sym_LT_EQ,
      anon_sym_u2264,
    ACTIONS(679), 2,
      anon_sym_GT_EQ,
      anon_sym_u2265,
    STATE(64), 3,
      sym_op_inequality,
      sym_op_less_than_or_equal,
      sym_op_greater_than_or_equal,
  [10279] = 12,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(265), 1,
      anon_sym_AT,
    ACTIONS(267), 1,
      anon_sym_assert,
    ACTIONS(751), 1,
      anon_sym_from,
    ACTIONS(775), 1,
      sym_identifier,
    ACTIONS(777), 1,
      anon_sym_end,
    STATE(116), 1,
      sym_qualified_identifier,
    STATE(399), 1,
      sym_from_definition_clause,
    STATE(432), 1,
      sym_identifier_reference,
    STATE(123), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
    STATE(170), 2,
      sym_annotation_property,
      sym_constraint,
    STATE(412), 2,
      sym_type_variant,
      aux_sym_union_body_repeat1,
  [10319] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(681), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(683), 10,
      anon_sym_RBRACK,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
  [10341] = 9,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(584), 1,
      anon_sym_LPAREN,
    ACTIONS(671), 1,
      anon_sym_EQ,
    STATE(96), 1,
      sym__actual_arguments,
    ACTIONS(673), 2,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
    ACTIONS(675), 2,
      sym_op_less_than,
      sym_op_greater_than,
    ACTIONS(677), 2,
      anon_sym_LT_EQ,
      anon_sym_u2264,
    ACTIONS(679), 2,
      anon_sym_GT_EQ,
      anon_sym_u2265,
    STATE(64), 3,
      sym_op_inequality,
      sym_op_less_than_or_equal,
      sym_op_greater_than_or_equal,
  [10375] = 12,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(265), 1,
      anon_sym_AT,
    ACTIONS(267), 1,
      anon_sym_assert,
    ACTIONS(751), 1,
      anon_sym_from,
    ACTIONS(775), 1,
      sym_identifier,
    ACTIONS(779), 1,
      anon_sym_end,
    STATE(116), 1,
      sym_qualified_identifier,
    STATE(411), 1,
      sym_from_definition_clause,
    STATE(432), 1,
      sym_identifier_reference,
    STATE(170), 2,
      sym_annotation_property,
      sym_constraint,
    STATE(218), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
    STATE(408), 2,
      sym_type_variant,
      aux_sym_union_body_repeat1,
  [10415] = 12,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(265), 1,
      anon_sym_AT,
    ACTIONS(267), 1,
      anon_sym_assert,
    ACTIONS(751), 1,
      anon_sym_from,
    ACTIONS(781), 1,
      anon_sym_end,
    ACTIONS(783), 1,
      anon_sym_def,
    STATE(342), 1,
      sym_function_signature,
    STATE(433), 1,
      sym_from_definition_clause,
    STATE(443), 1,
      aux_sym_type_class_body_repeat1,
    STATE(538), 1,
      sym_method_def,
    STATE(123), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
    STATE(170), 2,
      sym_annotation_property,
      sym_constraint,
  [10454] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(787), 1,
      anon_sym_of,
    STATE(272), 1,
      sym_union_body,
    ACTIONS(785), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10477] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(665), 1,
      anon_sym_is,
    STATE(303), 1,
      sym_annotation_only_body,
    ACTIONS(789), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10500] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(791), 1,
      anon_sym_is,
    STATE(271), 1,
      sym_structure_body,
    ACTIONS(793), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10523] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(769), 1,
      anon_sym_is,
    STATE(304), 1,
      sym_type_class_body,
    ACTIONS(795), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10546] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(797), 1,
      anon_sym_is,
    STATE(270), 1,
      sym_event_body,
    ACTIONS(799), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10569] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(803), 1,
      anon_sym_of,
    STATE(268), 1,
      sym_enum_body,
    ACTIONS(801), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10592] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(805), 1,
      anon_sym_is,
    STATE(264), 1,
      sym_dimension_body,
    ACTIONS(807), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10615] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(665), 1,
      anon_sym_is,
    STATE(290), 1,
      sym_annotation_only_body,
    ACTIONS(809), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10638] = 12,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(265), 1,
      anon_sym_AT,
    ACTIONS(267), 1,
      anon_sym_assert,
    ACTIONS(751), 1,
      anon_sym_from,
    ACTIONS(783), 1,
      anon_sym_def,
    ACTIONS(811), 1,
      anon_sym_end,
    STATE(342), 1,
      sym_function_signature,
    STATE(439), 1,
      sym_from_definition_clause,
    STATE(441), 1,
      aux_sym_type_class_body_repeat1,
    STATE(538), 1,
      sym_method_def,
    STATE(170), 2,
      sym_annotation_property,
      sym_constraint,
    STATE(222), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
  [10677] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(665), 1,
      anon_sym_is,
    STATE(305), 1,
      sym_annotation_only_body,
    ACTIONS(813), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10700] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(815), 1,
      anon_sym_is,
    STATE(267), 1,
      sym_entity_body,
    ACTIONS(817), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10723] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(819), 12,
      anon_sym_RBRACE,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
  [10741] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(821), 12,
      anon_sym_RBRACE,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
  [10759] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(823), 12,
      anon_sym_RBRACE,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
  [10777] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(825), 12,
      anon_sym_is,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10795] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(827), 12,
      anon_sym_RBRACE,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
  [10813] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(747), 1,
      sym_identifier,
    ACTIONS(751), 1,
      anon_sym_from,
    ACTIONS(753), 1,
      anon_sym_ref,
    ACTIONS(829), 1,
      anon_sym_end,
    ACTIONS(831), 1,
      anon_sym_parent,
    STATE(389), 1,
      sym_from_definition_clause,
    STATE(252), 2,
      sym_dimension_parent,
      aux_sym_dimension_body_repeat1,
    STATE(391), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(428), 2,
      sym_member_def,
      sym_property_ref,
  [10847] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(833), 12,
      anon_sym_RBRACE,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
  [10865] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(835), 12,
      anon_sym_RBRACE,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
  [10883] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(265), 1,
      anon_sym_AT,
    ACTIONS(267), 1,
      anon_sym_assert,
    ACTIONS(751), 1,
      anon_sym_from,
    ACTIONS(837), 1,
      sym_identifier,
    ACTIONS(839), 1,
      anon_sym_end,
    STATE(465), 1,
      sym_from_definition_clause,
    STATE(170), 2,
      sym_annotation_property,
      sym_constraint,
    STATE(249), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
    STATE(463), 2,
      sym_value_variant,
      aux_sym_enum_body_repeat1,
  [10917] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(841), 12,
      anon_sym_is,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10935] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(843), 12,
      anon_sym_RBRACE,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
  [10953] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(845), 12,
      anon_sym_RBRACE,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
  [10971] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(747), 1,
      sym_identifier,
    ACTIONS(751), 1,
      anon_sym_from,
    ACTIONS(753), 1,
      anon_sym_ref,
    ACTIONS(831), 1,
      anon_sym_parent,
    ACTIONS(847), 1,
      anon_sym_end,
    STATE(382), 1,
      sym_from_definition_clause,
    STATE(254), 2,
      sym_dimension_parent,
      aux_sym_dimension_body_repeat1,
    STATE(394), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(428), 2,
      sym_member_def,
      sym_property_ref,
  [11005] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(849), 12,
      anon_sym_RBRACE,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
  [11023] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(851), 12,
      anon_sym_RBRACE,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
  [11041] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(265), 1,
      anon_sym_AT,
    ACTIONS(267), 1,
      anon_sym_assert,
    ACTIONS(751), 1,
      anon_sym_from,
    ACTIONS(837), 1,
      sym_identifier,
    ACTIONS(853), 1,
      anon_sym_end,
    STATE(481), 1,
      sym_from_definition_clause,
    STATE(123), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
    STATE(170), 2,
      sym_annotation_property,
      sym_constraint,
    STATE(479), 2,
      sym_value_variant,
      aux_sym_enum_body_repeat1,
  [11075] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(855), 12,
      anon_sym_RBRACE,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
  [11093] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(857), 12,
      anon_sym_RBRACE,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
  [11111] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(747), 1,
      sym_identifier,
    ACTIONS(751), 1,
      anon_sym_from,
    ACTIONS(753), 1,
      anon_sym_ref,
    ACTIONS(831), 1,
      anon_sym_parent,
    ACTIONS(859), 1,
      anon_sym_end,
    STATE(361), 1,
      sym_from_definition_clause,
    STATE(362), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(386), 2,
      sym_dimension_parent,
      aux_sym_dimension_body_repeat1,
    STATE(428), 2,
      sym_member_def,
      sym_property_ref,
  [11145] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(861), 12,
      anon_sym_is,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11163] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(747), 1,
      sym_identifier,
    ACTIONS(751), 1,
      anon_sym_from,
    ACTIONS(753), 1,
      anon_sym_ref,
    ACTIONS(831), 1,
      anon_sym_parent,
    ACTIONS(863), 1,
      anon_sym_end,
    STATE(385), 1,
      sym_from_definition_clause,
    STATE(386), 2,
      sym_dimension_parent,
      aux_sym_dimension_body_repeat1,
    STATE(387), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(428), 2,
      sym_member_def,
      sym_property_ref,
  [11197] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(865), 12,
      anon_sym_is,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11215] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(867), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11232] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(869), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11249] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(871), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11266] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(873), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11283] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(875), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11300] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(877), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11317] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(879), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11334] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(881), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11351] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(883), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11368] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(885), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11385] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(887), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11402] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(889), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11419] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(891), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11436] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(893), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11453] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(895), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11470] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(897), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11487] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(899), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11504] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(901), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11521] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(903), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11538] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(905), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11555] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(907), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11572] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(909), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11589] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(911), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11606] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(913), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11623] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(915), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11640] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(917), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11657] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(919), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11674] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(921), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11691] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(923), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11708] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(925), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11725] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(927), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11742] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(929), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11759] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(931), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11776] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(933), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11793] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(935), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11810] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(937), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11827] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(939), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11844] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(941), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11861] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(943), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11878] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(945), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11895] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(947), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11912] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(949), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11929] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(951), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11946] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(953), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11963] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(955), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11980] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(957), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11997] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(959), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [12014] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(961), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [12031] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(963), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [12048] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(965), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [12065] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(967), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [12082] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(969), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [12099] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(971), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [12116] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(973), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [12133] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(975), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [12150] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(977), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [12167] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(979), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [12184] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(981), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [12201] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(983), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [12218] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(985), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [12235] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(987), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [12252] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(989), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [12269] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(991), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [12286] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(993), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [12303] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(995), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [12320] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(997), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [12337] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(999), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [12354] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1001), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [12371] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1003), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [12388] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1005), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [12405] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1007), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [12422] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1009), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [12439] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1011), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [12456] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1013), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [12473] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1015), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [12490] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(265), 1,
      anon_sym_AT,
    ACTIONS(267), 1,
      anon_sym_assert,
    ACTIONS(1017), 1,
      anon_sym_source,
    ACTIONS(1019), 1,
      anon_sym_identity,
    STATE(123), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
    STATE(170), 2,
      sym_annotation_property,
      sym_constraint,
    STATE(239), 2,
      sym_source_entity,
      sym_entity_identity,
  [12518] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(265), 1,
      anon_sym_AT,
    ACTIONS(267), 1,
      anon_sym_assert,
    ACTIONS(1017), 1,
      anon_sym_source,
    ACTIONS(1019), 1,
      anon_sym_identity,
    STATE(170), 2,
      sym_annotation_property,
      sym_constraint,
    STATE(246), 2,
      sym_source_entity,
      sym_entity_identity,
    STATE(331), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
  [12546] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(747), 1,
      sym_identifier,
    ACTIONS(751), 1,
      anon_sym_from,
    ACTIONS(753), 1,
      anon_sym_ref,
    ACTIONS(1021), 1,
      anon_sym_end,
    STATE(372), 1,
      sym_from_definition_clause,
    STATE(366), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(428), 2,
      sym_member_def,
      sym_property_ref,
  [12573] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1023), 1,
      anon_sym_RBRACE,
    ACTIONS(1025), 1,
      sym_unsigned,
    STATE(410), 1,
      sym_sequence_ordering,
    STATE(499), 1,
      sym_sequence_uniqueness,
    STATE(579), 1,
      sym__cardinality_inner,
    ACTIONS(1027), 2,
      anon_sym_ordered,
      anon_sym_unordered,
    ACTIONS(1029), 2,
      anon_sym_unique,
      anon_sym_nonunique,
  [12600] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(747), 1,
      sym_identifier,
    ACTIONS(751), 1,
      anon_sym_from,
    ACTIONS(753), 1,
      anon_sym_ref,
    ACTIONS(1031), 1,
      anon_sym_end,
    STATE(381), 1,
      sym_from_definition_clause,
    STATE(380), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(428), 2,
      sym_member_def,
      sym_property_ref,
  [12627] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(747), 1,
      sym_identifier,
    ACTIONS(751), 1,
      anon_sym_from,
    ACTIONS(753), 1,
      anon_sym_ref,
    ACTIONS(1033), 1,
      anon_sym_end,
    STATE(349), 1,
      sym_from_definition_clause,
    STATE(395), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(428), 2,
      sym_member_def,
      sym_property_ref,
  [12654] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1035), 1,
      sym_identifier,
    STATE(456), 1,
      aux_sym_sequence_builder_repeat1,
    STATE(482), 1,
      sym_sequence_ordering,
    STATE(545), 1,
      sym_variable,
    STATE(626), 1,
      sym_sequence_uniqueness,
    ACTIONS(1027), 2,
      anon_sym_ordered,
      anon_sym_unordered,
    ACTIONS(1029), 2,
      anon_sym_unique,
      anon_sym_nonunique,
  [12681] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(747), 1,
      sym_identifier,
    ACTIONS(751), 1,
      anon_sym_from,
    ACTIONS(753), 1,
      anon_sym_ref,
    ACTIONS(1037), 1,
      anon_sym_end,
    STATE(375), 1,
      sym_from_definition_clause,
    STATE(374), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(428), 2,
      sym_member_def,
      sym_property_ref,
  [12708] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(565), 1,
      sym_quantified_variable_binding,
    STATE(577), 1,
      sym_quantified_sentence,
    STATE(621), 1,
      sym_sequence_builder_body,
    ACTIONS(95), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(97), 2,
      anon_sym_exists,
      anon_sym_u2203,
    STATE(513), 2,
      sym_logical_quantifier_universal,
      sym_logical_quantifier_existential,
  [12733] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1035), 1,
      sym_identifier,
    STATE(453), 1,
      aux_sym_sequence_builder_repeat1,
    STATE(482), 1,
      sym_sequence_ordering,
    STATE(545), 1,
      sym_variable,
    STATE(626), 1,
      sym_sequence_uniqueness,
    ACTIONS(1027), 2,
      anon_sym_ordered,
      anon_sym_unordered,
    ACTIONS(1029), 2,
      anon_sym_unique,
      anon_sym_nonunique,
  [12760] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(565), 1,
      sym_quantified_variable_binding,
    STATE(574), 1,
      sym_sequence_builder_body,
    STATE(577), 1,
      sym_quantified_sentence,
    ACTIONS(95), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(97), 2,
      anon_sym_exists,
      anon_sym_u2203,
    STATE(513), 2,
      sym_logical_quantifier_universal,
      sym_logical_quantifier_existential,
  [12785] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(665), 1,
      anon_sym_is,
    STATE(23), 1,
      sym__function_op_by_definition,
    STATE(472), 1,
      sym_function_body,
    STATE(529), 1,
      sym_annotation_only_body,
    ACTIONS(1039), 2,
      anon_sym_end,
      anon_sym_def,
    ACTIONS(1041), 2,
      anon_sym_COLON_EQ,
      anon_sym_u2254,
  [12809] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(265), 1,
      anon_sym_AT,
    ACTIONS(267), 1,
      anon_sym_assert,
    ACTIONS(1019), 1,
      anon_sym_identity,
    STATE(333), 1,
      sym_entity_identity,
    STATE(170), 2,
      sym_annotation_property,
      sym_constraint,
    STATE(344), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
  [12833] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(265), 1,
      anon_sym_AT,
    ACTIONS(267), 1,
      anon_sym_assert,
    ACTIONS(1019), 1,
      anon_sym_identity,
    STATE(336), 1,
      sym_entity_identity,
    STATE(123), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
    STATE(170), 2,
      sym_annotation_property,
      sym_constraint,
  [12857] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1025), 1,
      sym_unsigned,
    STATE(427), 1,
      sym_sequence_ordering,
    STATE(547), 1,
      sym_sequence_uniqueness,
    STATE(619), 1,
      sym__cardinality_inner,
    ACTIONS(1027), 2,
      anon_sym_ordered,
      anon_sym_unordered,
    ACTIONS(1029), 2,
      anon_sym_unique,
      anon_sym_nonunique,
  [12881] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(265), 1,
      anon_sym_AT,
    ACTIONS(267), 1,
      anon_sym_assert,
    ACTIONS(1017), 1,
      anon_sym_source,
    STATE(335), 1,
      sym_source_entity,
    STATE(123), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
    STATE(170), 2,
      sym_annotation_property,
      sym_constraint,
  [12905] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(265), 1,
      anon_sym_AT,
    ACTIONS(267), 1,
      anon_sym_assert,
    ACTIONS(1017), 1,
      anon_sym_source,
    STATE(338), 1,
      sym_source_entity,
    STATE(170), 2,
      sym_annotation_property,
      sym_constraint,
    STATE(346), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
  [12929] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(747), 1,
      sym_identifier,
    ACTIONS(753), 1,
      anon_sym_ref,
    ACTIONS(1043), 1,
      anon_sym_end,
    STATE(352), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(428), 2,
      sym_member_def,
      sym_property_ref,
  [12950] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(747), 1,
      sym_identifier,
    ACTIONS(753), 1,
      anon_sym_ref,
    ACTIONS(1045), 1,
      anon_sym_end,
    STATE(370), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(428), 2,
      sym_member_def,
      sym_property_ref,
  [12971] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1047), 1,
      sym_identifier,
    ACTIONS(1049), 1,
      anon_sym_RBRACK,
    STATE(460), 1,
      sym_qualified_identifier,
    STATE(378), 4,
      sym__import,
      sym_member_import,
      sym_module_import,
      aux_sym_import_statement_repeat1,
  [12990] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1051), 1,
      sym_identifier,
    ACTIONS(1053), 6,
      anon_sym_is,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_def,
      anon_sym_COLON_EQ,
      anon_sym_u2254,
  [13005] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1055), 1,
      sym_identifier,
    ACTIONS(1058), 1,
      anon_sym_end,
    ACTIONS(1060), 1,
      anon_sym_ref,
    STATE(352), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(428), 2,
      sym_member_def,
      sym_property_ref,
  [13026] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1063), 1,
      sym_identifier,
    ACTIONS(1065), 6,
      anon_sym_is,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_def,
      anon_sym_COLON_EQ,
      anon_sym_u2254,
  [13041] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(747), 1,
      sym_identifier,
    ACTIONS(753), 1,
      anon_sym_ref,
    ACTIONS(1067), 1,
      anon_sym_end,
    STATE(352), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(428), 2,
      sym_member_def,
      sym_property_ref,
  [13062] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(747), 1,
      sym_identifier,
    ACTIONS(753), 1,
      anon_sym_ref,
    ACTIONS(1069), 1,
      anon_sym_end,
    STATE(352), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(428), 2,
      sym_member_def,
      sym_property_ref,
  [13083] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(747), 1,
      sym_identifier,
    ACTIONS(753), 1,
      anon_sym_ref,
    ACTIONS(1071), 1,
      anon_sym_end,
    STATE(376), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(428), 2,
      sym_member_def,
      sym_property_ref,
  [13104] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(747), 1,
      sym_identifier,
    ACTIONS(753), 1,
      anon_sym_ref,
    ACTIONS(1073), 1,
      anon_sym_end,
    STATE(352), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(428), 2,
      sym_member_def,
      sym_property_ref,
  [13125] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1047), 1,
      sym_identifier,
    ACTIONS(1075), 1,
      anon_sym_RBRACK,
    STATE(460), 1,
      sym_qualified_identifier,
    STATE(378), 4,
      sym__import,
      sym_member_import,
      sym_module_import,
      aux_sym_import_statement_repeat1,
  [13144] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(475), 1,
      sym__type_op_has_type,
    STATE(510), 1,
      sym_type_variable_restriction,
    ACTIONS(1079), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(1077), 3,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
  [13163] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(747), 1,
      sym_identifier,
    ACTIONS(753), 1,
      anon_sym_ref,
    ACTIONS(1081), 1,
      anon_sym_end,
    STATE(352), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(428), 2,
      sym_member_def,
      sym_property_ref,
  [13184] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(747), 1,
      sym_identifier,
    ACTIONS(753), 1,
      anon_sym_ref,
    ACTIONS(1083), 1,
      anon_sym_end,
    STATE(365), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(428), 2,
      sym_member_def,
      sym_property_ref,
  [13205] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(747), 1,
      sym_identifier,
    ACTIONS(753), 1,
      anon_sym_ref,
    ACTIONS(1085), 1,
      anon_sym_end,
    STATE(352), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(428), 2,
      sym_member_def,
      sym_property_ref,
  [13226] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(177), 1,
      anon_sym_LT,
    ACTIONS(457), 1,
      anon_sym_COLON,
    ACTIONS(576), 1,
      anon_sym_RBRACK,
    ACTIONS(1087), 1,
      sym_identifier,
    ACTIONS(1089), 1,
      anon_sym_as,
    STATE(191), 1,
      sym__rename_import,
    STATE(458), 1,
      sym_iri,
  [13251] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1091), 1,
      sym_identifier,
    STATE(494), 1,
      sym__type_op_has_type,
    ACTIONS(1095), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(1093), 3,
      anon_sym_in,
      anon_sym_u2208,
      sym_set_op_builder,
  [13270] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(747), 1,
      sym_identifier,
    ACTIONS(753), 1,
      anon_sym_ref,
    ACTIONS(1097), 1,
      anon_sym_end,
    STATE(352), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(428), 2,
      sym_member_def,
      sym_property_ref,
  [13291] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(747), 1,
      sym_identifier,
    ACTIONS(753), 1,
      anon_sym_ref,
    ACTIONS(1099), 1,
      anon_sym_end,
    STATE(352), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(428), 2,
      sym_member_def,
      sym_property_ref,
  [13312] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(265), 1,
      anon_sym_AT,
    ACTIONS(267), 1,
      anon_sym_assert,
    ACTIONS(1101), 1,
      anon_sym_end,
    STATE(123), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
    STATE(170), 2,
      sym_annotation_property,
      sym_constraint,
  [13333] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(377), 1,
      aux_sym_type_variable_restriction_repeat1,
    STATE(478), 1,
      sym_type_op_combiner,
    ACTIONS(1105), 2,
      anon_sym_PLUS,
      anon_sym_u2295,
    ACTIONS(1103), 3,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
  [13352] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1109), 1,
      anon_sym_LPAREN,
    STATE(429), 1,
      sym_type_class_arguments,
    ACTIONS(1107), 5,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_u2295,
  [13369] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(747), 1,
      sym_identifier,
    ACTIONS(753), 1,
      anon_sym_ref,
    ACTIONS(1111), 1,
      anon_sym_end,
    STATE(352), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(428), 2,
      sym_member_def,
      sym_property_ref,
  [13390] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(747), 1,
      sym_identifier,
    ACTIONS(749), 1,
      anon_sym_end,
    ACTIONS(753), 1,
      anon_sym_ref,
    STATE(352), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(428), 2,
      sym_member_def,
      sym_property_ref,
  [13411] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(747), 1,
      sym_identifier,
    ACTIONS(753), 1,
      anon_sym_ref,
    ACTIONS(1113), 1,
      anon_sym_end,
    STATE(393), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(428), 2,
      sym_member_def,
      sym_property_ref,
  [13432] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(747), 1,
      sym_identifier,
    ACTIONS(753), 1,
      anon_sym_ref,
    ACTIONS(1115), 1,
      anon_sym_end,
    STATE(360), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(428), 2,
      sym_member_def,
      sym_property_ref,
  [13453] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(747), 1,
      sym_identifier,
    ACTIONS(753), 1,
      anon_sym_ref,
    ACTIONS(1117), 1,
      anon_sym_end,
    STATE(352), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(428), 2,
      sym_member_def,
      sym_property_ref,
  [13474] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(747), 1,
      sym_identifier,
    ACTIONS(753), 1,
      anon_sym_ref,
    ACTIONS(1119), 1,
      anon_sym_end,
    STATE(388), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(428), 2,
      sym_member_def,
      sym_property_ref,
  [13495] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(747), 1,
      sym_identifier,
    ACTIONS(753), 1,
      anon_sym_ref,
    ACTIONS(1121), 1,
      anon_sym_end,
    STATE(352), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(428), 2,
      sym_member_def,
      sym_property_ref,
  [13516] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(383), 1,
      aux_sym_type_variable_restriction_repeat1,
    STATE(478), 1,
      sym_type_op_combiner,
    ACTIONS(1105), 2,
      anon_sym_PLUS,
      anon_sym_u2295,
    ACTIONS(1123), 3,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
  [13535] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1125), 1,
      sym_identifier,
    ACTIONS(1128), 1,
      anon_sym_RBRACK,
    STATE(460), 1,
      sym_qualified_identifier,
    STATE(378), 4,
      sym__import,
      sym_member_import,
      sym_module_import,
      aux_sym_import_statement_repeat1,
  [13554] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1132), 6,
      anon_sym_is,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_def,
      anon_sym_COLON_EQ,
      anon_sym_u2254,
  [13569] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(747), 1,
      sym_identifier,
    ACTIONS(753), 1,
      anon_sym_ref,
    ACTIONS(1134), 1,
      anon_sym_end,
    STATE(352), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(428), 2,
      sym_member_def,
      sym_property_ref,
  [13590] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(747), 1,
      sym_identifier,
    ACTIONS(753), 1,
      anon_sym_ref,
    ACTIONS(1136), 1,
      anon_sym_end,
    STATE(348), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(428), 2,
      sym_member_def,
      sym_property_ref,
  [13611] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(747), 1,
      sym_identifier,
    ACTIONS(753), 1,
      anon_sym_ref,
    ACTIONS(1138), 1,
      anon_sym_end,
    STATE(384), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(428), 2,
      sym_member_def,
      sym_property_ref,
  [13632] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(383), 1,
      aux_sym_type_variable_restriction_repeat1,
    STATE(478), 1,
      sym_type_op_combiner,
    ACTIONS(1142), 2,
      anon_sym_PLUS,
      anon_sym_u2295,
    ACTIONS(1140), 3,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
  [13651] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(747), 1,
      sym_identifier,
    ACTIONS(753), 1,
      anon_sym_ref,
    ACTIONS(1145), 1,
      anon_sym_end,
    STATE(352), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(428), 2,
      sym_member_def,
      sym_property_ref,
  [13672] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(747), 1,
      sym_identifier,
    ACTIONS(753), 1,
      anon_sym_ref,
    ACTIONS(1147), 1,
      anon_sym_end,
    STATE(354), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(428), 2,
      sym_member_def,
      sym_property_ref,
  [13693] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1149), 1,
      sym_identifier,
    ACTIONS(1153), 1,
      anon_sym_parent,
    STATE(386), 2,
      sym_dimension_parent,
      aux_sym_dimension_body_repeat1,
    ACTIONS(1151), 3,
      anon_sym_end,
      anon_sym_from,
      anon_sym_ref,
  [13712] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(747), 1,
      sym_identifier,
    ACTIONS(753), 1,
      anon_sym_ref,
    ACTIONS(1156), 1,
      anon_sym_end,
    STATE(352), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(428), 2,
      sym_member_def,
      sym_property_ref,
  [13733] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(747), 1,
      sym_identifier,
    ACTIONS(753), 1,
      anon_sym_ref,
    ACTIONS(1158), 1,
      anon_sym_end,
    STATE(352), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(428), 2,
      sym_member_def,
      sym_property_ref,
  [13754] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(747), 1,
      sym_identifier,
    ACTIONS(753), 1,
      anon_sym_ref,
    ACTIONS(1160), 1,
      anon_sym_end,
    STATE(357), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(428), 2,
      sym_member_def,
      sym_property_ref,
  [13775] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(665), 1,
      anon_sym_is,
    ACTIONS(1162), 1,
      sym_identifier,
    STATE(431), 1,
      sym_annotation_only_body,
    ACTIONS(1164), 4,
      anon_sym_end,
      anon_sym_from,
      anon_sym_parent,
      anon_sym_ref,
  [13794] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(747), 1,
      sym_identifier,
    ACTIONS(753), 1,
      anon_sym_ref,
    ACTIONS(859), 1,
      anon_sym_end,
    STATE(352), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(428), 2,
      sym_member_def,
      sym_property_ref,
  [13815] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(475), 1,
      sym__type_op_has_type,
    STATE(493), 1,
      sym_type_variable_restriction,
    ACTIONS(1079), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(1166), 3,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
  [13834] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(747), 1,
      sym_identifier,
    ACTIONS(753), 1,
      anon_sym_ref,
    ACTIONS(1168), 1,
      anon_sym_end,
    STATE(352), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(428), 2,
      sym_member_def,
      sym_property_ref,
  [13855] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(747), 1,
      sym_identifier,
    ACTIONS(753), 1,
      anon_sym_ref,
    ACTIONS(863), 1,
      anon_sym_end,
    STATE(352), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(428), 2,
      sym_member_def,
      sym_property_ref,
  [13876] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(747), 1,
      sym_identifier,
    ACTIONS(753), 1,
      anon_sym_ref,
    ACTIONS(1170), 1,
      anon_sym_end,
    STATE(352), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(428), 2,
      sym_member_def,
      sym_property_ref,
  [13897] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1172), 1,
      sym_identifier,
    ACTIONS(1175), 1,
      anon_sym_RPAREN,
    ACTIONS(1177), 1,
      anon_sym_LBRACE,
    STATE(396), 1,
      aux_sym_type_class_def_repeat1,
    STATE(506), 1,
      sym_type_variable,
    STATE(581), 1,
      sym_function_cardinality_expression,
  [13919] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(482), 1,
      sym_sequence_ordering,
    STATE(626), 1,
      sym_sequence_uniqueness,
    ACTIONS(1027), 2,
      anon_sym_ordered,
      anon_sym_unordered,
    ACTIONS(1029), 2,
      anon_sym_unique,
      anon_sym_nonunique,
  [13937] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1180), 1,
      sym_identifier,
    ACTIONS(1182), 1,
      anon_sym_LBRACK,
    STATE(181), 1,
      sym_qualified_identifier,
    STATE(215), 3,
      sym__import,
      sym_member_import,
      sym_module_import,
  [13955] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(775), 1,
      sym_identifier,
    ACTIONS(1184), 1,
      anon_sym_end,
    STATE(116), 1,
      sym_qualified_identifier,
    STATE(432), 1,
      sym_identifier_reference,
    STATE(414), 2,
      sym_type_variant,
      aux_sym_union_body_repeat1,
  [13975] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(775), 1,
      sym_identifier,
    ACTIONS(1186), 1,
      anon_sym_end,
    STATE(116), 1,
      sym_qualified_identifier,
    STATE(432), 1,
      sym_identifier_reference,
    STATE(413), 2,
      sym_type_variant,
      aux_sym_union_body_repeat1,
  [13995] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(65), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      sym_identifier,
    ACTIONS(1190), 1,
      anon_sym_RPAREN,
    STATE(396), 1,
      aux_sym_type_class_def_repeat1,
    STATE(506), 1,
      sym_type_variable,
    STATE(581), 1,
      sym_function_cardinality_expression,
  [14017] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(265), 1,
      anon_sym_AT,
    ACTIONS(267), 1,
      anon_sym_assert,
    STATE(170), 2,
      sym_annotation_property,
      sym_constraint,
    STATE(367), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
  [14035] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1047), 1,
      sym_identifier,
    STATE(460), 1,
      sym_qualified_identifier,
    STATE(358), 4,
      sym__import,
      sym_member_import,
      sym_module_import,
      aux_sym_import_statement_repeat1,
  [14051] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1192), 1,
      sym_identifier,
    ACTIONS(1194), 1,
      anon_sym_RPAREN,
    STATE(8), 1,
      sym_qualified_identifier,
    STATE(369), 1,
      sym_identifier_reference,
    STATE(407), 1,
      aux_sym_type_class_arguments_repeat1,
    STATE(543), 1,
      sym_type_class_reference,
  [14073] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1196), 1,
      anon_sym_is,
    ACTIONS(1198), 1,
      anon_sym_EQ,
    ACTIONS(1200), 1,
      anon_sym_with,
    STATE(568), 1,
      sym_constraint_environment,
    STATE(176), 2,
      sym_informal_constraint,
      sym_formal_constraint,
  [14093] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1180), 1,
      sym_identifier,
    ACTIONS(1202), 1,
      anon_sym_LBRACK,
    STATE(181), 1,
      sym_qualified_identifier,
    STATE(206), 3,
      sym__import,
      sym_member_import,
      sym_module_import,
  [14111] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1204), 1,
      sym_identifier,
    ACTIONS(1207), 1,
      anon_sym_RPAREN,
    STATE(8), 1,
      sym_qualified_identifier,
    STATE(369), 1,
      sym_identifier_reference,
    STATE(407), 1,
      aux_sym_type_class_arguments_repeat1,
    STATE(543), 1,
      sym_type_class_reference,
  [14133] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(775), 1,
      sym_identifier,
    ACTIONS(777), 1,
      anon_sym_end,
    STATE(116), 1,
      sym_qualified_identifier,
    STATE(432), 1,
      sym_identifier_reference,
    STATE(413), 2,
      sym_type_variant,
      aux_sym_union_body_repeat1,
  [14153] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1047), 1,
      sym_identifier,
    STATE(460), 1,
      sym_qualified_identifier,
    STATE(350), 4,
      sym__import,
      sym_member_import,
      sym_module_import,
      aux_sym_import_statement_repeat1,
  [14169] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1025), 1,
      sym_unsigned,
    ACTIONS(1209), 1,
      anon_sym_RBRACE,
    STATE(495), 1,
      sym_sequence_uniqueness,
    STATE(628), 1,
      sym__cardinality_inner,
    ACTIONS(1029), 2,
      anon_sym_unique,
      anon_sym_nonunique,
  [14189] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(775), 1,
      sym_identifier,
    ACTIONS(1211), 1,
      anon_sym_end,
    STATE(116), 1,
      sym_qualified_identifier,
    STATE(432), 1,
      sym_identifier_reference,
    STATE(400), 2,
      sym_type_variant,
      aux_sym_union_body_repeat1,
  [14209] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(775), 1,
      sym_identifier,
    ACTIONS(1213), 1,
      anon_sym_end,
    STATE(116), 1,
      sym_qualified_identifier,
    STATE(432), 1,
      sym_identifier_reference,
    STATE(413), 2,
      sym_type_variant,
      aux_sym_union_body_repeat1,
  [14229] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1215), 1,
      sym_identifier,
    ACTIONS(1218), 1,
      anon_sym_end,
    STATE(116), 1,
      sym_qualified_identifier,
    STATE(432), 1,
      sym_identifier_reference,
    STATE(413), 2,
      sym_type_variant,
      aux_sym_union_body_repeat1,
  [14249] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(775), 1,
      sym_identifier,
    ACTIONS(1220), 1,
      anon_sym_end,
    STATE(116), 1,
      sym_qualified_identifier,
    STATE(432), 1,
      sym_identifier_reference,
    STATE(413), 2,
      sym_type_variant,
      aux_sym_union_body_repeat1,
  [14269] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1192), 1,
      sym_identifier,
    ACTIONS(1222), 1,
      sym_wildcard,
    STATE(8), 1,
      sym_qualified_identifier,
    STATE(369), 1,
      sym_identifier_reference,
    STATE(404), 1,
      aux_sym_type_class_arguments_repeat1,
    STATE(543), 1,
      sym_type_class_reference,
  [14291] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1224), 1,
      sym_identifier,
    ACTIONS(1228), 1,
      anon_sym_with,
    ACTIONS(1226), 4,
      anon_sym_end,
      anon_sym_from,
      anon_sym_parent,
      anon_sym_ref,
  [14307] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1230), 1,
      sym_identifier,
    ACTIONS(1232), 4,
      anon_sym_end,
      anon_sym_from,
      anon_sym_parent,
      anon_sym_ref,
  [14320] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1234), 1,
      sym_identifier,
    ACTIONS(1236), 4,
      anon_sym_end,
      anon_sym_from,
      anon_sym_parent,
      anon_sym_ref,
  [14333] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1238), 1,
      anon_sym_LPAREN,
    STATE(14), 1,
      sym__type_op_has_type,
    STATE(420), 1,
      sym__function_type,
    ACTIONS(1240), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [14350] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1242), 5,
      anon_sym_is,
      anon_sym_end,
      anon_sym_def,
      anon_sym_COLON_EQ,
      anon_sym_u2254,
  [14361] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1244), 5,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_u2295,
  [14372] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1192), 1,
      sym_identifier,
    ACTIONS(1246), 1,
      anon_sym_RBRACK,
    STATE(8), 1,
      sym_qualified_identifier,
    STATE(426), 1,
      aux_sym_rdf_types_repeat1,
    STATE(533), 1,
      sym_identifier_reference,
  [14391] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1248), 1,
      anon_sym_is,
    ACTIONS(1250), 1,
      anon_sym_def,
    STATE(454), 1,
      sym_function_signature,
    STATE(423), 2,
      sym_function_def,
      aux_sym_constraint_environment_repeat1,
  [14408] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1253), 1,
      sym_identifier,
    ACTIONS(1255), 4,
      anon_sym_end,
      anon_sym_from,
      anon_sym_parent,
      anon_sym_ref,
  [14421] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1257), 5,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_u2295,
  [14432] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1259), 1,
      sym_identifier,
    ACTIONS(1262), 1,
      anon_sym_RBRACK,
    STATE(8), 1,
      sym_qualified_identifier,
    STATE(426), 1,
      aux_sym_rdf_types_repeat1,
    STATE(533), 1,
      sym_identifier_reference,
  [14451] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1025), 1,
      sym_unsigned,
    STATE(524), 1,
      sym_sequence_uniqueness,
    STATE(557), 1,
      sym__cardinality_inner,
    ACTIONS(1029), 2,
      anon_sym_unique,
      anon_sym_nonunique,
  [14468] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1264), 1,
      sym_identifier,
    ACTIONS(1266), 4,
      anon_sym_end,
      anon_sym_from,
      anon_sym_parent,
      anon_sym_ref,
  [14481] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1268), 5,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_u2295,
  [14492] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(783), 1,
      anon_sym_def,
    ACTIONS(1270), 1,
      anon_sym_end,
    STATE(342), 1,
      sym_function_signature,
    STATE(445), 1,
      aux_sym_type_class_body_repeat1,
    STATE(538), 1,
      sym_method_def,
  [14511] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1272), 1,
      sym_identifier,
    ACTIONS(1274), 4,
      anon_sym_end,
      anon_sym_from,
      anon_sym_parent,
      anon_sym_ref,
  [14524] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(665), 1,
      anon_sym_is,
    ACTIONS(1276), 1,
      sym_identifier,
    ACTIONS(1278), 1,
      anon_sym_end,
    ACTIONS(1280), 1,
      anon_sym_as,
    STATE(551), 1,
      sym_annotation_only_body,
  [14543] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(783), 1,
      anon_sym_def,
    ACTIONS(1282), 1,
      anon_sym_end,
    STATE(342), 1,
      sym_function_signature,
    STATE(430), 1,
      aux_sym_type_class_body_repeat1,
    STATE(538), 1,
      sym_method_def,
  [14562] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(783), 1,
      anon_sym_def,
    ACTIONS(1284), 1,
      anon_sym_end,
    STATE(342), 1,
      sym_function_signature,
    STATE(445), 1,
      aux_sym_type_class_body_repeat1,
    STATE(538), 1,
      sym_method_def,
  [14581] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1192), 1,
      sym_identifier,
    ACTIONS(1286), 1,
      anon_sym_RBRACK,
    STATE(8), 1,
      sym_qualified_identifier,
    STATE(422), 1,
      aux_sym_rdf_types_repeat1,
    STATE(533), 1,
      sym_identifier_reference,
  [14600] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1288), 1,
      sym_identifier,
    ACTIONS(1290), 4,
      anon_sym_end,
      anon_sym_from,
      anon_sym_parent,
      anon_sym_ref,
  [14613] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1292), 5,
      anon_sym_is,
      anon_sym_end,
      anon_sym_def,
      anon_sym_COLON_EQ,
      anon_sym_u2254,
  [14624] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(747), 1,
      sym_identifier,
    ACTIONS(753), 1,
      anon_sym_ref,
    STATE(417), 1,
      sym_member,
    STATE(428), 2,
      sym_member_def,
      sym_property_ref,
  [14641] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(783), 1,
      anon_sym_def,
    ACTIONS(1294), 1,
      anon_sym_end,
    STATE(342), 1,
      sym_function_signature,
    STATE(434), 1,
      aux_sym_type_class_body_repeat1,
    STATE(538), 1,
      sym_method_def,
  [14660] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(41), 1,
      sym_identifier,
    ACTIONS(457), 1,
      anon_sym_COLON,
    ACTIONS(43), 3,
      anon_sym_is,
      anon_sym_end,
      anon_sym_as,
  [14675] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(783), 1,
      anon_sym_def,
    ACTIONS(1296), 1,
      anon_sym_end,
    STATE(342), 1,
      sym_function_signature,
    STATE(445), 1,
      aux_sym_type_class_body_repeat1,
    STATE(538), 1,
      sym_method_def,
  [14694] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1140), 5,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_u2295,
  [14705] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(783), 1,
      anon_sym_def,
    ACTIONS(1298), 1,
      anon_sym_end,
    STATE(342), 1,
      sym_function_signature,
    STATE(445), 1,
      aux_sym_type_class_body_repeat1,
    STATE(538), 1,
      sym_method_def,
  [14724] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(783), 1,
      anon_sym_def,
    ACTIONS(1300), 1,
      anon_sym_is,
    STATE(454), 1,
      sym_function_signature,
    STATE(423), 2,
      sym_function_def,
      aux_sym_constraint_environment_repeat1,
  [14741] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1302), 1,
      anon_sym_end,
    ACTIONS(1304), 1,
      anon_sym_def,
    STATE(342), 1,
      sym_function_signature,
    STATE(445), 1,
      aux_sym_type_class_body_repeat1,
    STATE(538), 1,
      sym_method_def,
  [14760] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1307), 1,
      sym_identifier,
    ACTIONS(1309), 1,
      anon_sym_COLON_COLON,
    STATE(587), 3,
      sym_module_path_root_only,
      sym_module_path_absolute,
      sym_module_path_relative,
  [14775] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1313), 1,
      sym_kw_is_fixed,
    STATE(236), 1,
      sym_tz_restriction_value,
    ACTIONS(1311), 3,
      anon_sym_required,
      anon_sym_prohibited,
      anon_sym_optional,
  [14790] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(65), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      sym_identifier,
    STATE(401), 1,
      aux_sym_type_class_def_repeat1,
    STATE(506), 1,
      sym_type_variable,
    STATE(581), 1,
      sym_function_cardinality_expression,
  [14809] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1315), 1,
      sym_identifier,
    ACTIONS(1317), 4,
      anon_sym_end,
      anon_sym_from,
      anon_sym_parent,
      anon_sym_ref,
  [14822] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(1319), 1,
      anon_sym_is,
    STATE(540), 1,
      sym_iri,
    STATE(541), 1,
      sym__module_locations,
    STATE(618), 1,
      sym_module_body,
  [14841] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1321), 1,
      sym_identifier,
    ACTIONS(1323), 3,
      anon_sym_end,
      anon_sym_def,
      anon_sym_ref,
  [14853] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1325), 1,
      sym_identifier,
    ACTIONS(1327), 3,
      anon_sym_end,
      anon_sym_def,
      anon_sym_ref,
  [14865] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1329), 1,
      sym_identifier,
    ACTIONS(1331), 1,
      sym_set_op_builder,
    STATE(462), 1,
      aux_sym_sequence_builder_repeat1,
    STATE(545), 1,
      sym_variable,
  [14881] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(22), 1,
      sym__function_op_by_definition,
    STATE(550), 1,
      sym_function_body,
    ACTIONS(1333), 2,
      anon_sym_COLON_EQ,
      anon_sym_u2254,
  [14895] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(6), 1,
      sym__type_op_has_type,
    STATE(182), 1,
      sym__type_expression_to,
    ACTIONS(1335), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [14909] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1329), 1,
      sym_identifier,
    ACTIONS(1337), 1,
      sym_set_op_builder,
    STATE(462), 1,
      aux_sym_sequence_builder_repeat1,
    STATE(545), 1,
      sym_variable,
  [14925] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(783), 1,
      anon_sym_def,
    STATE(454), 1,
      sym_function_signature,
    STATE(444), 2,
      sym_function_def,
      aux_sym_constraint_environment_repeat1,
  [14939] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(693), 1,
      anon_sym_RBRACK,
    ACTIONS(1089), 1,
      anon_sym_as,
    ACTIONS(1339), 1,
      sym_identifier,
    STATE(195), 1,
      sym__rename_import,
  [14955] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(14), 1,
      sym__type_op_has_type,
    STATE(549), 1,
      sym__function_type,
    ACTIONS(1240), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [14969] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(661), 1,
      anon_sym_RBRACK,
    ACTIONS(1089), 1,
      anon_sym_as,
    ACTIONS(1341), 1,
      sym_identifier,
    STATE(188), 1,
      sym__rename_import,
  [14985] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1343), 1,
      sym_identifier,
    ACTIONS(1345), 1,
      anon_sym_RPAREN,
    STATE(477), 1,
      aux_sym_function_signature_repeat1,
    STATE(542), 1,
      sym_function_parameter,
  [15001] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1347), 1,
      sym_identifier,
    ACTIONS(1350), 1,
      sym_set_op_builder,
    STATE(462), 1,
      aux_sym_sequence_builder_repeat1,
    STATE(545), 1,
      sym_variable,
  [15017] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(837), 1,
      sym_identifier,
    ACTIONS(853), 1,
      anon_sym_end,
    STATE(466), 2,
      sym_value_variant,
      aux_sym_enum_body_repeat1,
  [15031] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1352), 1,
      sym_identifier,
    ACTIONS(1354), 3,
      anon_sym_end,
      anon_sym_def,
      anon_sym_ref,
  [15043] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(837), 1,
      sym_identifier,
    ACTIONS(1356), 1,
      anon_sym_end,
    STATE(480), 2,
      sym_value_variant,
      aux_sym_enum_body_repeat1,
  [15057] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1358), 1,
      sym_identifier,
    ACTIONS(1361), 1,
      anon_sym_end,
    STATE(466), 2,
      sym_value_variant,
      aux_sym_enum_body_repeat1,
  [15071] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(665), 1,
      anon_sym_is,
    ACTIONS(1363), 1,
      sym_identifier,
    ACTIONS(1365), 1,
      anon_sym_end,
    STATE(534), 1,
      sym_annotation_only_body,
  [15087] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1367), 1,
      sym_identifier,
    ACTIONS(1369), 1,
      anon_sym_LBRACK,
    ACTIONS(1371), 1,
      sym_wildcard,
    STATE(470), 1,
      sym__wildcard_or_identifier_or_sequence,
  [15103] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1373), 4,
      anon_sym_RBRACE,
      sym_unsigned,
      anon_sym_unique,
      anon_sym_nonunique,
  [15113] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1375), 1,
      sym_identifier,
    ACTIONS(1377), 3,
      anon_sym_end,
      anon_sym_def,
      anon_sym_ref,
  [15125] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(837), 1,
      sym_identifier,
    ACTIONS(1379), 1,
      anon_sym_end,
    STATE(466), 2,
      sym_value_variant,
      aux_sym_enum_body_repeat1,
  [15139] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(665), 1,
      anon_sym_is,
    STATE(521), 1,
      sym_annotation_only_body,
    ACTIONS(1381), 2,
      anon_sym_end,
      anon_sym_def,
  [15153] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(665), 1,
      anon_sym_is,
    ACTIONS(1383), 1,
      sym_identifier,
    ACTIONS(1385), 1,
      anon_sym_end,
    STATE(531), 1,
      sym_annotation_only_body,
  [15169] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1387), 1,
      sym_identifier,
    ACTIONS(1389), 3,
      anon_sym_in,
      anon_sym_u2208,
      sym_set_op_builder,
  [15181] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1192), 1,
      sym_identifier,
    STATE(8), 1,
      sym_qualified_identifier,
    STATE(368), 1,
      sym_type_class_reference,
    STATE(369), 1,
      sym_identifier_reference,
  [15197] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(14), 1,
      sym__type_op_has_type,
    STATE(437), 1,
      sym__function_type,
    ACTIONS(1240), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [15211] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1391), 1,
      sym_identifier,
    ACTIONS(1394), 1,
      anon_sym_RPAREN,
    STATE(477), 1,
      aux_sym_function_signature_repeat1,
    STATE(542), 1,
      sym_function_parameter,
  [15227] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1192), 1,
      sym_identifier,
    STATE(8), 1,
      sym_qualified_identifier,
    STATE(369), 1,
      sym_identifier_reference,
    STATE(442), 1,
      sym_type_class_reference,
  [15243] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(837), 1,
      sym_identifier,
    ACTIONS(1396), 1,
      anon_sym_end,
    STATE(466), 2,
      sym_value_variant,
      aux_sym_enum_body_repeat1,
  [15257] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(837), 1,
      sym_identifier,
    ACTIONS(1398), 1,
      anon_sym_end,
    STATE(466), 2,
      sym_value_variant,
      aux_sym_enum_body_repeat1,
  [15271] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(837), 1,
      sym_identifier,
    ACTIONS(1400), 1,
      anon_sym_end,
    STATE(471), 2,
      sym_value_variant,
      aux_sym_enum_body_repeat1,
  [15285] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1402), 1,
      anon_sym_RBRACE,
    STATE(623), 1,
      sym_sequence_uniqueness,
    ACTIONS(1029), 2,
      anon_sym_unique,
      anon_sym_nonunique,
  [15299] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(250), 1,
      sym_tz_restriction_value,
    ACTIONS(1311), 3,
      anon_sym_required,
      anon_sym_prohibited,
      anon_sym_optional,
  [15311] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1192), 1,
      sym_identifier,
    ACTIONS(1404), 1,
      anon_sym_LBRACK,
    STATE(8), 1,
      sym_qualified_identifier,
    STATE(255), 1,
      sym_identifier_reference,
  [15327] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1406), 1,
      anon_sym_RBRACK,
    ACTIONS(1408), 1,
      sym_hex_byte,
    STATE(517), 1,
      aux_sym_binary_repeat1,
  [15340] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1410), 1,
      anon_sym_import,
    ACTIONS(1412), 1,
      anon_sym_COLON_COLON2,
    STATE(486), 1,
      aux_sym_module_path_absolute_repeat1,
  [15353] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1415), 1,
      sym_identifier,
    ACTIONS(1418), 1,
      anon_sym_RBRACK,
    STATE(487), 1,
      aux_sym__identifier_or_sequence_repeat1,
  [15366] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1192), 1,
      sym_identifier,
    STATE(8), 1,
      sym_qualified_identifier,
    STATE(390), 1,
      sym_identifier_reference,
  [15379] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1420), 1,
      anon_sym_RBRACK,
    ACTIONS(1422), 1,
      sym_quoted_string,
    STATE(492), 1,
      aux_sym_pattern_restriction_facet_repeat1,
  [15392] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1192), 1,
      sym_identifier,
    STATE(8), 1,
      sym_qualified_identifier,
    STATE(416), 1,
      sym_identifier_reference,
  [15405] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1192), 1,
      sym_identifier,
    STATE(8), 1,
      sym_qualified_identifier,
    STATE(436), 1,
      sym_identifier_reference,
  [15418] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1424), 1,
      anon_sym_RBRACK,
    ACTIONS(1426), 1,
      sym_quoted_string,
    STATE(492), 1,
      aux_sym_pattern_restriction_facet_repeat1,
  [15431] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1429), 3,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
  [15440] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1192), 1,
      sym_identifier,
    STATE(8), 1,
      sym_qualified_identifier,
    STATE(474), 1,
      sym_identifier_reference,
  [15453] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1025), 1,
      sym_unsigned,
    ACTIONS(1431), 1,
      anon_sym_RBRACE,
    STATE(602), 1,
      sym__cardinality_inner,
  [15466] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(65), 1,
      sym_set_op_membership,
    ACTIONS(1433), 2,
      anon_sym_in,
      anon_sym_u2208,
  [15477] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1435), 1,
      sym_identifier,
    ACTIONS(1437), 1,
      anon_sym_LBRACK,
    STATE(424), 1,
      sym__identifier_or_sequence,
  [15490] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(488), 1,
      sym__type_op_has_type,
    ACTIONS(1439), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [15501] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1025), 1,
      sym_unsigned,
    ACTIONS(1441), 1,
      anon_sym_RBRACE,
    STATE(561), 1,
      sym__cardinality_inner,
  [15514] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(584), 1,
      anon_sym_LPAREN,
    ACTIONS(1443), 1,
      anon_sym_COMMA,
    STATE(160), 1,
      sym__actual_arguments,
  [15527] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1445), 1,
      anon_sym_import,
    ACTIONS(1447), 1,
      anon_sym_COLON_COLON2,
    STATE(486), 1,
      aux_sym_module_path_absolute_repeat1,
  [15540] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1449), 1,
      anon_sym_RBRACE,
    ACTIONS(1451), 1,
      anon_sym_DOT_DOT,
    STATE(591), 1,
      sym_cardinality_range,
  [15553] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1447), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(1453), 1,
      anon_sym_import,
    STATE(519), 1,
      aux_sym_module_path_absolute_repeat1,
  [15566] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(15), 1,
      sym__type_op_has_type,
    ACTIONS(1455), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [15577] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1457), 1,
      sym_identifier,
    ACTIONS(1459), 1,
      anon_sym_RBRACK,
    STATE(487), 1,
      aux_sym__identifier_or_sequence_repeat1,
  [15590] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1461), 3,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
  [15599] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1408), 1,
      sym_hex_byte,
    ACTIONS(1463), 1,
      anon_sym_RBRACK,
    STATE(485), 1,
      aux_sym_binary_repeat1,
  [15612] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1192), 1,
      sym_identifier,
    STATE(8), 1,
      sym_qualified_identifier,
    STATE(586), 1,
      sym_identifier_reference,
  [15625] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1457), 1,
      sym_identifier,
    ACTIONS(1465), 1,
      anon_sym_RBRACK,
    STATE(487), 1,
      aux_sym__identifier_or_sequence_repeat1,
  [15638] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1467), 3,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
  [15647] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1408), 1,
      sym_hex_byte,
    ACTIONS(1469), 1,
      anon_sym_RBRACK,
    STATE(517), 1,
      aux_sym_binary_repeat1,
  [15660] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1192), 1,
      sym_identifier,
    STATE(8), 1,
      sym_qualified_identifier,
    STATE(582), 1,
      sym_identifier_reference,
  [15673] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1329), 1,
      sym_identifier,
    STATE(496), 1,
      sym_variable,
    STATE(594), 1,
      sym_quantified_variable,
  [15686] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(19), 1,
      sym__type_op_type_restriction,
    ACTIONS(1471), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
  [15697] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1447), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(1473), 1,
      anon_sym_import,
    STATE(501), 1,
      aux_sym_module_path_absolute_repeat1,
  [15710] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1408), 1,
      sym_hex_byte,
    ACTIONS(1475), 1,
      anon_sym_RBRACK,
    STATE(511), 1,
      aux_sym_binary_repeat1,
  [15723] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1477), 1,
      anon_sym_RBRACK,
    ACTIONS(1479), 1,
      sym_hex_byte,
    STATE(517), 1,
      aux_sym_binary_repeat1,
  [15736] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(1482), 1,
      sym_quoted_string,
    STATE(578), 1,
      sym_iri,
  [15749] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1447), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(1484), 1,
      anon_sym_import,
    STATE(486), 1,
      aux_sym_module_path_absolute_repeat1,
  [15762] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1343), 1,
      sym_identifier,
    STATE(461), 1,
      aux_sym_function_signature_repeat1,
    STATE(542), 1,
      sym_function_parameter,
  [15775] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1486), 2,
      anon_sym_end,
      anon_sym_def,
  [15783] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1488), 2,
      anon_sym_import,
      anon_sym_COLON_COLON2,
  [15791] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1490), 1,
      sym_identifier,
    ACTIONS(1492), 1,
      anon_sym_import,
  [15801] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1025), 1,
      sym_unsigned,
    STATE(614), 1,
      sym__cardinality_inner,
  [15811] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1494), 1,
      sym_identifier,
    STATE(262), 1,
      sym_member_def,
  [15821] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1496), 1,
      anon_sym_LBRACK,
    ACTIONS(1498), 1,
      sym__value_empty_sequence,
  [15831] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1500), 1,
      anon_sym_RBRACE,
    ACTIONS(1502), 1,
      sym_unsigned,
  [15841] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1504), 1,
      anon_sym_LBRACK,
    ACTIONS(1506), 1,
      sym__value_empty_sequence,
  [15851] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1508), 2,
      anon_sym_end,
      anon_sym_def,
  [15859] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1510), 1,
      sym_quoted_string,
    STATE(489), 1,
      aux_sym_pattern_restriction_facet_repeat1,
  [15869] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1512), 1,
      sym_identifier,
    ACTIONS(1514), 1,
      anon_sym_end,
  [15879] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1516), 2,
      anon_sym_RBRACK,
      sym_identifier,
  [15887] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1518), 2,
      anon_sym_RBRACK,
      sym_identifier,
  [15895] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1520), 1,
      sym_identifier,
    ACTIONS(1522), 1,
      anon_sym_end,
  [15905] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(81), 1,
      anon_sym_LT,
    STATE(590), 1,
      sym_iri,
  [15915] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1524), 2,
      anon_sym_RBRACE,
      sym_unsigned,
  [15923] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1526), 2,
      anon_sym_LBRACK,
      sym__value_empty_sequence,
  [15931] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1528), 2,
      anon_sym_end,
      anon_sym_def,
  [15939] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1530), 2,
      anon_sym_RBRACK,
      sym_hex_byte,
  [15947] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1532), 1,
      anon_sym_version,
    ACTIONS(1534), 1,
      anon_sym_is,
  [15957] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1319), 1,
      anon_sym_is,
    STATE(592), 1,
      sym_module_body,
  [15967] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1536), 2,
      sym_identifier,
      anon_sym_RPAREN,
  [15975] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1538), 2,
      sym_identifier,
      anon_sym_RPAREN,
  [15983] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1457), 1,
      sym_identifier,
    STATE(505), 1,
      aux_sym__identifier_or_sequence_repeat1,
  [15993] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1540), 2,
      sym_identifier,
      sym_set_op_builder,
  [16001] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1542), 1,
      anon_sym_LBRACK,
    ACTIONS(1544), 1,
      sym_quoted_string,
  [16011] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1025), 1,
      sym_unsigned,
    STATE(608), 1,
      sym__cardinality_inner,
  [16021] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1546), 2,
      anon_sym_LBRACK,
      sym__value_empty_sequence,
  [16029] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1548), 2,
      sym_identifier,
      anon_sym_RPAREN,
  [16037] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1550), 2,
      anon_sym_is,
      anon_sym_def,
  [16045] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1552), 1,
      sym_identifier,
    ACTIONS(1554), 1,
      anon_sym_end,
  [16055] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1556), 2,
      anon_sym_LBRACK,
      sym__value_empty_sequence,
  [16063] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1558), 1,
      anon_sym_LBRACK,
    ACTIONS(1560), 1,
      sym__value_empty_sequence,
  [16073] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1562), 1,
      sym_unsigned,
    ACTIONS(1564), 1,
      sym_kw_is_fixed,
  [16083] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1457), 1,
      sym_identifier,
    STATE(509), 1,
      aux_sym__identifier_or_sequence_repeat1,
  [16093] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1566), 1,
      sym_unsigned,
    ACTIONS(1568), 1,
      sym_kw_is_fixed,
  [16103] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1570), 1,
      anon_sym_RBRACE,
  [16110] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1572), 1,
      anon_sym_EQ,
  [16117] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1574), 1,
      anon_sym_EQ,
  [16124] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1576), 1,
      anon_sym_EQ,
  [16131] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1578), 1,
      anon_sym_RBRACE,
  [16138] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1580), 1,
      sym_identifier,
  [16145] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1582), 1,
      anon_sym_EQ,
  [16152] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1584), 1,
      anon_sym_EQ,
  [16159] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1586), 1,
      anon_sym_COMMA,
  [16166] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1588), 1,
      sym_identifier,
  [16173] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1590), 1,
      sym_identifier,
  [16180] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1592), 1,
      anon_sym_is,
  [16187] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1594), 1,
      sym_identifier,
  [16194] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1596), 1,
      anon_sym_RPAREN,
  [16201] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1598), 1,
      sym_quoted_string,
  [16208] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1600), 1,
      sym_identifier,
  [16215] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1602), 1,
      sym_identifier,
  [16222] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1604), 1,
      anon_sym_RBRACE,
  [16229] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1606), 1,
      sym_identifier,
  [16236] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1608), 1,
      sym_identifier,
  [16243] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1610), 1,
      anon_sym_RBRACE,
  [16250] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1612), 1,
      anon_sym_is,
  [16257] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1614), 1,
      anon_sym_RBRACE,
  [16264] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1616), 1,
      ts_builtin_sym_end,
  [16271] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1618), 1,
      sym_identifier,
  [16278] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1620), 1,
      anon_sym_with,
  [16285] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(159), 1,
      anon_sym_LPAREN,
  [16292] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1622), 1,
      sym_unsigned,
  [16299] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1624), 1,
      anon_sym_RPAREN,
  [16306] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1626), 1,
      anon_sym_EQ,
  [16313] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1628), 1,
      anon_sym_import,
  [16320] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1630), 1,
      ts_builtin_sym_end,
  [16327] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1632), 1,
      sym_unsigned,
  [16334] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1634), 1,
      anon_sym_is,
  [16341] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1636), 1,
      anon_sym_RBRACE,
  [16348] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1638), 1,
      ts_builtin_sym_end,
  [16355] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1640), 1,
      anon_sym_GT,
  [16362] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1642), 1,
      anon_sym_COMMA,
  [16369] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1644), 1,
      anon_sym_import,
  [16376] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1646), 1,
      sym_identifier,
  [16383] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1648), 1,
      sym_identifier,
  [16390] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1650), 1,
      sym_identifier,
  [16397] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1652), 1,
      sym_identifier,
  [16404] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1654), 1,
      anon_sym_GT,
  [16411] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1656), 1,
      sym_identifier,
  [16418] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1658), 1,
      anon_sym_RBRACE,
  [16425] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1660), 1,
      sym_identifier,
  [16432] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1662), 1,
      sym_identifier,
  [16439] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1664), 1,
      sym_identifier,
  [16446] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1666), 1,
      sym_identifier,
  [16453] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1668), 1,
      sym_identifier,
  [16460] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1670), 1,
      anon_sym_RBRACE,
  [16467] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1672), 1,
      sym_identifier,
  [16474] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1674), 1,
      sym_identifier,
  [16481] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1676), 1,
      sym_identifier,
  [16488] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1678), 1,
      sym_identifier,
  [16495] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1680), 1,
      ts_builtin_sym_end,
  [16502] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1682), 1,
      anon_sym_RBRACE,
  [16509] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1684), 1,
      anon_sym_RBRACE,
  [16516] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1686), 1,
      ts_builtin_sym_end,
  [16523] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1688), 1,
      anon_sym_RPAREN,
  [16530] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1690), 1,
      ts_builtin_sym_end,
  [16537] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1692), 1,
      anon_sym_RBRACE,
  [16544] = 2,
    ACTIONS(1694), 1,
      aux_sym_iri_token1,
    ACTIONS(1696), 1,
      sym_line_comment,
  [16551] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1698), 1,
      anon_sym_RBRACE,
  [16558] = 2,
    ACTIONS(1696), 1,
      sym_line_comment,
    ACTIONS(1700), 1,
      aux_sym_iri_token1,
  [16565] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1702), 1,
      anon_sym_RBRACE,
  [16572] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1704), 1,
      anon_sym_COMMA,
  [16579] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1706), 1,
      ts_builtin_sym_end,
  [16586] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1708), 1,
      anon_sym_RBRACE,
  [16593] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1710), 1,
      sym_identifier,
  [16600] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1712), 1,
      anon_sym_RBRACE,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2)] = 0,
  [SMALL_STATE(3)] = 69,
  [SMALL_STATE(4)] = 137,
  [SMALL_STATE(5)] = 206,
  [SMALL_STATE(6)] = 272,
  [SMALL_STATE(7)] = 356,
  [SMALL_STATE(8)] = 422,
  [SMALL_STATE(9)] = 488,
  [SMALL_STATE(10)] = 554,
  [SMALL_STATE(11)] = 620,
  [SMALL_STATE(12)] = 686,
  [SMALL_STATE(13)] = 752,
  [SMALL_STATE(14)] = 818,
  [SMALL_STATE(15)] = 899,
  [SMALL_STATE(16)] = 977,
  [SMALL_STATE(17)] = 1055,
  [SMALL_STATE(18)] = 1133,
  [SMALL_STATE(19)] = 1208,
  [SMALL_STATE(20)] = 1280,
  [SMALL_STATE(21)] = 1401,
  [SMALL_STATE(22)] = 1522,
  [SMALL_STATE(23)] = 1643,
  [SMALL_STATE(24)] = 1764,
  [SMALL_STATE(25)] = 1885,
  [SMALL_STATE(26)] = 2006,
  [SMALL_STATE(27)] = 2075,
  [SMALL_STATE(28)] = 2196,
  [SMALL_STATE(29)] = 2317,
  [SMALL_STATE(30)] = 2438,
  [SMALL_STATE(31)] = 2559,
  [SMALL_STATE(32)] = 2680,
  [SMALL_STATE(33)] = 2735,
  [SMALL_STATE(34)] = 2789,
  [SMALL_STATE(35)] = 2843,
  [SMALL_STATE(36)] = 2897,
  [SMALL_STATE(37)] = 2951,
  [SMALL_STATE(38)] = 3004,
  [SMALL_STATE(39)] = 3057,
  [SMALL_STATE(40)] = 3110,
  [SMALL_STATE(41)] = 3163,
  [SMALL_STATE(42)] = 3216,
  [SMALL_STATE(43)] = 3269,
  [SMALL_STATE(44)] = 3322,
  [SMALL_STATE(45)] = 3375,
  [SMALL_STATE(46)] = 3422,
  [SMALL_STATE(47)] = 3468,
  [SMALL_STATE(48)] = 3511,
  [SMALL_STATE(49)] = 3592,
  [SMALL_STATE(50)] = 3635,
  [SMALL_STATE(51)] = 3678,
  [SMALL_STATE(52)] = 3721,
  [SMALL_STATE(53)] = 3802,
  [SMALL_STATE(54)] = 3845,
  [SMALL_STATE(55)] = 3926,
  [SMALL_STATE(56)] = 3969,
  [SMALL_STATE(57)] = 4050,
  [SMALL_STATE(58)] = 4131,
  [SMALL_STATE(59)] = 4174,
  [SMALL_STATE(60)] = 4217,
  [SMALL_STATE(61)] = 4297,
  [SMALL_STATE(62)] = 4377,
  [SMALL_STATE(63)] = 4452,
  [SMALL_STATE(64)] = 4501,
  [SMALL_STATE(65)] = 4576,
  [SMALL_STATE(66)] = 4651,
  [SMALL_STATE(67)] = 4697,
  [SMALL_STATE(68)] = 4775,
  [SMALL_STATE(69)] = 4853,
  [SMALL_STATE(70)] = 4931,
  [SMALL_STATE(71)] = 5009,
  [SMALL_STATE(72)] = 5055,
  [SMALL_STATE(73)] = 5133,
  [SMALL_STATE(74)] = 5179,
  [SMALL_STATE(75)] = 5225,
  [SMALL_STATE(76)] = 5303,
  [SMALL_STATE(77)] = 5381,
  [SMALL_STATE(78)] = 5459,
  [SMALL_STATE(79)] = 5537,
  [SMALL_STATE(80)] = 5609,
  [SMALL_STATE(81)] = 5681,
  [SMALL_STATE(82)] = 5753,
  [SMALL_STATE(83)] = 5791,
  [SMALL_STATE(84)] = 5858,
  [SMALL_STATE(85)] = 5925,
  [SMALL_STATE(86)] = 5961,
  [SMALL_STATE(87)] = 5997,
  [SMALL_STATE(88)] = 6033,
  [SMALL_STATE(89)] = 6069,
  [SMALL_STATE(90)] = 6105,
  [SMALL_STATE(91)] = 6141,
  [SMALL_STATE(92)] = 6177,
  [SMALL_STATE(93)] = 6213,
  [SMALL_STATE(94)] = 6249,
  [SMALL_STATE(95)] = 6285,
  [SMALL_STATE(96)] = 6321,
  [SMALL_STATE(97)] = 6358,
  [SMALL_STATE(98)] = 6420,
  [SMALL_STATE(99)] = 6482,
  [SMALL_STATE(100)] = 6544,
  [SMALL_STATE(101)] = 6606,
  [SMALL_STATE(102)] = 6668,
  [SMALL_STATE(103)] = 6703,
  [SMALL_STATE(104)] = 6762,
  [SMALL_STATE(105)] = 6797,
  [SMALL_STATE(106)] = 6837,
  [SMALL_STATE(107)] = 6869,
  [SMALL_STATE(108)] = 6901,
  [SMALL_STATE(109)] = 6957,
  [SMALL_STATE(110)] = 6989,
  [SMALL_STATE(111)] = 7021,
  [SMALL_STATE(112)] = 7053,
  [SMALL_STATE(113)] = 7085,
  [SMALL_STATE(114)] = 7138,
  [SMALL_STATE(115)] = 7169,
  [SMALL_STATE(116)] = 7222,
  [SMALL_STATE(117)] = 7253,
  [SMALL_STATE(118)] = 7290,
  [SMALL_STATE(119)] = 7321,
  [SMALL_STATE(120)] = 7352,
  [SMALL_STATE(121)] = 7385,
  [SMALL_STATE(122)] = 7422,
  [SMALL_STATE(123)] = 7475,
  [SMALL_STATE(124)] = 7514,
  [SMALL_STATE(125)] = 7567,
  [SMALL_STATE(126)] = 7604,
  [SMALL_STATE(127)] = 7641,
  [SMALL_STATE(128)] = 7675,
  [SMALL_STATE(129)] = 7705,
  [SMALL_STATE(130)] = 7735,
  [SMALL_STATE(131)] = 7765,
  [SMALL_STATE(132)] = 7795,
  [SMALL_STATE(133)] = 7825,
  [SMALL_STATE(134)] = 7855,
  [SMALL_STATE(135)] = 7885,
  [SMALL_STATE(136)] = 7915,
  [SMALL_STATE(137)] = 7944,
  [SMALL_STATE(138)] = 7983,
  [SMALL_STATE(139)] = 8012,
  [SMALL_STATE(140)] = 8051,
  [SMALL_STATE(141)] = 8080,
  [SMALL_STATE(142)] = 8109,
  [SMALL_STATE(143)] = 8148,
  [SMALL_STATE(144)] = 8177,
  [SMALL_STATE(145)] = 8205,
  [SMALL_STATE(146)] = 8233,
  [SMALL_STATE(147)] = 8261,
  [SMALL_STATE(148)] = 8293,
  [SMALL_STATE(149)] = 8325,
  [SMALL_STATE(150)] = 8353,
  [SMALL_STATE(151)] = 8381,
  [SMALL_STATE(152)] = 8409,
  [SMALL_STATE(153)] = 8439,
  [SMALL_STATE(154)] = 8467,
  [SMALL_STATE(155)] = 8503,
  [SMALL_STATE(156)] = 8535,
  [SMALL_STATE(157)] = 8572,
  [SMALL_STATE(158)] = 8601,
  [SMALL_STATE(159)] = 8628,
  [SMALL_STATE(160)] = 8657,
  [SMALL_STATE(161)] = 8682,
  [SMALL_STATE(162)] = 8725,
  [SMALL_STATE(163)] = 8762,
  [SMALL_STATE(164)] = 8799,
  [SMALL_STATE(165)] = 8836,
  [SMALL_STATE(166)] = 8863,
  [SMALL_STATE(167)] = 8890,
  [SMALL_STATE(168)] = 8917,
  [SMALL_STATE(169)] = 8954,
  [SMALL_STATE(170)] = 8981,
  [SMALL_STATE(171)] = 9008,
  [SMALL_STATE(172)] = 9035,
  [SMALL_STATE(173)] = 9062,
  [SMALL_STATE(174)] = 9089,
  [SMALL_STATE(175)] = 9118,
  [SMALL_STATE(176)] = 9145,
  [SMALL_STATE(177)] = 9172,
  [SMALL_STATE(178)] = 9199,
  [SMALL_STATE(179)] = 9227,
  [SMALL_STATE(180)] = 9259,
  [SMALL_STATE(181)] = 9293,
  [SMALL_STATE(182)] = 9320,
  [SMALL_STATE(183)] = 9349,
  [SMALL_STATE(184)] = 9374,
  [SMALL_STATE(185)] = 9397,
  [SMALL_STATE(186)] = 9436,
  [SMALL_STATE(187)] = 9465,
  [SMALL_STATE(188)] = 9490,
  [SMALL_STATE(189)] = 9515,
  [SMALL_STATE(190)] = 9542,
  [SMALL_STATE(191)] = 9565,
  [SMALL_STATE(192)] = 9590,
  [SMALL_STATE(193)] = 9613,
  [SMALL_STATE(194)] = 9638,
  [SMALL_STATE(195)] = 9661,
  [SMALL_STATE(196)] = 9686,
  [SMALL_STATE(197)] = 9709,
  [SMALL_STATE(198)] = 9734,
  [SMALL_STATE(199)] = 9759,
  [SMALL_STATE(200)] = 9782,
  [SMALL_STATE(201)] = 9807,
  [SMALL_STATE(202)] = 9837,
  [SMALL_STATE(203)] = 9875,
  [SMALL_STATE(204)] = 9899,
  [SMALL_STATE(205)] = 9923,
  [SMALL_STATE(206)] = 9947,
  [SMALL_STATE(207)] = 9968,
  [SMALL_STATE(208)] = 9989,
  [SMALL_STATE(209)] = 10010,
  [SMALL_STATE(210)] = 10035,
  [SMALL_STATE(211)] = 10076,
  [SMALL_STATE(212)] = 10105,
  [SMALL_STATE(213)] = 10146,
  [SMALL_STATE(214)] = 10169,
  [SMALL_STATE(215)] = 10198,
  [SMALL_STATE(216)] = 10219,
  [SMALL_STATE(217)] = 10245,
  [SMALL_STATE(218)] = 10279,
  [SMALL_STATE(219)] = 10319,
  [SMALL_STATE(220)] = 10341,
  [SMALL_STATE(221)] = 10375,
  [SMALL_STATE(222)] = 10415,
  [SMALL_STATE(223)] = 10454,
  [SMALL_STATE(224)] = 10477,
  [SMALL_STATE(225)] = 10500,
  [SMALL_STATE(226)] = 10523,
  [SMALL_STATE(227)] = 10546,
  [SMALL_STATE(228)] = 10569,
  [SMALL_STATE(229)] = 10592,
  [SMALL_STATE(230)] = 10615,
  [SMALL_STATE(231)] = 10638,
  [SMALL_STATE(232)] = 10677,
  [SMALL_STATE(233)] = 10700,
  [SMALL_STATE(234)] = 10723,
  [SMALL_STATE(235)] = 10741,
  [SMALL_STATE(236)] = 10759,
  [SMALL_STATE(237)] = 10777,
  [SMALL_STATE(238)] = 10795,
  [SMALL_STATE(239)] = 10813,
  [SMALL_STATE(240)] = 10847,
  [SMALL_STATE(241)] = 10865,
  [SMALL_STATE(242)] = 10883,
  [SMALL_STATE(243)] = 10917,
  [SMALL_STATE(244)] = 10935,
  [SMALL_STATE(245)] = 10953,
  [SMALL_STATE(246)] = 10971,
  [SMALL_STATE(247)] = 11005,
  [SMALL_STATE(248)] = 11023,
  [SMALL_STATE(249)] = 11041,
  [SMALL_STATE(250)] = 11075,
  [SMALL_STATE(251)] = 11093,
  [SMALL_STATE(252)] = 11111,
  [SMALL_STATE(253)] = 11145,
  [SMALL_STATE(254)] = 11163,
  [SMALL_STATE(255)] = 11197,
  [SMALL_STATE(256)] = 11215,
  [SMALL_STATE(257)] = 11232,
  [SMALL_STATE(258)] = 11249,
  [SMALL_STATE(259)] = 11266,
  [SMALL_STATE(260)] = 11283,
  [SMALL_STATE(261)] = 11300,
  [SMALL_STATE(262)] = 11317,
  [SMALL_STATE(263)] = 11334,
  [SMALL_STATE(264)] = 11351,
  [SMALL_STATE(265)] = 11368,
  [SMALL_STATE(266)] = 11385,
  [SMALL_STATE(267)] = 11402,
  [SMALL_STATE(268)] = 11419,
  [SMALL_STATE(269)] = 11436,
  [SMALL_STATE(270)] = 11453,
  [SMALL_STATE(271)] = 11470,
  [SMALL_STATE(272)] = 11487,
  [SMALL_STATE(273)] = 11504,
  [SMALL_STATE(274)] = 11521,
  [SMALL_STATE(275)] = 11538,
  [SMALL_STATE(276)] = 11555,
  [SMALL_STATE(277)] = 11572,
  [SMALL_STATE(278)] = 11589,
  [SMALL_STATE(279)] = 11606,
  [SMALL_STATE(280)] = 11623,
  [SMALL_STATE(281)] = 11640,
  [SMALL_STATE(282)] = 11657,
  [SMALL_STATE(283)] = 11674,
  [SMALL_STATE(284)] = 11691,
  [SMALL_STATE(285)] = 11708,
  [SMALL_STATE(286)] = 11725,
  [SMALL_STATE(287)] = 11742,
  [SMALL_STATE(288)] = 11759,
  [SMALL_STATE(289)] = 11776,
  [SMALL_STATE(290)] = 11793,
  [SMALL_STATE(291)] = 11810,
  [SMALL_STATE(292)] = 11827,
  [SMALL_STATE(293)] = 11844,
  [SMALL_STATE(294)] = 11861,
  [SMALL_STATE(295)] = 11878,
  [SMALL_STATE(296)] = 11895,
  [SMALL_STATE(297)] = 11912,
  [SMALL_STATE(298)] = 11929,
  [SMALL_STATE(299)] = 11946,
  [SMALL_STATE(300)] = 11963,
  [SMALL_STATE(301)] = 11980,
  [SMALL_STATE(302)] = 11997,
  [SMALL_STATE(303)] = 12014,
  [SMALL_STATE(304)] = 12031,
  [SMALL_STATE(305)] = 12048,
  [SMALL_STATE(306)] = 12065,
  [SMALL_STATE(307)] = 12082,
  [SMALL_STATE(308)] = 12099,
  [SMALL_STATE(309)] = 12116,
  [SMALL_STATE(310)] = 12133,
  [SMALL_STATE(311)] = 12150,
  [SMALL_STATE(312)] = 12167,
  [SMALL_STATE(313)] = 12184,
  [SMALL_STATE(314)] = 12201,
  [SMALL_STATE(315)] = 12218,
  [SMALL_STATE(316)] = 12235,
  [SMALL_STATE(317)] = 12252,
  [SMALL_STATE(318)] = 12269,
  [SMALL_STATE(319)] = 12286,
  [SMALL_STATE(320)] = 12303,
  [SMALL_STATE(321)] = 12320,
  [SMALL_STATE(322)] = 12337,
  [SMALL_STATE(323)] = 12354,
  [SMALL_STATE(324)] = 12371,
  [SMALL_STATE(325)] = 12388,
  [SMALL_STATE(326)] = 12405,
  [SMALL_STATE(327)] = 12422,
  [SMALL_STATE(328)] = 12439,
  [SMALL_STATE(329)] = 12456,
  [SMALL_STATE(330)] = 12473,
  [SMALL_STATE(331)] = 12490,
  [SMALL_STATE(332)] = 12518,
  [SMALL_STATE(333)] = 12546,
  [SMALL_STATE(334)] = 12573,
  [SMALL_STATE(335)] = 12600,
  [SMALL_STATE(336)] = 12627,
  [SMALL_STATE(337)] = 12654,
  [SMALL_STATE(338)] = 12681,
  [SMALL_STATE(339)] = 12708,
  [SMALL_STATE(340)] = 12733,
  [SMALL_STATE(341)] = 12760,
  [SMALL_STATE(342)] = 12785,
  [SMALL_STATE(343)] = 12809,
  [SMALL_STATE(344)] = 12833,
  [SMALL_STATE(345)] = 12857,
  [SMALL_STATE(346)] = 12881,
  [SMALL_STATE(347)] = 12905,
  [SMALL_STATE(348)] = 12929,
  [SMALL_STATE(349)] = 12950,
  [SMALL_STATE(350)] = 12971,
  [SMALL_STATE(351)] = 12990,
  [SMALL_STATE(352)] = 13005,
  [SMALL_STATE(353)] = 13026,
  [SMALL_STATE(354)] = 13041,
  [SMALL_STATE(355)] = 13062,
  [SMALL_STATE(356)] = 13083,
  [SMALL_STATE(357)] = 13104,
  [SMALL_STATE(358)] = 13125,
  [SMALL_STATE(359)] = 13144,
  [SMALL_STATE(360)] = 13163,
  [SMALL_STATE(361)] = 13184,
  [SMALL_STATE(362)] = 13205,
  [SMALL_STATE(363)] = 13226,
  [SMALL_STATE(364)] = 13251,
  [SMALL_STATE(365)] = 13270,
  [SMALL_STATE(366)] = 13291,
  [SMALL_STATE(367)] = 13312,
  [SMALL_STATE(368)] = 13333,
  [SMALL_STATE(369)] = 13352,
  [SMALL_STATE(370)] = 13369,
  [SMALL_STATE(371)] = 13390,
  [SMALL_STATE(372)] = 13411,
  [SMALL_STATE(373)] = 13432,
  [SMALL_STATE(374)] = 13453,
  [SMALL_STATE(375)] = 13474,
  [SMALL_STATE(376)] = 13495,
  [SMALL_STATE(377)] = 13516,
  [SMALL_STATE(378)] = 13535,
  [SMALL_STATE(379)] = 13554,
  [SMALL_STATE(380)] = 13569,
  [SMALL_STATE(381)] = 13590,
  [SMALL_STATE(382)] = 13611,
  [SMALL_STATE(383)] = 13632,
  [SMALL_STATE(384)] = 13651,
  [SMALL_STATE(385)] = 13672,
  [SMALL_STATE(386)] = 13693,
  [SMALL_STATE(387)] = 13712,
  [SMALL_STATE(388)] = 13733,
  [SMALL_STATE(389)] = 13754,
  [SMALL_STATE(390)] = 13775,
  [SMALL_STATE(391)] = 13794,
  [SMALL_STATE(392)] = 13815,
  [SMALL_STATE(393)] = 13834,
  [SMALL_STATE(394)] = 13855,
  [SMALL_STATE(395)] = 13876,
  [SMALL_STATE(396)] = 13897,
  [SMALL_STATE(397)] = 13919,
  [SMALL_STATE(398)] = 13937,
  [SMALL_STATE(399)] = 13955,
  [SMALL_STATE(400)] = 13975,
  [SMALL_STATE(401)] = 13995,
  [SMALL_STATE(402)] = 14017,
  [SMALL_STATE(403)] = 14035,
  [SMALL_STATE(404)] = 14051,
  [SMALL_STATE(405)] = 14073,
  [SMALL_STATE(406)] = 14093,
  [SMALL_STATE(407)] = 14111,
  [SMALL_STATE(408)] = 14133,
  [SMALL_STATE(409)] = 14153,
  [SMALL_STATE(410)] = 14169,
  [SMALL_STATE(411)] = 14189,
  [SMALL_STATE(412)] = 14209,
  [SMALL_STATE(413)] = 14229,
  [SMALL_STATE(414)] = 14249,
  [SMALL_STATE(415)] = 14269,
  [SMALL_STATE(416)] = 14291,
  [SMALL_STATE(417)] = 14307,
  [SMALL_STATE(418)] = 14320,
  [SMALL_STATE(419)] = 14333,
  [SMALL_STATE(420)] = 14350,
  [SMALL_STATE(421)] = 14361,
  [SMALL_STATE(422)] = 14372,
  [SMALL_STATE(423)] = 14391,
  [SMALL_STATE(424)] = 14408,
  [SMALL_STATE(425)] = 14421,
  [SMALL_STATE(426)] = 14432,
  [SMALL_STATE(427)] = 14451,
  [SMALL_STATE(428)] = 14468,
  [SMALL_STATE(429)] = 14481,
  [SMALL_STATE(430)] = 14492,
  [SMALL_STATE(431)] = 14511,
  [SMALL_STATE(432)] = 14524,
  [SMALL_STATE(433)] = 14543,
  [SMALL_STATE(434)] = 14562,
  [SMALL_STATE(435)] = 14581,
  [SMALL_STATE(436)] = 14600,
  [SMALL_STATE(437)] = 14613,
  [SMALL_STATE(438)] = 14624,
  [SMALL_STATE(439)] = 14641,
  [SMALL_STATE(440)] = 14660,
  [SMALL_STATE(441)] = 14675,
  [SMALL_STATE(442)] = 14694,
  [SMALL_STATE(443)] = 14705,
  [SMALL_STATE(444)] = 14724,
  [SMALL_STATE(445)] = 14741,
  [SMALL_STATE(446)] = 14760,
  [SMALL_STATE(447)] = 14775,
  [SMALL_STATE(448)] = 14790,
  [SMALL_STATE(449)] = 14809,
  [SMALL_STATE(450)] = 14822,
  [SMALL_STATE(451)] = 14841,
  [SMALL_STATE(452)] = 14853,
  [SMALL_STATE(453)] = 14865,
  [SMALL_STATE(454)] = 14881,
  [SMALL_STATE(455)] = 14895,
  [SMALL_STATE(456)] = 14909,
  [SMALL_STATE(457)] = 14925,
  [SMALL_STATE(458)] = 14939,
  [SMALL_STATE(459)] = 14955,
  [SMALL_STATE(460)] = 14969,
  [SMALL_STATE(461)] = 14985,
  [SMALL_STATE(462)] = 15001,
  [SMALL_STATE(463)] = 15017,
  [SMALL_STATE(464)] = 15031,
  [SMALL_STATE(465)] = 15043,
  [SMALL_STATE(466)] = 15057,
  [SMALL_STATE(467)] = 15071,
  [SMALL_STATE(468)] = 15087,
  [SMALL_STATE(469)] = 15103,
  [SMALL_STATE(470)] = 15113,
  [SMALL_STATE(471)] = 15125,
  [SMALL_STATE(472)] = 15139,
  [SMALL_STATE(473)] = 15153,
  [SMALL_STATE(474)] = 15169,
  [SMALL_STATE(475)] = 15181,
  [SMALL_STATE(476)] = 15197,
  [SMALL_STATE(477)] = 15211,
  [SMALL_STATE(478)] = 15227,
  [SMALL_STATE(479)] = 15243,
  [SMALL_STATE(480)] = 15257,
  [SMALL_STATE(481)] = 15271,
  [SMALL_STATE(482)] = 15285,
  [SMALL_STATE(483)] = 15299,
  [SMALL_STATE(484)] = 15311,
  [SMALL_STATE(485)] = 15327,
  [SMALL_STATE(486)] = 15340,
  [SMALL_STATE(487)] = 15353,
  [SMALL_STATE(488)] = 15366,
  [SMALL_STATE(489)] = 15379,
  [SMALL_STATE(490)] = 15392,
  [SMALL_STATE(491)] = 15405,
  [SMALL_STATE(492)] = 15418,
  [SMALL_STATE(493)] = 15431,
  [SMALL_STATE(494)] = 15440,
  [SMALL_STATE(495)] = 15453,
  [SMALL_STATE(496)] = 15466,
  [SMALL_STATE(497)] = 15477,
  [SMALL_STATE(498)] = 15490,
  [SMALL_STATE(499)] = 15501,
  [SMALL_STATE(500)] = 15514,
  [SMALL_STATE(501)] = 15527,
  [SMALL_STATE(502)] = 15540,
  [SMALL_STATE(503)] = 15553,
  [SMALL_STATE(504)] = 15566,
  [SMALL_STATE(505)] = 15577,
  [SMALL_STATE(506)] = 15590,
  [SMALL_STATE(507)] = 15599,
  [SMALL_STATE(508)] = 15612,
  [SMALL_STATE(509)] = 15625,
  [SMALL_STATE(510)] = 15638,
  [SMALL_STATE(511)] = 15647,
  [SMALL_STATE(512)] = 15660,
  [SMALL_STATE(513)] = 15673,
  [SMALL_STATE(514)] = 15686,
  [SMALL_STATE(515)] = 15697,
  [SMALL_STATE(516)] = 15710,
  [SMALL_STATE(517)] = 15723,
  [SMALL_STATE(518)] = 15736,
  [SMALL_STATE(519)] = 15749,
  [SMALL_STATE(520)] = 15762,
  [SMALL_STATE(521)] = 15775,
  [SMALL_STATE(522)] = 15783,
  [SMALL_STATE(523)] = 15791,
  [SMALL_STATE(524)] = 15801,
  [SMALL_STATE(525)] = 15811,
  [SMALL_STATE(526)] = 15821,
  [SMALL_STATE(527)] = 15831,
  [SMALL_STATE(528)] = 15841,
  [SMALL_STATE(529)] = 15851,
  [SMALL_STATE(530)] = 15859,
  [SMALL_STATE(531)] = 15869,
  [SMALL_STATE(532)] = 15879,
  [SMALL_STATE(533)] = 15887,
  [SMALL_STATE(534)] = 15895,
  [SMALL_STATE(535)] = 15905,
  [SMALL_STATE(536)] = 15915,
  [SMALL_STATE(537)] = 15923,
  [SMALL_STATE(538)] = 15931,
  [SMALL_STATE(539)] = 15939,
  [SMALL_STATE(540)] = 15947,
  [SMALL_STATE(541)] = 15957,
  [SMALL_STATE(542)] = 15967,
  [SMALL_STATE(543)] = 15975,
  [SMALL_STATE(544)] = 15983,
  [SMALL_STATE(545)] = 15993,
  [SMALL_STATE(546)] = 16001,
  [SMALL_STATE(547)] = 16011,
  [SMALL_STATE(548)] = 16021,
  [SMALL_STATE(549)] = 16029,
  [SMALL_STATE(550)] = 16037,
  [SMALL_STATE(551)] = 16045,
  [SMALL_STATE(552)] = 16055,
  [SMALL_STATE(553)] = 16063,
  [SMALL_STATE(554)] = 16073,
  [SMALL_STATE(555)] = 16083,
  [SMALL_STATE(556)] = 16093,
  [SMALL_STATE(557)] = 16103,
  [SMALL_STATE(558)] = 16110,
  [SMALL_STATE(559)] = 16117,
  [SMALL_STATE(560)] = 16124,
  [SMALL_STATE(561)] = 16131,
  [SMALL_STATE(562)] = 16138,
  [SMALL_STATE(563)] = 16145,
  [SMALL_STATE(564)] = 16152,
  [SMALL_STATE(565)] = 16159,
  [SMALL_STATE(566)] = 16166,
  [SMALL_STATE(567)] = 16173,
  [SMALL_STATE(568)] = 16180,
  [SMALL_STATE(569)] = 16187,
  [SMALL_STATE(570)] = 16194,
  [SMALL_STATE(571)] = 16201,
  [SMALL_STATE(572)] = 16208,
  [SMALL_STATE(573)] = 16215,
  [SMALL_STATE(574)] = 16222,
  [SMALL_STATE(575)] = 16229,
  [SMALL_STATE(576)] = 16236,
  [SMALL_STATE(577)] = 16243,
  [SMALL_STATE(578)] = 16250,
  [SMALL_STATE(579)] = 16257,
  [SMALL_STATE(580)] = 16264,
  [SMALL_STATE(581)] = 16271,
  [SMALL_STATE(582)] = 16278,
  [SMALL_STATE(583)] = 16285,
  [SMALL_STATE(584)] = 16292,
  [SMALL_STATE(585)] = 16299,
  [SMALL_STATE(586)] = 16306,
  [SMALL_STATE(587)] = 16313,
  [SMALL_STATE(588)] = 16320,
  [SMALL_STATE(589)] = 16327,
  [SMALL_STATE(590)] = 16334,
  [SMALL_STATE(591)] = 16341,
  [SMALL_STATE(592)] = 16348,
  [SMALL_STATE(593)] = 16355,
  [SMALL_STATE(594)] = 16362,
  [SMALL_STATE(595)] = 16369,
  [SMALL_STATE(596)] = 16376,
  [SMALL_STATE(597)] = 16383,
  [SMALL_STATE(598)] = 16390,
  [SMALL_STATE(599)] = 16397,
  [SMALL_STATE(600)] = 16404,
  [SMALL_STATE(601)] = 16411,
  [SMALL_STATE(602)] = 16418,
  [SMALL_STATE(603)] = 16425,
  [SMALL_STATE(604)] = 16432,
  [SMALL_STATE(605)] = 16439,
  [SMALL_STATE(606)] = 16446,
  [SMALL_STATE(607)] = 16453,
  [SMALL_STATE(608)] = 16460,
  [SMALL_STATE(609)] = 16467,
  [SMALL_STATE(610)] = 16474,
  [SMALL_STATE(611)] = 16481,
  [SMALL_STATE(612)] = 16488,
  [SMALL_STATE(613)] = 16495,
  [SMALL_STATE(614)] = 16502,
  [SMALL_STATE(615)] = 16509,
  [SMALL_STATE(616)] = 16516,
  [SMALL_STATE(617)] = 16523,
  [SMALL_STATE(618)] = 16530,
  [SMALL_STATE(619)] = 16537,
  [SMALL_STATE(620)] = 16544,
  [SMALL_STATE(621)] = 16551,
  [SMALL_STATE(622)] = 16558,
  [SMALL_STATE(623)] = 16565,
  [SMALL_STATE(624)] = 16572,
  [SMALL_STATE(625)] = 16579,
  [SMALL_STATE(626)] = 16586,
  [SMALL_STATE(627)] = 16593,
  [SMALL_STATE(628)] = 16600,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [7] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iri, 3, 0, 0),
  [9] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iri, 3, 0, 0),
  [11] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 17),
  [13] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_identifier, 3, 0, 17),
  [15] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 1, 0, 0),
  [17] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 1, 0, 0),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [21] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2, 0, 33),
  [23] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2, 0, 33),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(45),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(114),
  [35] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [37] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary, 2, 0, 0),
  [39] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary, 2, 0, 0),
  [41] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_identifier_reference, 1, 0, 0),
  [43] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier_reference, 1, 0, 0),
  [45] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary, 3, 0, 65),
  [47] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary, 3, 0, 65),
  [49] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_boolean_falsity, 1, 0, 0),
  [51] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean_falsity, 1, 0, 0),
  [53] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_boolean_truth, 1, 0, 0),
  [55] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean_truth, 1, 0, 0),
  [57] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_simple_value, 1, 0, 0),
  [59] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_value, 1, 0, 0),
  [61] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_boolean, 1, 0, 0),
  [63] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean, 1, 0, 0),
  [65] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [67] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(63),
  [71] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [73] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [75] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [77] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [83] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [101] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_value_constructor, 4, 0, 93),
  [103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_constructor, 4, 0, 93),
  [105] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cardinality_expression, 4, 0, 109),
  [107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cardinality_expression, 4, 0, 109),
  [109] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cardinality_expression, 3, 0, 84),
  [111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cardinality_expression, 3, 0, 84),
  [113] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cardinality_expression, 4, 0, 108),
  [115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cardinality_expression, 4, 0, 108),
  [117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cardinality_expression, 5, 0, 120),
  [119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cardinality_expression, 5, 0, 120),
  [121] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_cardinality_expression, 3, 0, 64),
  [123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_cardinality_expression, 3, 0, 64),
  [125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_cardinality_expression, 2, 0, 0),
  [127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_cardinality_expression, 2, 0, 0),
  [129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_cardinality_expression, 4, 0, 109),
  [131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_cardinality_expression, 4, 0, 109),
  [133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_cardinality_expression, 3, 0, 63),
  [135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_cardinality_expression, 3, 0, 63),
  [137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_cardinality_expression, 4, 0, 92),
  [139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_cardinality_expression, 4, 0, 92),
  [141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_cardinality_expression, 4, 0, 108),
  [143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_cardinality_expression, 4, 0, 108),
  [145] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_cardinality_expression, 5, 0, 120),
  [147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_cardinality_expression, 5, 0, 120),
  [149] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_cardinality_expression, 3, 0, 84),
  [151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_cardinality_expression, 3, 0, 84),
  [153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(575),
  [155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_value, 1, 0, 0),
  [157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value, 1, 0, 0),
  [159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [161] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequence_of_values, 2, 0, 0),
  [163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_of_values, 2, 0, 0),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(105),
  [167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(129),
  [185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [191] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mapping_value, 3, 0, 68),
  [193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mapping_value, 3, 0, 68),
  [195] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequence_of_values, 3, 0, 61),
  [197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_of_values, 3, 0, 61),
  [199] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequence_of_values, 3, 0, 67),
  [201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_of_values, 3, 0, 67),
  [203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [207] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequence_of_values, 1, 0, 21),
  [209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_of_values, 1, 0, 21),
  [211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [213] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__actual_arguments_repeat1, 2, 0, 97), SHIFT_REPEAT(105),
  [216] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__actual_arguments_repeat1, 2, 0, 97), SHIFT_REPEAT(78),
  [219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__actual_arguments_repeat1, 2, 0, 97),
  [221] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__actual_arguments_repeat1, 2, 0, 97), SHIFT_REPEAT(121),
  [224] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__actual_arguments_repeat1, 2, 0, 97), SHIFT_REPEAT(340),
  [227] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__actual_arguments_repeat1, 2, 0, 97), SHIFT_REPEAT(120),
  [230] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__actual_arguments_repeat1, 2, 0, 97), SHIFT_REPEAT(622),
  [233] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__actual_arguments_repeat1, 2, 0, 97), SHIFT_REPEAT(516),
  [236] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__actual_arguments_repeat1, 2, 0, 97), SHIFT_REPEAT(129),
  [239] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__actual_arguments_repeat1, 2, 0, 97), SHIFT_REPEAT(129),
  [242] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__actual_arguments_repeat1, 2, 0, 97), SHIFT_REPEAT(128),
  [245] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__actual_arguments_repeat1, 2, 0, 97), SHIFT_REPEAT(133),
  [248] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__actual_arguments_repeat1, 2, 0, 97), SHIFT_REPEAT(145),
  [251] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequence_of_values, 4, 0, 94),
  [253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_of_values, 4, 0, 94),
  [255] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequence_of_values, 2, 0, 35),
  [257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_of_values, 2, 0, 35),
  [259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_composition_repeat1, 2, 0, 69),
  [297] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_function_composition_repeat1, 2, 0, 69),
  [299] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_composition_repeat1, 2, 0, 69), SHIFT_REPEAT(572),
  [302] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sequence_of_predicate_values_repeat1, 2, 0, 62), SHIFT_REPEAT(159),
  [305] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_of_predicate_values_repeat1, 2, 0, 62), SHIFT_REPEAT(78),
  [308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_sequence_of_predicate_values_repeat1, 2, 0, 62),
  [310] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_of_predicate_values_repeat1, 2, 0, 62), SHIFT_REPEAT(397),
  [313] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_of_predicate_values_repeat1, 2, 0, 62), SHIFT_REPEAT(120),
  [316] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_of_predicate_values_repeat1, 2, 0, 62), SHIFT_REPEAT(622),
  [319] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_of_predicate_values_repeat1, 2, 0, 62), SHIFT_REPEAT(516),
  [322] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_of_predicate_values_repeat1, 2, 0, 62), SHIFT_REPEAT(129),
  [325] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sequence_of_predicate_values_repeat1, 2, 0, 62), SHIFT_REPEAT(129),
  [328] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_of_predicate_values_repeat1, 2, 0, 62), SHIFT_REPEAT(128),
  [331] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_of_predicate_values_repeat1, 2, 0, 62), SHIFT_REPEAT(133),
  [334] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_of_predicate_values_repeat1, 2, 0, 62), SHIFT_REPEAT(145),
  [337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(159),
  [339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_term, 1, 0, 0),
  [349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_term, 1, 0, 0),
  [351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_composition, 2, 0, 36),
  [355] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_composition, 2, 0, 36),
  [357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_composition_repeat1, 2, 0, 6),
  [371] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_function_composition_repeat1, 2, 0, 6),
  [373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_builder, 5, 0, 113),
  [377] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequence_builder, 5, 0, 113),
  [379] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_of_predicate_values, 3, 0, 61),
  [381] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequence_of_predicate_values, 3, 0, 61),
  [383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_of_predicate_values, 2, 0, 35),
  [385] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequence_of_predicate_values, 2, 0, 35),
  [387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_of_predicate_values, 1, 0, 21),
  [389] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequence_of_predicate_values, 1, 0, 21),
  [391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_of_predicate_values, 4, 0, 94),
  [393] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequence_of_predicate_values, 4, 0, 94),
  [395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_of_predicate_values, 2, 0, 0),
  [397] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequence_of_predicate_values, 2, 0, 0),
  [399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_of_predicate_values, 3, 0, 67),
  [401] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequence_of_predicate_values, 3, 0, 67),
  [403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__actual_arguments, 3, 0, 96),
  [405] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__actual_arguments, 3, 0, 96),
  [407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__actual_arguments, 2, 0, 0),
  [409] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__actual_arguments, 2, 0, 0),
  [411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_predicate_value, 1, 0, 0),
  [413] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_predicate_value, 1, 0, 0),
  [415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_functional_term, 2, 0, 39),
  [417] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_atomic_sentence, 2, 0, 38),
  [419] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_functional_term, 2, 0, 39),
  [421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [429] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sequence_of_values_repeat1, 2, 0, 62), SHIFT_REPEAT(159),
  [432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_sequence_of_values_repeat1, 2, 0, 62),
  [434] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_of_values_repeat1, 2, 0, 62), SHIFT_REPEAT(120),
  [437] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_of_values_repeat1, 2, 0, 62), SHIFT_REPEAT(622),
  [440] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_of_values_repeat1, 2, 0, 62), SHIFT_REPEAT(516),
  [443] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_of_values_repeat1, 2, 0, 62), SHIFT_REPEAT(129),
  [446] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sequence_of_values_repeat1, 2, 0, 62), SHIFT_REPEAT(129),
  [449] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_of_values_repeat1, 2, 0, 62), SHIFT_REPEAT(128),
  [452] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_of_values_repeat1, 2, 0, 62), SHIFT_REPEAT(133),
  [455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [461] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_logical_op_biconditional, 1, 0, 0),
  [463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_logical_op_biconditional, 1, 0, 0),
  [465] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_logical_op_exclusive_disjunction, 1, 0, 0),
  [467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_logical_op_exclusive_disjunction, 1, 0, 0),
  [469] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_logical_op_negation, 1, 0, 0),
  [471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_logical_op_negation, 1, 0, 0),
  [473] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_logical_op_disjunction, 1, 0, 0),
  [475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_logical_op_disjunction, 1, 0, 0),
  [477] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_logical_op_conjunction, 1, 0, 0),
  [479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_logical_op_conjunction, 1, 0, 0),
  [481] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_logical_op_implication, 1, 0, 0),
  [483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_logical_op_implication, 1, 0, 0),
  [485] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_builtin_simple_type, 1, 0, 0),
  [487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_builtin_simple_type, 1, 0, 0),
  [489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [491] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_composition_repeat1, 2, 0, 69), SHIFT_REPEAT(610),
  [494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_body_repeat3, 2, 0, 0),
  [498] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat3, 2, 0, 0), SHIFT_REPEAT(611),
  [501] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat3, 2, 0, 0), SHIFT_REPEAT(609),
  [504] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat3, 2, 0, 0), SHIFT_REPEAT(607),
  [507] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat3, 2, 0, 0), SHIFT_REPEAT(605),
  [510] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat3, 2, 0, 0), SHIFT_REPEAT(604),
  [513] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat3, 2, 0, 0), SHIFT_REPEAT(525),
  [516] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat3, 2, 0, 0), SHIFT_REPEAT(599),
  [519] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat3, 2, 0, 0), SHIFT_REPEAT(598),
  [522] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat3, 2, 0, 0), SHIFT_REPEAT(597),
  [525] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat3, 2, 0, 0), SHIFT_REPEAT(596),
  [528] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_module_body_repeat2, 2, 0, 0),
  [530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_body_repeat2, 2, 0, 0),
  [532] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat2, 2, 0, 0), SHIFT_REPEAT(508),
  [535] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat2, 2, 0, 0), SHIFT_REPEAT(612),
  [538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [540] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mapping_type, 5, 0, 119),
  [542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mapping_type, 5, 0, 119),
  [544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quantified_sentence, 3, 0, 71),
  [546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_boolean_sentence, 2, 0, 40),
  [558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_boolean_sentence, 3, 0, 70),
  [560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_body, 2, 0, 37),
  [562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [564] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__actual_arguments_repeat1, 1, 0, 73),
  [566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__actual_arguments_repeat1, 1, 0, 73),
  [568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [570] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_informal_constraint, 2, 0, 23),
  [572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_informal_constraint, 2, 0, 23),
  [574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [576] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_import, 1, 0, 4),
  [578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(576),
  [580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inequation, 3, 0, 74),
  [584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [586] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_informal_constraint, 3, 0, 42),
  [588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_informal_constraint, 3, 0, 42),
  [590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_datatype_def_restriction_repeat1, 2, 0, 0),
  [594] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_datatype_def_restriction_repeat1, 2, 0, 0), SHIFT_REPEAT(560),
  [597] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_datatype_def_restriction_repeat1, 2, 0, 0), SHIFT_REPEAT(559),
  [600] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_datatype_def_restriction_repeat1, 2, 0, 0), SHIFT_REPEAT(558),
  [603] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_datatype_def_restriction_repeat1, 2, 0, 0), SHIFT_REPEAT(563),
  [606] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_datatype_def_restriction_repeat1, 2, 0, 0), SHIFT_REPEAT(564),
  [609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [611] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_property, 4, 0, 22),
  [613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_property, 4, 0, 22),
  [615] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_formal_constraint, 3, 0, 37),
  [617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_constraint, 3, 0, 37),
  [619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [631] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation, 1, 0, 0),
  [633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation, 1, 0, 0),
  [635] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_formal_constraint, 4, 0, 76),
  [637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_constraint, 4, 0, 76),
  [639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_equation, 3, 0, 72),
  [641] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constraint, 3, 0, 1),
  [643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 3, 0, 1),
  [645] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_reference, 1, 0, 0),
  [647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_reference, 1, 0, 0),
  [649] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_sequence_of_predicate_values_repeat1, 1, 0, 32),
  [651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_sequence_of_predicate_values_repeat1, 1, 0, 32),
  [653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_body_repeat1, 2, 0, 0),
  [655] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat1, 2, 0, 0), SHIFT_REPEAT(398),
  [658] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat1, 2, 0, 0), SHIFT_REPEAT(446),
  [661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_import, 1, 0, 4),
  [663] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_def, 2, 0, 13),
  [665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_def, 2, 0, 13),
  [669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint_sentence, 1, 0, 0),
  [671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(64),
  [677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [681] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_sequence_of_values_repeat1, 1, 0, 32),
  [683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_sequence_of_values_repeat1, 1, 0, 32),
  [685] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set_op_membership, 1, 0, 0),
  [687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set_op_membership, 1, 0, 0),
  [689] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_import, 2, 0, 9),
  [691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_import, 2, 0, 9),
  [693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_import, 2, 0, 10),
  [695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean_sentence, 1, 0, 0),
  [697] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_import, 2, 0, 9),
  [699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_import, 2, 0, 9),
  [701] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__rename_import, 2, 0, 16),
  [703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__rename_import, 2, 0, 16),
  [705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint_sentence, 3, 0, 0),
  [707] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_import, 3, 0, 18),
  [709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_import, 3, 0, 18),
  [711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_sentence, 1, 0, 0),
  [713] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_op_greater_than_or_equal, 1, 0, 0),
  [715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_op_greater_than_or_equal, 1, 0, 0),
  [717] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_op_less_than_or_equal, 1, 0, 0),
  [719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_op_less_than_or_equal, 1, 0, 0),
  [721] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_op_inequality, 1, 0, 0),
  [723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_op_inequality, 1, 0, 0),
  [725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rdf_def, 2, 0, 6),
  [727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [729] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_expression_to, 2, 0, 26),
  [731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_expression_to, 2, 0, 26),
  [733] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_only_body, 3, 0, 0),
  [735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_only_body, 3, 0, 0),
  [737] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_expression_to, 3, 0, 52),
  [739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_expression_to, 3, 0, 52),
  [741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 3, 0, 0),
  [743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 5, 0, 0),
  [745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 4, 0, 0),
  [747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(455),
  [749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_type_def, 5, 0, 44),
  [757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [761] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_def, 3, 0, 25),
  [763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_def, 3, 0, 25),
  [765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_type_def, 4, 0, 24),
  [767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 2, 0, 0),
  [769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_class_def, 2, 0, 6),
  [773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(440),
  [777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_def, 2, 0, 6),
  [787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_type_def, 6, 0, 77),
  [791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_structure_def, 2, 0, 6),
  [795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_class_def, 5, 0, 59),
  [797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_def, 2, 0, 6),
  [801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_def, 2, 0, 6),
  [803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimension_def, 2, 0, 6),
  [809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_type_def, 5, 0, 45),
  [811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rdf_def, 3, 0, 14),
  [815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_entity_def, 2, 0, 6),
  [819] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_restriction_facet, 3, 0, 115),
  [821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tz_restriction_value, 1, 0, 0),
  [823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tz_restriction_facet, 3, 0, 116),
  [825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rdf_types, 3, 0, 0),
  [827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_restriction_facet, 3, 0, 116),
  [829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_restriction_facet, 5, 0, 129),
  [835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_digit_restriction_facet, 4, 0, 122),
  [837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(467),
  [839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [841] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rdf_types, 4, 0, 86),
  [843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_restriction_value, 1, 0, 0),
  [845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_digit_restriction_facet, 3, 0, 115),
  [847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_length_restriction_facet, 4, 0, 122),
  [851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_restriction_facet, 4, 0, 122),
  [853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tz_restriction_facet, 4, 0, 123),
  [857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_length_restriction_facet, 3, 0, 115),
  [859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_datatype_def_restriction, 3, 0, 0),
  [863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rdf_types, 2, 0, 27),
  [867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimension_body, 5, 0, 103),
  [869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimension_body, 5, 0, 104),
  [871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_body, 2, 0, 0),
  [873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_class_body, 2, 0, 0),
  [875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_type_def, 6, 0, 78),
  [877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_definition, 1, 0, 0),
  [879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_def, 2, 0, 7),
  [881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimension_body, 4, 0, 48),
  [883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimension_def, 3, 0, 1),
  [885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimension_body, 7, 0, 118),
  [887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_type_def, 5, 0, 46),
  [889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_entity_def, 3, 0, 1),
  [891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_def, 3, 0, 1),
  [893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimension_body, 3, 0, 48),
  [895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_def, 3, 0, 1),
  [897] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_structure_def, 3, 0, 1),
  [899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_def, 3, 0, 1),
  [901] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_body, 6, 0, 104),
  [903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_entity_body, 6, 0, 104),
  [905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_entity_body, 3, 0, 48),
  [907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimension_body, 6, 0, 81),
  [909] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimension_body, 6, 0, 118),
  [911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimension_body, 4, 0, 80),
  [913] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimension_body, 6, 0, 104),
  [915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimension_body, 6, 0, 103),
  [917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 3, 0, 50),
  [919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rdf_def, 3, 0, 1),
  [921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 3, 0, 0),
  [923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_class_def, 3, 0, 1),
  [925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_class_body, 5, 0, 111),
  [927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_body, 5, 0, 82),
  [929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_body, 3, 0, 48),
  [931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_structure_body, 5, 0, 82),
  [933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_body, 5, 0, 81),
  [935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_type_def, 6, 0, 79),
  [937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_body, 5, 0, 104),
  [939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_body, 5, 0, 80),
  [941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 5, 0, 82),
  [943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_entity_body, 5, 0, 81),
  [945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_entity_body, 5, 0, 104),
  [947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_entity_body, 5, 0, 80),
  [949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimension_body, 5, 0, 81),
  [951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_structure_body, 3, 0, 50),
  [953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_structure_body, 2, 0, 0),
  [955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_structure_body, 3, 0, 0),
  [957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimension_body, 5, 0, 48),
  [959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimension_body, 5, 0, 80),
  [961] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_type_def, 7, 0, 100),
  [963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_class_def, 6, 0, 91),
  [965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rdf_def, 4, 0, 28),
  [967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_body, 3, 0, 50),
  [969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimension_body, 4, 0, 81),
  [971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_body, 3, 0, 0),
  [973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_class_body, 4, 0, 89),
  [975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_class_body, 4, 0, 82),
  [977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_class_body, 4, 0, 88),
  [979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_body, 4, 0, 0),
  [981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_body, 4, 0, 82),
  [983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_body, 4, 0, 50),
  [985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_structure_body, 4, 0, 0),
  [987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_structure_body, 4, 0, 82),
  [989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_structure_body, 4, 0, 50),
  [991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_class_body, 3, 0, 50),
  [993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 2, 0, 0),
  [995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_class_body, 3, 0, 0),
  [997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_body, 4, 0, 81),
  [999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_body, 4, 0, 48),
  [1001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_class_body, 3, 0, 55),
  [1003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_body, 4, 0, 80),
  [1005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4, 0, 0),
  [1007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4, 0, 82),
  [1009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4, 0, 50),
  [1011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_entity_body, 4, 0, 81),
  [1013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_entity_body, 4, 0, 48),
  [1015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_entity_body, 4, 0, 80),
  [1017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [1019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [1021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [1023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [1025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [1027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [1029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [1031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [1033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [1035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(364),
  [1037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [1039] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_def, 1, 0, 29),
  [1041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [1043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [1045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [1047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [1049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [1051] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type_reference, 1, 0, 0),
  [1053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type_reference, 1, 0, 0),
  [1055] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_dimension_body_repeat2, 2, 0, 0), SHIFT_REPEAT(455),
  [1058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dimension_body_repeat2, 2, 0, 0),
  [1060] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dimension_body_repeat2, 2, 0, 0), SHIFT_REPEAT(491),
  [1063] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_type, 2, 0, 26),
  [1065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_type, 2, 0, 26),
  [1067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [1069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [1071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [1073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [1075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [1077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_variable, 1, 0, 4),
  [1079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [1081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [1083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [1085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [1087] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_import, 1, 0, 4),
  [1089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [1091] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable, 1, 0, 4),
  [1093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable, 1, 0, 4),
  [1095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [1097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [1099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [1101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [1103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_variable_restriction, 2, 0, 0),
  [1105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [1107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_class_reference, 1, 0, 4),
  [1109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [1111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [1113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [1115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [1117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [1119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [1121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [1123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_variable_restriction, 3, 0, 0),
  [1125] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_import_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(363),
  [1128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_import_statement_repeat1, 2, 0, 0),
  [1130] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_type, 3, 0, 52),
  [1132] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_type, 3, 0, 52),
  [1134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [1136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [1138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [1140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_variable_restriction_repeat1, 2, 0, 0),
  [1142] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_variable_restriction_repeat1, 2, 0, 0), SHIFT_REPEAT(606),
  [1145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [1147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [1149] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_dimension_body_repeat1, 2, 0, 0),
  [1151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dimension_body_repeat1, 2, 0, 0),
  [1153] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dimension_body_repeat1, 2, 0, 0), SHIFT_REPEAT(566),
  [1156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [1158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [1160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [1162] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dimension_parent, 4, 0, 117),
  [1164] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimension_parent, 4, 0, 117),
  [1166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_variable, 2, 0, 58),
  [1168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [1170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [1172] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_class_def_repeat1, 2, 0, 60), SHIFT_REPEAT(359),
  [1175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_class_def_repeat1, 2, 0, 60),
  [1177] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_class_def_repeat1, 2, 0, 60), SHIFT_REPEAT(334),
  [1180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [1182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [1184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [1186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [1188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [1190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [1192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [1194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [1196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [1198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [1200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [1202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [1204] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_class_arguments_repeat1, 2, 0, 60), SHIFT_REPEAT(45),
  [1207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_class_arguments_repeat1, 2, 0, 60),
  [1209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [1211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [1213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [1215] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_union_body_repeat1, 2, 0, 0), SHIFT_REPEAT(440),
  [1218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_union_body_repeat1, 2, 0, 0),
  [1220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [1222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [1224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_source_entity, 2, 0, 47),
  [1226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_entity, 2, 0, 47),
  [1228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [1230] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_entity_identity, 2, 0, 48),
  [1232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_entity_identity, 2, 0, 48),
  [1234] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__identifier_or_sequence, 3, 0, 124),
  [1236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__identifier_or_sequence, 3, 0, 124),
  [1238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [1240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [1242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 3, 0, 75),
  [1244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_class_arguments, 3, 0, 127),
  [1246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [1248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_constraint_environment_repeat1, 2, 0, 0),
  [1250] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_environment_repeat1, 2, 0, 0), SHIFT_REPEAT(627),
  [1253] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_source_entity, 4, 0, 102),
  [1255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_entity, 4, 0, 102),
  [1257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_class_arguments, 3, 0, 128),
  [1259] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rdf_types_repeat1, 2, 0, 87), SHIFT_REPEAT(45),
  [1262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_rdf_types_repeat1, 2, 0, 87),
  [1264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member, 1, 0, 0),
  [1266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member, 1, 0, 0),
  [1268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_class_reference, 2, 0, 112),
  [1270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [1272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dimension_parent, 5, 0, 126),
  [1274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimension_parent, 5, 0, 126),
  [1276] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_variant, 1, 0, 4),
  [1278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_variant, 1, 0, 4),
  [1280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [1282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [1284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [1286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [1288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_ref, 2, 0, 53),
  [1290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_ref, 2, 0, 53),
  [1292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 6, 0, 121),
  [1294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [1296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [1298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [1300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint_environment, 2, 0, 0),
  [1302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_class_body_repeat1, 2, 0, 56),
  [1304] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_class_body_repeat1, 2, 0, 56), SHIFT_REPEAT(627),
  [1307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [1309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [1311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [1313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [1315] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__identifier_or_sequence, 1, 0, 101),
  [1317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__identifier_or_sequence, 1, 0, 101),
  [1319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [1321] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__wildcard_or_identifier_or_sequence, 1, 0, 105),
  [1323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__wildcard_or_identifier_or_sequence, 1, 0, 105),
  [1325] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__wildcard_or_identifier_or_sequence, 1, 0, 101),
  [1327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__wildcard_or_identifier_or_sequence, 1, 0, 101),
  [1329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [1331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [1333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [1335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [1337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [1339] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_import, 2, 0, 10),
  [1341] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_import, 1, 0, 4),
  [1343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [1345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [1347] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_builder_repeat1, 2, 0, 60), SHIFT_REPEAT(364),
  [1350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_sequence_builder_repeat1, 2, 0, 60),
  [1352] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__wildcard_or_identifier_or_sequence, 3, 0, 124),
  [1354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__wildcard_or_identifier_or_sequence, 3, 0, 124),
  [1356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [1358] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_repeat1, 2, 0, 0), SHIFT_REPEAT(467),
  [1361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, 0, 0),
  [1363] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_value_variant, 1, 0, 4),
  [1365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_variant, 1, 0, 4),
  [1367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [1369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [1371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [1373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_ordering, 1, 0, 0),
  [1375] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_from_definition_clause, 4, 0, 106),
  [1377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_from_definition_clause, 4, 0, 106),
  [1379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [1381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_def, 2, 0, 43),
  [1383] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_variant, 3, 0, 85),
  [1385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_variant, 3, 0, 85),
  [1387] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable, 3, 0, 95),
  [1389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable, 3, 0, 95),
  [1391] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_signature_repeat1, 2, 0, 114), SHIFT_REPEAT(459),
  [1394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_signature_repeat1, 2, 0, 114),
  [1396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [1398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [1400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [1402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [1404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [1406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [1408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [1410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_path_absolute_repeat1, 2, 0, 20),
  [1412] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_path_absolute_repeat1, 2, 0, 20), SHIFT_REPEAT(573),
  [1415] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__identifier_or_sequence_repeat1, 2, 0, 125), SHIFT_REPEAT(532),
  [1418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__identifier_or_sequence_repeat1, 2, 0, 125),
  [1420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [1422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [1424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pattern_restriction_facet_repeat1, 2, 0, 0),
  [1426] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pattern_restriction_facet_repeat1, 2, 0, 0), SHIFT_REPEAT(492),
  [1429] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_variable, 3, 0, 90),
  [1431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [1433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [1435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [1437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [1439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [1441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [1443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quantified_variable, 3, 0, 98),
  [1445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_path_relative, 2, 0, 12),
  [1447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [1449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cardinality_inner, 1, 0, 51),
  [1451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [1453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_path_absolute, 2, 0, 11),
  [1455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [1457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [1459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [1461] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_class_def_repeat1, 1, 0, 31),
  [1463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [1465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [1467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_variable, 2, 0, 57),
  [1469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [1471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [1473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_path_relative, 1, 0, 5),
  [1475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [1477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_binary_repeat1, 2, 0, 66),
  [1479] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_binary_repeat1, 2, 0, 66), SHIFT_REPEAT(539),
  [1482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [1484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_path_absolute, 3, 0, 19),
  [1486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_def, 3, 0, 43),
  [1488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_path_absolute_repeat1, 2, 0, 11),
  [1490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(503),
  [1492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_path_root_only, 1, 0, 0),
  [1494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [1496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [1498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [1500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cardinality_range, 1, 0, 0),
  [1502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [1504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [1506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [1508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_def, 2, 0, 29),
  [1510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [1512] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_variant, 4, 0, 110),
  [1514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_variant, 4, 0, 110),
  [1516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__identifier_or_sequence_repeat1, 1, 0, 101),
  [1518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_rdf_types_repeat1, 1, 0, 54),
  [1520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_value_variant, 2, 0, 49),
  [1522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_variant, 2, 0, 49),
  [1524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_uniqueness, 1, 0, 0),
  [1526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__sequence_value_constraints, 3, 0, 64),
  [1528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_class_body_repeat1, 1, 0, 30),
  [1530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_binary_repeat1, 1, 0, 34),
  [1532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [1534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module_locations, 1, 0, 2),
  [1536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_signature_repeat1, 1, 0, 99),
  [1538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_class_arguments_repeat1, 1, 0, 31),
  [1540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_sequence_builder_repeat1, 1, 0, 31),
  [1542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [1544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [1546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__sequence_value_constraints, 3, 0, 63),
  [1548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_parameter, 2, 0, 13),
  [1550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_def, 2, 0, 43),
  [1552] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_variant, 2, 0, 49),
  [1554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_variant, 2, 0, 49),
  [1556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__sequence_value_constraints, 4, 0, 92),
  [1558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [1560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [1562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [1564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [1566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [1568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [1570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [1572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [1574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [1576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [1578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [1580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [1582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [1584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [1586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [1588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [1590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_logical_quantifier_existential, 1, 0, 0),
  [1592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [1594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_logical_quantifier_universal, 1, 0, 0),
  [1596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [1598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [1600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [1602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [1604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [1606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [1608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [1610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_builder_body, 1, 0, 0),
  [1612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module_locations, 3, 0, 8),
  [1614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [1616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_body, 3, 0, 0),
  [1618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [1620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [1622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [1624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [1626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [1628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_from_clause, 2, 0, 0),
  [1630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_body, 4, 0, 0),
  [1632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [1634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module_locations, 4, 0, 15),
  [1636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cardinality_inner, 2, 0, 83),
  [1638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 4, 0, 3),
  [1640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [1642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quantified_variable_binding, 2, 0, 41),
  [1644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [1646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [1648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [1650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [1652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [1654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [1656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [1658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [1660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [1662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [1664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [1666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_op_combiner, 1, 0, 0),
  [1668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [1670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [1672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [1674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [1676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [1678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [1680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_body, 5, 0, 0),
  [1682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [1684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cardinality_range, 2, 0, 107),
  [1686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_body, 2, 0, 0),
  [1688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [1690] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 3, 0, 1),
  [1692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [1694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(593),
  [1696] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [1698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [1700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(600),
  [1702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [1704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [1706] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [1708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [1710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [1712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_sdml(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
